/* tslint:disable */
/* eslint-disable */
/**
* @returns {string}
*/
export function get_counters(): string;
/**
* @param {Level} _level
*/
export function init_logger(_level: Level): void;
/**
* @param {Function} f
*/
export function set_destroy_callback(f: Function): void;
/**
* 设置日志过滤器
* 如果过滤器格式错误， 日志过滤器未初始化， 则设置将失败， 但不会panic
* @param {Engine} engine
* @param {string} filter
*/
export function set_log_filter(engine: Engine, filter: string): void;
/**
* @param {Engine} app
* @param {boolean} value
*/
export function set_is_not_run(app: Engine, value: boolean): void;
/**
* width、height为physical_size
* @param {HTMLCanvasElement} canvas
* @param {number} width
* @param {number} height
* @param {ResAllocator} asset_mgr
* @param {number} asset_total_capacity
* @param {string} asset_config
* @param {string | undefined} log_filter
* @param {number} log_level
* @param {number} collect_interval
* @returns {Engine}
*/
export function create_engine(canvas: HTMLCanvasElement, width: number, height: number, asset_mgr: ResAllocator, asset_total_capacity: number, asset_config: string, log_filter: string | undefined, log_level: number, collect_interval: number): Engine;
/**
* @param {Engine} engine
* @returns {string}
*/
export function dump_graphviz(engine: Engine): string;
/**
* @param {Engine} engine
* @param {boolean} reset_state
*/
export function fram_call(engine: Engine, reset_state: boolean): void;
/**
* @param {number} entity
* @returns {string}
*/
export function entity_to_asimage_url(entity: number): string;
/**
* @param {number} index
* @param {number} version
* @returns {number}
*/
export function entity_from_number(index: number, version: number): number;
/**
* @param {Engine} app
* @param {boolean} spine
* @param {Uint32Array} param
*/
export function init_engine_3d(app: Engine, spine: boolean, param: Uint32Array): void;
/**
* @param {TextureDefaultView} item
* @returns {number}
*/
export function p3d_texture_default_view_width(item: TextureDefaultView): number;
/**
* @param {TextureDefaultView} item
* @returns {number}
*/
export function p3d_texture_default_view_height(item: TextureDefaultView): number;
/**
* @param {Engine} app
* @param {bigint} key
* @returns {TextureDefaultView | undefined}
*/
export function query_texture_default_view(app: Engine, key: bigint): TextureDefaultView | undefined;
/**
* @param {Engine} app
* @param {Uint32Array} data
*/
export function p3d_device_limis(app: Engine, data: Uint32Array): void;
/**
* @param {Engine} app
*/
export function p3d_init_engine(app: Engine): void;
/**
* @param {Engine} app
* @returns {number}
*/
export function p3d_entity(app: Engine): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} entity
*/
export function p3d_dispose(cmds: CommandsExchangeD3, entity: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
*/
export function p3d_scene_dispose(cmds: CommandsExchangeD3, scene: number): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} scene_max_direct_light_count
* @param {number} scene_max_point_light_count
* @param {number} scene_max_spot_light_count
* @param {number} scene_max_hemi_light_count
* @param {number} scene_max_shadow_count
* @param {number} model_max_direct_light_count
* @param {number} model_max_point_light_count
* @param {number} model_max_spot_light_count
* @param {number} model_max_hemi_light_count
*/
export function p3d_lighting_shadow_limit(app: Engine, param: ActionSetScene3D, scene_max_direct_light_count: number, scene_max_point_light_count: number, scene_max_spot_light_count: number, scene_max_hemi_light_count: number, scene_max_shadow_count: number, model_max_direct_light_count: number, model_max_point_light_count: number, model_max_spot_light_count: number, model_max_hemi_light_count: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} before
* @param {number} after
* @param {boolean} isdisconnect
*/
export function p3d_render_graphic(cmds: CommandsExchangeD3, before: number, after: number, isdisconnect: boolean): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} matrix
* @returns {boolean}
*/
export function p3d_query_world_matrix(app: Engine, param: ActionSetScene3D, entity: number, matrix: Float32Array): boolean;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} result
* @returns {boolean}
*/
export function p3d_query_scene_state(app: Engine, param: ActionSetScene3D, entity: number, result: Float32Array): boolean;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {boolean} active
*/
export function p3d_engine_state(app: Engine, param: ActionSetScene3D, active: boolean): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {boolean} debug
*/
export function p3d_engine_debug(app: Engine, param: ActionSetScene3D, debug: boolean): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float32Array} result
*/
export function p3d_query_performance_state(app: Engine, param: ActionSetScene3D, result: Float32Array): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {CommandsExchangeD3} commands
* @param {Float32Array} result
*/
export function p3d_query_resource_state(app: Engine, param: ActionSetScene3D, commands: CommandsExchangeD3, result: Float32Array): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float64Array} result
* @returns {number}
*/
export function p3d_query_resource_memory(app: Engine, param: ActionSetScene3D, result: Float64Array): number;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float32Array} result
*/
export function p3d_material_state(app: Engine, param: ActionSetScene3D, result: Float32Array): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number | undefined} scene
* @param {Float32Array} result
*/
export function p3d_mesh_state(app: Engine, param: ActionSetScene3D, scene: number | undefined, result: Float32Array): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number | undefined} scene
* @param {Float32Array} result
*/
export function p3d_transform_state(app: Engine, param: ActionSetScene3D, scene: number | undefined, result: Float32Array): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number | undefined} transform
* @param {Float32Array} result
* @returns {boolean}
*/
export function p3d_query_transform_state(app: Engine, param: ActionSetScene3D, transform: number | undefined, result: Float32Array): boolean;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number | undefined} camera
* @param {Float32Array} result
*/
export function p3d_camera_state(app: Engine, param: ActionSetScene3D, camera: number | undefined, result: Float32Array): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float32Array} result
*/
export function p3d_texture_loader_state(app: Engine, param: ActionSetScene3D, result: Float32Array): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Uint32Array} info
* @param {boolean} flag
* @returns {number}
*/
export function p3d_errors(app: Engine, param: ActionSetScene3D, info: Uint32Array, flag: boolean): number;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {boolean} val
*/
export function p3d_global_state(app: Engine, param: ActionSetScene3D, val: boolean): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} matrix
* @returns {boolean}
*/
export function p3d_query_local_matrix(app: Engine, param: ActionSetScene3D, entity: number, matrix: Float32Array): boolean;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} matrix
* @returns {boolean}
*/
export function p3d_query_view_matrix(app: Engine, param: ActionSetScene3D, entity: number, matrix: Float32Array): boolean;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} matrix
* @returns {boolean}
*/
export function p3d_query_project_matrix(app: Engine, param: ActionSetScene3D, entity: number, matrix: Float32Array): boolean;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} matrix
* @returns {boolean}
*/
export function p3d_query_viewproject_matrix(app: Engine, param: ActionSetScene3D, entity: number, matrix: Float32Array): boolean;
/**
* @param {GLTFRes} item
* @returns {string}
*/
export function p3d_gltf_val(item: GLTFRes): string;
/**
* 创建动画组
* @param {GLTFRes} gltf
* @param {number} group_index
* @param {number} channel_index
* @returns {number}
*/
export function p3d_animation_curve_id_bygltf(gltf: GLTFRes, group_index: number, channel_index: number): number;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Atom} baseurl
* @param {string} dyndesc
*/
export function p3d_create_gltf_load(app: Engine, param: ActionSetScene3D, entity: number, baseurl: Atom, dyndesc: string): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float64Array} success
* @param {Float64Array} failed
*/
export function p3d_query_gltf_load(app: Engine, param: ActionSetScene3D, success: Float64Array, failed: Float64Array): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @returns {GLTFRes | undefined}
*/
export function p3d_get_gltf(app: Engine, param: ActionSetScene3D, entity: number): GLTFRes | undefined;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @returns {string | undefined}
*/
export function p3d_get_gltf_fail_reason(app: Engine, param: ActionSetScene3D, entity: number): string | undefined;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Atom} url
* @param {boolean} cancombine
* @param {boolean} compressed
* @param {number} depth_or_array_layers
* @returns {number}
*/
export function p3d_create_image_load(app: Engine, param: ActionSetScene3D, url: Atom, cancombine: boolean, compressed: boolean, depth_or_array_layers: number): number;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float64Array} success
* @param {Float64Array} failed
*/
export function p3d_query_image_load(app: Engine, param: ActionSetScene3D, success: Float64Array, failed: Float64Array): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} id
* @returns {ImageRes | undefined}
*/
export function p3d_get_image(app: Engine, param: ActionSetScene3D, id: number): ImageRes | undefined;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} id
* @returns {string | undefined}
*/
export function p3d_get_image_fail_reason(app: Engine, param: ActionSetScene3D, id: number): string | undefined;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} id
* @param {Float64Array} info
* @returns {number}
*/
export function p3d_query_children(app: Engine, param: ActionSetScene3D, id: number, info: Float64Array): number;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} id
* @param {Uint32Array} info
* @returns {boolean}
*/
export function p3d_query_mesh_info(app: Engine, param: ActionSetScene3D, id: number, info: Uint32Array): boolean;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} id
* @param {Uint32Array} info
* @returns {boolean}
*/
export function p3d_query_material_info(app: Engine, param: ActionSetScene3D, id: number, info: Uint32Array): boolean;
/**
* 正向渲染
* Pass 配置使用默认值
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} cullingmode
* @param {number} collidermode
* @param {Int32Array} vals
* @returns {number}
*/
export function p3d_scene(app: Engine, cmds: CommandsExchangeD3, cullingmode: number, collidermode: number, vals: Int32Array): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {boolean} val
*/
export function p3d_scene_animation_enable(cmds: CommandsExchangeD3, scene: number, val: boolean): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} val
*/
export function p3d_scene_time(cmds: CommandsExchangeD3, scene: number, val: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} r
* @param {number} g
* @param {number} b
*/
export function p3d_scene_fogcolor(cmds: CommandsExchangeD3, scene: number, r: number, g: number, b: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} mode
* @param {number} param0
* @param {number} param1
* @param {number} param2
*/
export function p3d_scene_fogparam(cmds: CommandsExchangeD3, scene: number, mode: number, param0: number, param1: number, param2: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} r
* @param {number} g
* @param {number} b
*/
export function p3d_scene_ambientcolor(cmds: CommandsExchangeD3, scene: number, r: number, g: number, b: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} val
*/
export function p3d_scene_ambientintensity(cmds: CommandsExchangeD3, scene: number, val: number): void;
/**
*
* 相机渲染像素宽高
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} val
*/
export function p3d_layermask(cmds: CommandsExchangeD3, node: number, val: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {Atom} url
* @param {boolean} compressed
*/
export function p3d_scene_brdf_texture(cmds: CommandsExchangeD3, scene: number, url: Atom, compressed: boolean): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {Atom} url
* @param {boolean} data_is_image
*/
export function p3d_scene_env_texture(cmds: CommandsExchangeD3, scene: number, url: Atom, data_is_image: boolean): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number | undefined} [url]
*/
export function p3d_scene_shadowmap(cmds: CommandsExchangeD3, scene: number, url?: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {boolean} display
* @param {number} pass
*/
export function p3d_scene_boundingbox(cmds: CommandsExchangeD3, scene: number, display: boolean, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} minx
* @param {number} miny
* @param {number} minz
* @param {number} maxx
* @param {number} maxy
* @param {number} maxz
* @param {number} intersection_treshold
*/
export function p3d_collider(cmds: CommandsExchangeD3, node: number, minx: number, miny: number, minz: number, maxx: number, maxy: number, maxz: number, intersection_treshold: number): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} camera
* @param {number} projectx
* @param {number} projecty
* @param {Float32Array} result
* @returns {boolean}
*/
export function p3d_create_pickingray(app: Engine, param: ActionSetScene3D, camera: number, projectx: number, projecty: number, result: Float32Array): boolean;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} scene
* @param {number} viewer
* @param {number} projectx
* @param {number} projecty
* @param {boolean} not_ray_bounding
* @param {Float64Array} result
* @returns {boolean}
*/
export function p3d_scene_pick(app: Engine, param: ActionSetScene3D, scene: number, viewer: number, projectx: number, projecty: number, not_ray_bounding: boolean, result: Float64Array): boolean;
/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @returns {number}
*/
export function p3d_transform_node(app: Engine, cmds: CommandsExchangeD3, scene: number): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} parent
*/
export function p3d_transform_node_parent(cmds: CommandsExchangeD3, node: number, parent: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_transform_node_parent_arr(cmds: CommandsExchangeD3, data: Float64Array, len: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {boolean} val
*/
export function p3d_node_enable(cmds: CommandsExchangeD3, node: number, val: boolean): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_node_enable_arr(cmds: CommandsExchangeD3, data: Float64Array, len: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_local_position(cmds: CommandsExchangeD3, node: number, x: number, y: number, z: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_local_position_arr(cmds: CommandsExchangeD3, data: Float64Array, len: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_local_scaling(cmds: CommandsExchangeD3, node: number, x: number, y: number, z: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_local_scaling_arr(cmds: CommandsExchangeD3, data: Float64Array, len: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_local_euler(cmds: CommandsExchangeD3, node: number, x: number, y: number, z: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_local_euler_arr(cmds: CommandsExchangeD3, data: Float64Array, len: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
*/
export function p3d_local_quaternion(cmds: CommandsExchangeD3, node: number, x: number, y: number, z: number, w: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_local_quaternion_arr(cmds: CommandsExchangeD3, data: Float64Array, len: number): void;
/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @returns {number}
*/
export function p3d_camera(app: Engine, cmds: CommandsExchangeD3, scene: number): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {number} size
*/
export function p3d_camera_size(cmds: CommandsExchangeD3, camera: number, size: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {number} fov
*/
export function p3d_camera_fov(cmds: CommandsExchangeD3, camera: number, fov: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {boolean} active
*/
export function p3d_camera_active(cmds: CommandsExchangeD3, camera: number, active: boolean): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {boolean} as_orthographic
*/
export function p3d_camera_mode(cmds: CommandsExchangeD3, camera: number, as_orthographic: boolean): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {boolean} as_horizontal
*/
export function p3d_camera_fixed_mode(cmds: CommandsExchangeD3, camera: number, as_horizontal: boolean): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_camera_target(cmds: CommandsExchangeD3, camera: number, x: number, y: number, z: number): void;
/**
*
* 相机渲染像素宽高
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {number} near
* @param {number} far
*/
export function p3d_camera_nearfar(cmds: CommandsExchangeD3, camera: number, near: number, far: number): void;
/**
*
* 相机宽高比
* * @tip 传入null值对应 自适应宽高比
* * @tip 传入正小数 表示自定义宽高比
* * @example 16/9 16/10 null
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {number | undefined} [val]
*/
export function p3d_camera_aspect(cmds: CommandsExchangeD3, camera: number, val?: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} viewer
* @param {number} entity
* @param {boolean} add
*/
export function p3d_viewer_force_include(cmds: CommandsExchangeD3, viewer: number, entity: number, add: boolean): void;
/**
* * pass_tag:
*     * 0b0000_0000_0000_0001
*     * 0b0000_0000_0000_0010
*     * 0b0000_0000_0000_0100
*     * 0b0000_0000_0000_1000
*     * 0b0000_0000_0001_0000
*     * 0b0000_0000_0010_0000
*     * 0b0000_0000_0100_0000
*     * 0b0000_0000_1000_0000
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} viewer
* @param {string} name
* @param {number} pass_tag
* @param {boolean} transparent
* @returns {number}
*/
export function p3d_create_render(app: Engine, cmds: CommandsExchangeD3, viewer: number, name: string, pass_tag: number, transparent: boolean): number;
/**
* 
* Renderer Modify
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number | undefined} [keytarget]
*/
export function p3d_render_target_key(cmds: CommandsExchangeD3, renderer: number, keytarget?: number): void;
/**
* 
* Renderer Modify
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number} width
* @param {number} height
* @param {number} colorformat
* @param {number} depthstencilformat
*/
export function p3d_render_target_auto(cmds: CommandsExchangeD3, renderer: number, width: number, height: number, colorformat: number, depthstencilformat: number): void;
/**
* 
* Renderer Modify
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {boolean} val
*/
export function p3d_render_auto_clear_color(cmds: CommandsExchangeD3, renderer: number, val: boolean): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {boolean} val
*/
export function p3d_render_auto_clear_depth(cmds: CommandsExchangeD3, renderer: number, val: boolean): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {boolean} val
*/
export function p3d_render_auto_clear_stencil(cmds: CommandsExchangeD3, renderer: number, val: boolean): void;
/**
* r g b a 数值为 0 ~ 255 u8
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function p3d_render_clear_color(cmds: CommandsExchangeD3, renderer: number, r: number, g: number, b: number, a: number): void;
/**
* val 数值为 0.~1.
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number} val
*/
export function p3d_render_clear_depth(cmds: CommandsExchangeD3, renderer: number, val: number): void;
/**
*
* val 数值为 u32
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number} val
*/
export function p3d_render_clear_stencil(cmds: CommandsExchangeD3, renderer: number, val: number): void;
/**
*
* val 数值为 u32
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number} x
* @param {number} y
* @param {number} w
* @param {number} h
*/
export function p3d_render_viewport(cmds: CommandsExchangeD3, renderer: number, x: number, y: number, w: number, h: number): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} color_format
* @param {number} depth_stencil_format
* @param {number} width
* @param {number} height
* @param {number} filter
* @param {number} address
* @param {number} anisotropy_clamp
* @returns {number | undefined}
*/
export function p3d_create_render_target(app: Engine, param: ActionSetScene3D, color_format: number, depth_stencil_format: number, width: number, height: number, filter: number, address: number, anisotropy_clamp: number): number | undefined;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} key
*/
export function p3d_dispose_render_target(app: Engine, param: ActionSetScene3D, key: number): void;
/**
* @param {VInstanceAttributes} item
* @param {Atom} key
* @param {Atom} code
* @param {Atom} foruniform
* @param {number} vtype
*/
export function p3d_instance_attribute(item: VInstanceAttributes, key: Atom, code: Atom, foruniform: Atom, vtype: number): void;
/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {VInstanceAttributes} instancestate
* @param {boolean} instance_use_single_buffer
* @returns {number}
*/
export function p3d_mesh(app: Engine, cmds: CommandsExchangeD3, scene: number, instancestate: VInstanceAttributes, instance_use_single_buffer: boolean): number;
/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {GeometryMeta} geometa
* @returns {number}
*/
export function p3d_mesh_geometry(app: Engine, cmds: CommandsExchangeD3, mesh: number, geometa: GeometryMeta): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number | undefined} [index_start]
* @param {number | undefined} [index_end]
*/
export function p3d_mesh_indexrange(cmds: CommandsExchangeD3, mesh: number, index_start?: number, index_end?: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number | undefined} [vertex_start]
* @param {number | undefined} [vertex_count]
*/
export function p3d_mesh_vertexrange(cmds: CommandsExchangeD3, mesh: number, vertex_start?: number, vertex_count?: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {boolean} enable
* @param {number} src_color
* @param {number} dst_color
* @param {number} src_alpha
* @param {number} dst_alpha
* @param {number} opt_color
* @param {number} opt_alpha
* @param {number | undefined} [pass]
*/
export function p3d_mesh_blend(cmds: CommandsExchangeD3, mesh: number, enable: boolean, src_color: number, dst_color: number, src_alpha: number, dst_alpha: number, opt_color: number, opt_alpha: number, pass?: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_cull_mode(cmds: CommandsExchangeD3, mesh: number, val: number, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_frontface(cmds: CommandsExchangeD3, mesh: number, val: number, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_topology(cmds: CommandsExchangeD3, mesh: number, val: number, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_polygon_mode(cmds: CommandsExchangeD3, mesh: number, val: number, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {boolean} val
* @param {number} pass
*/
export function p3d_mesh_unclip_depth(cmds: CommandsExchangeD3, mesh: number, val: boolean, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {boolean} val
* @param {number} pass
*/
export function p3d_mesh_cast_shadow(cmds: CommandsExchangeD3, mesh: number, val: boolean, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {boolean} val
* @param {number} pass
*/
export function p3d_mesh_receive_shadow(cmds: CommandsExchangeD3, mesh: number, val: boolean, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {boolean} val
* @param {number} pass
*/
export function p3d_mesh_depth_write(cmds: CommandsExchangeD3, mesh: number, val: boolean, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_depth_compare(cmds: CommandsExchangeD3, mesh: number, val: number, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} constant
* @param {number} slope_scale
* @param {number} clamp
* @param {number} pass
*/
export function p3d_mesh_depth_bias(cmds: CommandsExchangeD3, mesh: number, constant: number, slope_scale: number, clamp: number, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} compare
* @param {number} fail_op
* @param {number} depth_fail_op
* @param {number} pass_op
* @param {number} pass
*/
export function p3d_mesh_stencil_front(cmds: CommandsExchangeD3, mesh: number, compare: number, fail_op: number, depth_fail_op: number, pass_op: number, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} compare
* @param {number} fail_op
* @param {number} depth_fail_op
* @param {number} pass_op
* @param {number} pass
*/
export function p3d_mesh_stencil_back(cmds: CommandsExchangeD3, mesh: number, compare: number, fail_op: number, depth_fail_op: number, pass_op: number, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_stencil_read(cmds: CommandsExchangeD3, mesh: number, val: number, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_stencil_write(cmds: CommandsExchangeD3, mesh: number, val: number, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} minx
* @param {number} miny
* @param {number} minz
* @param {number} maxx
* @param {number} maxy
* @param {number} maxz
*/
export function p3d_mesh_bounding_box(cmds: CommandsExchangeD3, mesh: number, minx: number, miny: number, minz: number, maxx: number, maxy: number, maxz: number): void;
/**
*
* * `mode` = `1`: ECullingStrategy::Optimistic
* * `mode` = `2`: ECullingStrategy::STANDARD
* * `mode` = `_`: ECullingStrategy::None
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} mode
*/
export function p3d_mesh_bounding_cullingmode(cmds: CommandsExchangeD3, mesh: number, mode: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} group
* @param {number} index
*/
export function p3d_mesh_render_queue(cmds: CommandsExchangeD3, mesh: number, group: number, index: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_mesh_render_queue_arr(cmds: CommandsExchangeD3, data: Float64Array, len: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
*/
export function p3d_mesh_render_alignment(cmds: CommandsExchangeD3, mesh: number, val: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
*/
export function p3d_mesh_instance_sort_mode(cmds: CommandsExchangeD3, mesh: number, val: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
*/
export function p3d_abstruct_mesh_scaling_mode(cmds: CommandsExchangeD3, mesh: number, val: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_abstruct_mesh_velocity(cmds: CommandsExchangeD3, mesh: number, x: number, y: number, z: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_abstruct_mesh_velocity_arr(cmds: CommandsExchangeD3, data: Float64Array, len: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} abstructmesh
* @param {number} group
* @param {Atom} key
* @param {number} curve_key
*/
export function p3d_attribute_target_animation(cmds: CommandsExchangeD3, abstructmesh: number, group: number, key: Atom, curve_key: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {Float32Array} data
*/
export function p3d_abstruct_pose_matrix(cmds: CommandsExchangeD3, mesh: number, data: Float32Array): void;
/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} source
* @returns {number}
*/
export function p3d_instance_mesh(app: Engine, cmds: CommandsExchangeD3, source: number): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} uscale
* @param {number} vscale
* @param {number} uoffset
* @param {number} voffset
* @param {Atom} attr
*/
export function p3d_instance_mesh_vec4(cmds: CommandsExchangeD3, instance: number, uscale: number, vscale: number, uoffset: number, voffset: number, attr: Atom): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} r
* @param {number} g
* @param {number} b
* @param {Atom} attr
*/
export function p3d_instance_mesh_vec3(cmds: CommandsExchangeD3, instance: number, r: number, g: number, b: number, attr: Atom): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {number} y
* @param {Atom} attr
*/
export function p3d_instance_mesh_vec2(cmds: CommandsExchangeD3, instance: number, x: number, y: number, attr: Atom): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} val
* @param {Atom} attr
*/
export function p3d_instance_mesh_float(cmds: CommandsExchangeD3, instance: number, val: number, attr: Atom): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {Atom} attr
*/
export function p3d_instance_mesh_sint(cmds: CommandsExchangeD3, instance: number, x: number, attr: Atom): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {Atom} attr
*/
export function p3d_instance_mesh_uint(cmds: CommandsExchangeD3, instance: number, x: number, attr: Atom): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @param {Atom} attr
*/
export function p3d_instance_mesh_ivec4(cmds: CommandsExchangeD3, instance: number, x: number, y: number, z: number, w: number, attr: Atom): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {number} y
* @param {Atom} attr
*/
export function p3d_instance_mesh_u16x2(cmds: CommandsExchangeD3, instance: number, x: number, y: number, attr: Atom): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @param {Atom} attr
*/
export function p3d_instance_mesh_u16x4(cmds: CommandsExchangeD3, instance: number, x: number, y: number, z: number, w: number, attr: Atom): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @param {Atom} attr
*/
export function p3d_instance_mesh_u8x4(cmds: CommandsExchangeD3, instance: number, x: number, y: number, z: number, w: number, attr: Atom): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} val
*/
export function p3d_mesh_bone_offset(cmds: CommandsExchangeD3, instance: number, val: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_mesh_bone_offset_arr(cmds: CommandsExchangeD3, data: Float64Array, len: number): void;
/**
* @param {VBMeta} meta
* @param {number} attr
* @param {number} format
*/
export function p3d_vbmeta_attr(meta: VBMeta, attr: number, format: number): void;
/**
* @param {VBMeta} meta
* @param {Atom} key
* @param {number} format
* @param {Atom} code
* @param {Atom} foruniform
*/
export function p3d_vbmeta_custom_attr(meta: VBMeta, key: Atom, format: number, code: Atom, foruniform: Atom): void;
/**
* @param {GeometryMeta} geo
* @param {VBMeta} vb
*/
export function p3d_geo_set_vertex(geo: GeometryMeta, vb: VBMeta): void;
/**
* @param {GeometryMeta} geo
* @param {string} name
* @param {number | undefined} start
* @param {number | undefined} end
* @param {boolean} as_u16
*/
export function p3d_geo_set_indice(geo: GeometryMeta, name: string, start: number | undefined, end: number | undefined, as_u16: boolean): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {string} key
* @param {Float32Array} data
* @param {number} length
*/
export function p3d_create_vertex_buffer(app: Engine, param: ActionSetScene3D, key: string, data: Float32Array, length: number): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {string} key
* @param {Uint16Array} data
* @param {number} length
*/
export function p3d_create_indices_buffer(app: Engine, param: ActionSetScene3D, key: string, data: Uint16Array, length: number): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {string} key
* @param {Uint32Array} data
* @param {number} length
*/
export function p3d_create_indices_buffer_u32(app: Engine, param: ActionSetScene3D, key: string, data: Uint32Array, length: number): void;
/**
* @param {Engine} app
* @returns {number}
*/
export function p3d_material(app: Engine): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} shader
*/
export function p3d_material_shader(cmds: CommandsExchangeD3, mat: number, shader: Atom): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {number} mesh
* @param {number} pass
*/
export function p3d_material_apply(cmds: CommandsExchangeD3, mat: number, mesh: number, pass: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {number} m11
* @param {number} m12
* @param {number} m13
* @param {number} m14
* @param {number} m21
* @param {number} m22
* @param {number} m23
* @param {number} m24
* @param {number} m31
* @param {number} m32
* @param {number} m33
* @param {number} m34
* @param {number} m41
* @param {number} m42
* @param {number} m43
* @param {number} m44
*/
export function p3d_material_uniform_mat4(cmds: CommandsExchangeD3, mat: number, key: Atom, m11: number, m12: number, m13: number, m14: number, m21: number, m22: number, m23: number, m24: number, m31: number, m32: number, m33: number, m34: number, m41: number, m42: number, m43: number, m44: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {number} x
* @param {number} y
*/
export function p3d_material_uniform_vec2(cmds: CommandsExchangeD3, mat: number, key: Atom, x: number, y: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
*/
export function p3d_material_uniform_vec4(cmds: CommandsExchangeD3, mat: number, key: Atom, x: number, y: number, z: number, w: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {number} val
*/
export function p3d_material_uniform_float(cmds: CommandsExchangeD3, mat: number, key: Atom, val: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {number} val
*/
export function p3d_material_uniform_uint(cmds: CommandsExchangeD3, mat: number, key: Atom, val: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {Atom} url
* @param {boolean} srgb
* @param {boolean} compressed
* @param {boolean} filter
* @param {number} address_mode_u
* @param {number} address_mode_v
* @param {number} address_mode_w
* @param {number} mag_filter
* @param {number} min_filter
* @param {number} mipmap_filter
* @param {number} anisotropy_clamp
* @param {number} border_color
* @param {boolean} isfile
* @param {boolean} cancombine
* @param {number | undefined} [compare]
*/
export function p3d_material_uniform_tex(cmds: CommandsExchangeD3, mat: number, key: Atom, url: Atom, srgb: boolean, compressed: boolean, filter: boolean, address_mode_u: number, address_mode_v: number, address_mode_w: number, mag_filter: number, min_filter: number, mipmap_filter: number, anisotropy_clamp: number, border_color: number, isfile: boolean, cancombine: boolean, compare?: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {Atom} key_tilloff
* @param {number} url
* @param {boolean} filter
* @param {number} address_mode_u
* @param {number} address_mode_v
* @param {number} address_mode_w
* @param {number} mag_filter
* @param {number} min_filter
* @param {number} mipmap_filter
* @param {number} anisotropy_clamp
* @param {number} border_color
* @param {number | undefined} [compare]
*/
export function p3d_material_uniform_tex_from_render_target(cmds: CommandsExchangeD3, mat: number, key: Atom, key_tilloff: Atom, url: number, filter: boolean, address_mode_u: number, address_mode_v: number, address_mode_w: number, mag_filter: number, min_filter: number, mipmap_filter: number, anisotropy_clamp: number, border_color: number, compare?: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {number} group
* @param {Atom} key
* @param {number} curve_key
*/
export function p3d_uniform_target_animation(cmds: CommandsExchangeD3, mat: number, group: number, key: Atom, curve_key: number): void;
/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} ltype
* @returns {number}
*/
export function p3d_light(app: Engine, cmds: CommandsExchangeD3, scene: number, ltype: number): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} light
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_light_direction(cmds: CommandsExchangeD3, light: number, x: number, y: number, z: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} light
* @param {number} val
*/
export function p3d_light_strength(cmds: CommandsExchangeD3, light: number, val: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} light
* @param {number} inner
* @param {number} outer
*/
export function p3d_light_spot_angle(cmds: CommandsExchangeD3, light: number, inner: number, outer: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} light
* @param {number} val
*/
export function p3d_light_radius(cmds: CommandsExchangeD3, light: number, val: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} light
* @param {number} r
* @param {number} g
* @param {number} b
*/
export function p3d_light_color(cmds: CommandsExchangeD3, light: number, r: number, g: number, b: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh_or_instance
* @param {number} light
* @param {boolean} is_add
*/
export function p3d_abstructmesh_force_point_light(cmds: CommandsExchangeD3, mesh_or_instance: number, light: number, is_add: boolean): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh_or_instance
* @param {number} light
* @param {boolean} is_add
*/
export function p3d_abstructmesh_force_spot_light(cmds: CommandsExchangeD3, mesh_or_instance: number, light: number, is_add: boolean): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh_or_instance
* @param {number} light
* @param {boolean} is_add
*/
export function p3d_abstructmesh_force_hemi_light(cmds: CommandsExchangeD3, mesh_or_instance: number, light: number, is_add: boolean): void;
/**
* * pass_tag:
*     * 0b0000_0000_0000_0001
*     * 0b0000_0000_0000_0010
*     * 0b0000_0000_0000_0100
*     * 0b0000_0000_0000_1000
*     * 0b0000_0000_0001_0000
*     * 0b0000_0000_0010_0000
*     * 0b0000_0000_0100_0000
*     * 0b0000_0000_1000_0000
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} light
* @param {number} pass_tag
* @returns {number}
*/
export function p3d_shadow_generator(app: Engine, cmds: CommandsExchangeD3, scene: number, light: number, pass_tag: number): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} shadow
* @param {number} bias
* @param {number} normal_bias
* @param {number} depthscale
* @returns {number}
*/
export function p3d_shadow_base_param(cmds: CommandsExchangeD3, shadow: number, bias: number, normal_bias: number, depthscale: number): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} shadow
* @param {number} frustum_size
* @param {number} minz
* @param {number} maxz
*/
export function p3d_shadow_frustum(cmds: CommandsExchangeD3, shadow: number, frustum_size: number, minz: number, maxz: number): void;
/**
* @param {NodeMaterialBlock} block
* @param {Atom} depend
*/
export function p3d_node_material_block_extend_depend(block: NodeMaterialBlock, depend: Atom): void;
/**
* @param {NodeMaterialBlock} block
* @param {number} bind_define
*/
export function p3d_node_material_block_extend_bind_define(block: NodeMaterialBlock, bind_define: number): void;
/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} m11
* @param {number} m12
* @param {number} m13
* @param {number} m14
* @param {number} m21
* @param {number} m22
* @param {number} m23
* @param {number} m24
* @param {number} m31
* @param {number} m32
* @param {number} m33
* @param {number} m34
* @param {number} m41
* @param {number} m42
* @param {number} m43
* @param {number} m44
*/
export function p3d_node_material_block_mat4(block: NodeMaterialBlock, key: Atom, m11: number, m12: number, m13: number, m14: number, m21: number, m22: number, m23: number, m24: number, m31: number, m32: number, m33: number, m34: number, m41: number, m42: number, m43: number, m44: number): void;
/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @param {boolean} caninstance
*/
export function p3d_node_material_block_vec4(block: NodeMaterialBlock, key: Atom, x: number, y: number, z: number, w: number, caninstance: boolean): void;
/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} x
* @param {number} y
* @param {number} z
* @param {boolean} caninstance
*/
export function p3d_node_material_block_vec3(block: NodeMaterialBlock, key: Atom, x: number, y: number, z: number, caninstance: boolean): void;
/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} x
* @param {number} y
* @param {boolean} caninstance
*/
export function p3d_node_material_block_vec2(block: NodeMaterialBlock, key: Atom, x: number, y: number, caninstance: boolean): void;
/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} x
* @param {boolean} caninstance
*/
export function p3d_node_material_block_float(block: NodeMaterialBlock, key: Atom, x: number, caninstance: boolean): void;
/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} x
* @param {boolean} caninstance
*/
export function p3d_node_material_block_uint(block: NodeMaterialBlock, key: Atom, x: number, caninstance: boolean): void;
/**
* @param {NodeMaterialBlock} block
* @param {Atom} name
* @param {Atom} format
*/
export function p3d_node_material_block_varying(block: NodeMaterialBlock, name: Atom, format: Atom): void;
/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {boolean} filterable
* @param {number} stage
* @param {number} default_texture
* @param {number} demision
*/
export function p3d_node_material_block_texture(block: NodeMaterialBlock, key: Atom, filterable: boolean, stage: number, default_texture: number, demision: number): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {NodeMaterialBlock} block
*/
export function p3d_node_material_block_regist(app: Engine, param: ActionSetScene3D, block: NodeMaterialBlock): void;
/**
* @param {NodematerialIncludes} includes
* @param {BuiltinNodeMaterialBlock} block
*/
export function p3d_material_include(includes: NodematerialIncludes, block: BuiltinNodeMaterialBlock): void;
/**
* @param {NodematerialIncludes} includes
* @param {Atom} block
*/
export function p3d_material_include_by_name(includes: NodematerialIncludes, block: Atom): void;
/**
* @param {NodematerialIncludes} includes
*/
export function p3d_material_includes_reset(includes: NodematerialIncludes): void;
/**
* @param {MaterialUniformDefines} uniforms
* @param {string} key
* @param {number} val
* @param {boolean} caninstance
*/
export function p3d_shader_uniform_float(uniforms: MaterialUniformDefines, key: string, val: number, caninstance: boolean): void;
/**
* @param {MaterialUniformDefines} uniforms
* @param {string} key
* @param {number} x
* @param {number} y
* @param {boolean} caninstance
*/
export function p3d_shader_uniform_vec2(uniforms: MaterialUniformDefines, key: string, x: number, y: number, caninstance: boolean): void;
/**
* @param {MaterialUniformDefines} uniforms
* @param {string} key
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @param {boolean} caninstance
*/
export function p3d_shader_uniform_vec4(uniforms: MaterialUniformDefines, key: string, x: number, y: number, z: number, w: number, caninstance: boolean): void;
/**
* @param {MaterialUniformDefines} uniforms
* @param {string} key
* @param {number} val
* @param {boolean} caninstance
*/
export function p3d_shader_uniform_uint(uniforms: MaterialUniformDefines, key: string, val: number, caninstance: boolean): void;
/**
* @param {MaterialUniformDefines} uniforms
* @param {string} key
* @param {boolean} filterable
* @param {number} stage
* @param {number} default_texture
* @param {number} demision
*/
export function p3d_shader_uniform_tex(uniforms: MaterialUniformDefines, key: string, filterable: boolean, stage: number, default_texture: number, demision: number): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {string} key
* @returns {boolean}
*/
export function p3d_check_shader(app: Engine, param: ActionSetScene3D, key: string): boolean;
/**
* @param {P3DShaderVaryings} block
* @param {Atom} name
* @param {Atom} format
*/
export function p3d_varying(block: P3DShaderVaryings, name: Atom, format: Atom): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {string} key
* @param {MaterialUniformDefines} uniforms
* @param {string} vs_define_code
* @param {string} fs_define_code
* @param {string} vs_code
* @param {string} fs_code
* @param {NodematerialIncludes} includes
* @param {string} instance_code
* @param {P3DShaderVaryings} varyings
* @param {number | undefined} [binds_defines_base]
* @returns {P3DShaderMeta | undefined}
*/
export function p3d_regist_material(app: Engine, param: ActionSetScene3D, key: string, uniforms: MaterialUniformDefines, vs_define_code: string, fs_define_code: string, vs_code: string, fs_code: string, includes: NodematerialIncludes, instance_code: string, varyings: P3DShaderVaryings, binds_defines_base?: number): P3DShaderMeta | undefined;
/**
* @param {CommandsExchangeD3} param
* @param {Atom} key
* @param {number} width
* @param {number} height
* @param {number} format
* @param {number | undefined} [aspect]
*/
export function p3d_create_data_texture(param: CommandsExchangeD3, key: Atom, width: number, height: number, format: number, aspect?: number): void;
/**
* @param {CommandsExchangeD3} param
* @param {Atom} key
* @param {Uint8Array} data
* @param {number} xoffset
* @param {number} yoffset
* @param {number} width
* @param {number} height
* @param {number | undefined} [aspect]
*/
export function p3d_update_data_texture(param: CommandsExchangeD3, key: Atom, data: Uint8Array, xoffset: number, yoffset: number, width: number, height: number, aspect?: number): void;
/**
* @param {CommandsExchangeD3} param
* @param {Atom} key
*/
export function p3d_remove_data_texture(param: CommandsExchangeD3, key: Atom): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {boolean} isfile
* @param {Atom} url
* @param {boolean} cancombine
* @param {boolean} compressed
* @param {number} depth_or_array_layers
* @param {Float32Array} info
* @returns {boolean}
*/
export function p3d_query_texture(app: Engine, param: ActionSetScene3D, isfile: boolean, url: Atom, cancombine: boolean, compressed: boolean, depth_or_array_layers: number, info: Float32Array): boolean;
/**
* @param {CommandsExchangeD3} cmd
* @param {number} requestid
* @param {Atom} targetkey
* @param {Atom} file
* @param {number} idx
* @param {boolean} iscompress
* @param {number} xoffset
* @param {number} yoffset
* @param {number} width
* @param {number} height
*/
export function p3d_texture_combine_add_frame(cmd: CommandsExchangeD3, requestid: number, targetkey: Atom, file: Atom, idx: number, iscompress: boolean, xoffset: number, yoffset: number, width: number, height: number): void;
/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmd
* @param {number} requestid
* @param {Atom} targetkey
*/
export function p3d_texture_combine_remove(app: Engine, cmd: CommandsExchangeD3, requestid: number, targetkey: Atom): void;
/**
* @param {Engine} app
* @param {Uint32Array} success
* @param {Uint32Array} fail
*/
export function p3d_texture_combine_query(app: Engine, success: Uint32Array, fail: Uint32Array): void;
/**
* @param {Engine} app
* @param {number} format
* @param {number} maxlayer
* @param {number} maxsize
* @param {number} maxcount
*/
export function p3d_texture_combine_param(app: Engine, format: number, maxlayer: number, maxsize: number, maxcount: number): void;
/**
* 创建动画组
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @returns {number}
*/
export function p3d_animation_group(app: Engine, cmds: CommandsExchangeD3, scene: number): number;
/**
* 动画曲线ID
* @param {Atom} key
* @returns {number}
*/
export function p3d_animation_curve_id(key: Atom): number;
/**
* 设置 动画组 混合权重
* @param {CommandsExchangeD3} cmds
* @param {number} group
* @param {number} weight
*/
export function p3d_animation_group_weight(cmds: CommandsExchangeD3, group: number, weight: number): void;
/**
* 重置动画组各动画作用目标到非动画操作状态
* @param {CommandsExchangeD3} cmds
* @param {number} group
*/
export function p3d_animation_group_target_reset(cmds: CommandsExchangeD3, group: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} group_key
* @param {number} speed
* @param {ELoopMode} loop_mode
* @param {number | undefined} loop_count
* @param {number} from
* @param {number} to
* @param {number} fps
* @param {EAmountMode} amount_mode
* @param {number} delay_ms
* @param {EFillMode} fillmode
* @param {number} amount_param0
* @param {number} amount_param1
* @param {number} amount_param2
* @param {number} amount_param3
*/
export function p3d_anime_group_start(cmds: CommandsExchangeD3, group_key: number, speed: number, loop_mode: ELoopMode, loop_count: number | undefined, from: number, to: number, fps: number, amount_mode: EAmountMode, delay_ms: number, fillmode: EFillMode, amount_param0: number, amount_param1: number, amount_param2: number, amount_param3: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} group_key
*/
export function p3d_anime_group_pause(cmds: CommandsExchangeD3, group_key: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} group_key
*/
export function p3d_anime_group_stop(cmds: CommandsExchangeD3, group_key: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} group_key
* @param {number} amount
*/
export function p3d_anime_group_goto(cmds: CommandsExchangeD3, group_key: number, amount: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} group_key
* @param {EAnimationGroupListen} mode
*/
export function p3d_animation_group_listen(cmds: CommandsExchangeD3, group_key: number, mode: EAnimationGroupListen): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} group
* @param {number} percent
* @param {number} data
*/
export function p3d_animation_group_add_frame_event(cmds: CommandsExchangeD3, group: number, percent: number, data: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} group
*/
export function p3d_animation_group_delete(cmds: CommandsExchangeD3, group: number): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float64Array} receive
* @param {number} receive_len
* @returns {number}
*/
export function p3d_query_anime_events(app: Engine, param: ActionSetScene3D, receive: Float64Array, receive_len: number): number;
/**
* FrameCurve
* * `FrameValues` data: [design_frame_per_second, (frame, x, y, ..), (frame, x, y, ..) ...]
* * `FrameValuesStep` data: [design_frame_per_second, (frame, x, y, ..), (frame, x, y, ..) ...]
* * `EasingCurve` data: [design_frame_per_second, total_frame, mode, (x, y, ..), (x, y, ..)]
* * `MinMaxCurve` data: [design_frame_per_second, (x, y, ..), (x, y, ..), (frame, f32, it, ot), (frame, f32, it, ot) ...]
* * `CubicBezierCurve` data: [design_frame_per_second, total_frame, (x, y, ..), (x, y, ..), (x1, y1, x2, y2)]
* * `GLTFCubicSpline` data: [design_frame_per_second, (frame, (x, y, ..), (x, y, ..), (x, y, ..)), ...]
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} key
* @param {EAnimePropertyID} property
* @returns {boolean}
*/
export function p3d_anime_curve_query(app: Engine, param: ActionSetScene3D, key: number, property: EAnimePropertyID): boolean;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} key
* @param {EAnimePropertyID} property
* @param {Float32Array} data
* @param {EAnimeCurve} mode
* @returns {boolean}
*/
export function p3d_anime_curve_create(app: Engine, param: ActionSetScene3D, key: number, property: EAnimePropertyID, data: Float32Array, mode: EAnimeCurve): boolean;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} curve_key
* @param {EAnimePropertyID} property
* @param {number} group
* @param {number} curve_target
* @returns {boolean}
*/
export function p3d_property_target_animation(cmds: CommandsExchangeD3, curve_key: number, property: EAnimePropertyID, group: number, curve_target: number): boolean;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} entity
* @param {number} trailmesh
* @param {number} trailgeo
* @param {Atom} key
* @param {Atom} color_attr_key
* @param {Atom} tilloff_attr_key
* @param {number | undefined} [update_buffer_interval_frame]
*/
export function p3d_particle_system(app: Engine, param: ActionSetScene3D, cmds: CommandsExchangeD3, scene: number, entity: number, trailmesh: number, trailgeo: number, key: Atom, color_attr_key: Atom, tilloff_attr_key: Atom, update_buffer_interval_frame?: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} entity
* @param {number} trailmesh
* @param {number} trailgeo
* @param {GLTFRes} gltf
* @param {number} index_calculator
* @param {Atom} color_attr_key
* @param {Atom} tilloff_attr_key
* @param {number | undefined} [update_buffer_interval_frame]
*/
export function p3d_particle_system_with_gltf(cmds: CommandsExchangeD3, scene: number, entity: number, trailmesh: number, trailgeo: number, gltf: GLTFRes, index_calculator: number, color_attr_key: Atom, tilloff_attr_key: Atom, update_buffer_interval_frame?: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} entity
*/
export function p3d_particle_system_start(cmds: CommandsExchangeD3, entity: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} entity
* @param {number} speed
*/
export function p3d_particle_system_timescale(cmds: CommandsExchangeD3, entity: number, speed: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} entity
*/
export function p3d_particle_system_stop(cmds: CommandsExchangeD3, entity: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} entity
* @param {number} linked
*/
export function p3d_trail(cmds: CommandsExchangeD3, scene: number, entity: number, linked: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} entity
* @param {number} age_ms
*/
export function p3d_trail_age(cmds: CommandsExchangeD3, entity: number, age_ms: number): void;
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {CommandsExchangeD3} cmds
*/
export function p3d_commands_exchange(app: Engine, param: ActionSetScene3D, cmds: CommandsExchangeD3): void;
/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} bonespervertex
* @param {number} root
* @param {Float64Array} bones
* @param {number} bonecount
* @param {number} cacheframe
* @returns {number}
*/
export function p3d_skeleton(app: Engine, cmds: CommandsExchangeD3, bonespervertex: number, root: number, bones: Float64Array, bonecount: number, cacheframe: number): number;
/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @returns {number}
*/
export function p3d_bone(app: Engine, cmds: CommandsExchangeD3, scene: number): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} bone
* @param {number} link
*/
export function p3d_bone_link(cmds: CommandsExchangeD3, bone: number, link: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} bone
* @param {Float32Array} data
*/
export function p3d_bone_pose(cmds: CommandsExchangeD3, bone: number, data: Float32Array): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} id_mesh
* @param {number} skin
*/
export function p3d_skin_use(cmds: CommandsExchangeD3, id_mesh: number, skin: number): void;
/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} source
* @param {Atom} atlas
* @returns {number}
*/
export function p3d_sprite(app: Engine, cmds: CommandsExchangeD3, source: number, atlas: Atom): number;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} sprite
* @param {Atom} tilloffkey
* @param {number} idxframe
*/
export function p3d_sprite_frame(cmds: CommandsExchangeD3, sprite: number, tilloffkey: Atom, idxframe: number): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {number} sprite
* @param {Atom} tilloffkey
* @param {Uint16Array} data
*/
export function p3d_sprite_frame_data(cmds: CommandsExchangeD3, sprite: number, tilloffkey: Atom, data: Uint16Array): void;
/**
* @param {CommandsExchangeD3} cmds
* @param {Uint16Array} data
* @returns {number}
*/
export function p3d_record_sprite_frame_data(cmds: CommandsExchangeD3, data: Uint16Array): number;
/**
* @param {Atom} atlas
* @param {number} width
* @param {number} height
* @returns {PTextureFrameAtlas}
*/
export function p3d_texture_frame_atlas(atlas: Atom, width: number, height: number): PTextureFrameAtlas;
/**
* @param {PTextureFrameAtlas} atlas
* @param {Atom} frame_name
* @param {Uint16Array} framedata
* @returns {number}
*/
export function p3d_texture_frame_atlas_append_frame(atlas: PTextureFrameAtlas, frame_name: Atom, framedata: Uint16Array): number;
/**
* @param {PTextureFrameAtlas} atlas
* @param {Atom} anim_name
* @param {Uint16Array} animframeidxs
* @returns {number}
*/
export function p3d_texture_frame_atlas_append_animation(atlas: PTextureFrameAtlas, anim_name: Atom, animframeidxs: Uint16Array): number;
/**
* @param {Engine} app
* @param {PTextureFrameAtlas} atlas
* @returns {ResTextureFrameAtlas | undefined}
*/
export function p3d_texture_frame_atlas_cache(app: Engine, atlas: PTextureFrameAtlas): ResTextureFrameAtlas | undefined;
/**
* @param {Engine} engine
* @param {number} node_id
* @returns {string}
*/
export function get_layout(engine: Engine, node_id: number): string;
/**
* @param {Engine} engine
* @param {number} class_name
* @returns {string}
*/
export function get_class(engine: Engine, class_name: number): string;
/**
* @param {Engine} engine
* @param {number} node_id
* @returns {string}
*/
export function node_info(engine: Engine, node_id: number): string;
/**
* @param {Engine} engine
* @returns {string}
*/
export function texture_info(engine: Engine): string;
/**
* @param {Engine} engine
* @returns {Float64Array}
*/
export function debug_info(engine: Engine): Float64Array;
/**
* @param {Engine} engine
* @param {number} node_id
* @returns {string}
*/
export function get_world_matrix(engine: Engine, node_id: number): string;
/**
* @param {Engine} engine
* @param {number} node_id
* @returns {string}
*/
export function get_transform(engine: Engine, node_id: number): string;
/**
* @param {any} context
* @param {Engine} engine
* @param {number} width
* @param {number} height
* @param {Function | undefined} load_sdf_fun
* @param {number} class_sheet
* @param {number} font_sheet
* @param {number} cur_time
* @param {Function} animation_event_fun
* @param {TraceOption} debug
* @returns {Gui}
*/
export function create_gui(context: any, engine: Engine, width: number, height: number, load_sdf_fun: Function | undefined, class_sheet: number, font_sheet: number, cur_time: number, animation_event_fun: Function, debug: TraceOption): Gui;
/**
* @param {Gui} gui
* @param {Float64Array} arr
* @param {number} count
* @param {number} key
*/
export function create_fragment(gui: Gui, arr: Float64Array, count: number, key: number): void;
/**
* @param {Engine} engine
*/
export function log_animation(engine: Engine): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_align_content(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_align_content(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_align_items(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_align_items(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_justify_content(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_justify_content(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_direction(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_direction(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_wrap(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_wrap(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_align_self(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_align_self(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_position_type(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_position_type(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_grow(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_grow(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_shrink(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_shrink(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_basis_percent(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_basis_percent(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_basis(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_basis(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_flex_basis_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_basis_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_width_percent(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_width_percent(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_width(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_width(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_width_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_width_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_height_percent(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_height_percent(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_height(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_height(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_height_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_height_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_min_width_percent(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_width_percent(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_min_width(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_width(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_min_width_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_width_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_min_height_percent(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_height_percent(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_min_height(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_height(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_min_height_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_height_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_max_width_percent(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_width_percent(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_max_width(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_width(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_max_width_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_width_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_max_height_percent(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_height_percent(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_max_height(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_height(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_max_height_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_height_auto(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_padding_percent(gui: Gui, node_id: number, edge: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_padding_percent(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_padding(gui: Gui, node_id: number, edge: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_padding(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function set_padding_auto(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_padding_auto(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_margin_percent(gui: Gui, node_id: number, edge: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_margin_percent(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_margin(gui: Gui, node_id: number, edge: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_margin(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function set_margin_auto(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_margin_auto(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_border_percent(gui: Gui, node_id: number, edge: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_border_percent(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_border(gui: Gui, node_id: number, edge: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_border(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function set_border_auto(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_border_auto(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_position_percent(gui: Gui, node_id: number, edge: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_position_percent(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_position(gui: Gui, node_id: number, edge: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_position(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function set_position_auto(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_position_auto(gui: Gui, node_id: number, edge: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_background_rgba_color(gui: Gui, node_id: number, r: number, g: number, b: number, a: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_background_rgba_color(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} direction
* @param {Float32Array} color_and_positions
*/
export function set_background_linear_color(gui: Gui, node_id: number, direction: number, color_and_positions: Float32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_background_linear_color(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_border_color(gui: Gui, node_id: number, r: number, g: number, b: number, a: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_color(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_border_radius(gui: Gui, node_id: number, s: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_radius(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} h
* @param {number} v
* @param {number} blur
* @param {number} spread
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_box_shadow(gui: Gui, node_id: number, h: number, v: number, blur: number, spread: number, r: number, g: number, b: number, a: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_box_shadow(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_object_fit(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_object_fit(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} x
* @param {number} y
*/
export function set_background_repeat(gui: Gui, node_id: number, x: number, y: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_background_repeat(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} direction
* @param {Float32Array} color_and_positions
*/
export function set_mask_image_linear(gui: Gui, node_id: number, direction: number, color_and_positions: Float32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_mask_image_linear(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} u1
* @param {number} v1
* @param {number} u2
* @param {number} v2
*/
export function set_image_clip(gui: Gui, node_id: number, u1: number, v1: number, u2: number, v2: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_image_clip(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} u1
* @param {number} v1
* @param {number} u2
* @param {number} v2
*/
export function set_mask_image_clip(gui: Gui, node_id: number, u1: number, v1: number, u2: number, v2: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_mask_image_clip(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} u1
* @param {number} v1
* @param {number} u2
* @param {number} v2
*/
export function set_border_image_clip(gui: Gui, node_id: number, u1: number, v1: number, u2: number, v2: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_image_clip(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} top
* @param {number} right
* @param {number} bottom
* @param {number} left
* @param {boolean} fill
*/
export function set_border_image_slice(gui: Gui, node_id: number, top: number, right: number, bottom: number, left: number, fill: boolean): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_image_slice(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} vertical
* @param {number} horizontal
*/
export function set_border_image_repeat(gui: Gui, node_id: number, vertical: number, horizontal: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_image_repeat(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {boolean} v
*/
export function set_overflow(gui: Gui, node_id: number, v: boolean): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_overflow(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_opacity(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_opacity(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_display(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_display(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {boolean} v
*/
export function set_visibility(gui: Gui, node_id: number, v: boolean): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_visibility(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_enable(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_enable(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_blend_mode(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_blend_mode(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_zindex(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_zindex(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
*/
export function set_as_image(gui: Gui, node_id: number, value: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_as_image(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_filter_blur(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_filter_blur(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {boolean} v
*/
export function set_transform_will_change(gui: Gui, node_id: number, v: boolean): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_transform_will_change(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} h
* @param {number} s
* @param {number} _i
*/
export function set_filter_hsi(gui: Gui, node_id: number, h: number, s: number, _i: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_filter_hsi(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_translate(gui: Gui, node_id: number, s: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_translate(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_scale(gui: Gui, node_id: number, s: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_scale(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_rotate(gui: Gui, node_id: number, s: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_rotate(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_transform(gui: Gui, node_id: number, s: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_transform(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_text_overflow(gui: Gui, node_id: number, s: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_overflow(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_overflow_wrap(gui: Gui, node_id: number, s: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_overflow_wrap(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} x_ty
* @param {number} x
* @param {number} y_ty
* @param {number} y
*/
export function set_transform_origin(gui: Gui, node_id: number, x_ty: number, x: number, y_ty: number, y: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_transform_origin(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_letter_spacing(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_letter_spacing(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_word_spacing(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_word_spacing(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_text_rgba_color(gui: Gui, node_id: number, r: number, g: number, b: number, a: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_rgba_color(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} direction
* @param {Float32Array} color_and_positions
*/
export function set_text_linear_gradient_color(gui: Gui, node_id: number, direction: number, color_and_positions: Float32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_linear_gradient_color(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_line_height_normal(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_line_height_normal(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} value
*/
export function set_line_height(gui: Gui, node_id: number, value: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_line_height(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} value
*/
export function set_line_height_percent(gui: Gui, node_id: number, value: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_line_height_percent(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_text_indent(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_indent(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_text_align(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_align(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_vertical_align(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_vertical_align(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} width
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_text_stroke(gui: Gui, node_id: number, width: number, r: number, g: number, b: number, a: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_stroke(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_white_space(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_white_space(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_font_style(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_style(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_font_weight(gui: Gui, node_id: number, v: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_weight(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_font_size_none(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_size_none(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} value
*/
export function set_font_size(gui: Gui, node_id: number, value: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_size(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} value
*/
export function set_font_size_percent(gui: Gui, node_id: number, value: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_size_percent(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint8Array} content
*/
export function set_text_content_utf8(gui: Gui, node_id: number, content: Uint8Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_content_utf8(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
*/
export function set_clip_path_str(gui: Gui, node_id: number, value: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_clip_path_str(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint32Array} name
*/
export function set_animation_duration(gui: Gui, node_id: number, name: Uint32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_duration(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint32Array} name
*/
export function set_animation_delay(gui: Gui, node_id: number, name: Uint32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_delay(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} name
*/
export function set_animation_iteration_count(gui: Gui, node_id: number, name: Float32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_iteration_count(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint8Array} name
*/
export function set_animation_direction(gui: Gui, node_id: number, name: Uint8Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_direction(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint8Array} name
*/
export function set_animation_fill_mode(gui: Gui, node_id: number, name: Uint8Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_fill_mode(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint8Array} name
*/
export function set_animation_play_state(gui: Gui, node_id: number, name: Uint8Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_play_state(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
* @param {number} scope_hash
*/
export function set_animation_name_str(gui: Gui, node_id: number, value: string, scope_hash: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_name_str(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} animation
* @param {string} key_frames
* @param {number} scope_hash
*/
export function set_runtime_animation(gui: Gui, node_id: number, animation: string, key_frames: string, scope_hash: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_runtime_animation(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
* @param {number} scope_hash
*/
export function set_animation_str(gui: Gui, node_id: number, value: string, scope_hash: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_str(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Atom} image_hash
*/
export function set_mask_image(gui: Gui, node_id: number, image_hash: Atom): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_mask_image(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Atom} image_hash
*/
export function set_background_image(gui: Gui, node_id: number, image_hash: Atom): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_background_image(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Atom} image_hash
*/
export function set_border_image(gui: Gui, node_id: number, image_hash: Atom): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_image(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_text_shadow(gui: Gui, node_id: number, s: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_shadow(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
*/
export function set_text_outer_glow(gui: Gui, node_id: number, value: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_outer_glow(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Atom} name
*/
export function set_font_family(gui: Gui, node_id: number, name: Atom): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_family(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} content
*/
export function set_text_content(gui: Gui, node_id: number, content: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_content(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
*/
export function set_animation_timing_function_str(gui: Gui, node_id: number, value: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_timing_function_str(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {string} value
*/
export function set_default_style(gui: Gui, value: string): void;
/**
* @param {Gui} gui
* @param {string} css
* @param {number} scope_hash
*/
export function create_class_by_str(gui: Gui, css: string, scope_hash: number): void;
/**
* @param {Gui} gui
* @param {number} node
* @param {Uint32Array} class_name
*/
export function set_class(gui: Gui, node: number, class_name: Uint32Array): void;
/**
* @param {Gui} gui
* @param {number} x
* @param {number} y
* @param {number} width
* @param {number} height
* @param {number} root
*/
export function set_view_port(gui: Gui, x: number, y: number, width: number, height: number, root: number): void;
/**
* @param {Gui} gui
* @param {number} node
* @param {number} brush
* @param {boolean | undefined} [by_draw_list]
*/
export function set_brush(gui: Gui, node: number, brush: number, by_draw_list?: boolean): void;
/**
* @param {Gui} gui
* @param {number} node
* @param {boolean} aspect_ratio
* @param {number} start
* @param {number} end
* @param {number} center_x
* @param {number} center_y
* @param {number} cycle
* @param {number} weight
*/
export function set_radial_wave(gui: Gui, node: number, aspect_ratio: boolean, start: number, end: number, center_x: number, center_y: number, cycle: number, weight: number): void;
/**
* @param {Gui} gui
* @param {number} node
* @param {number} target_ty
*/
export function set_rendertarget_type(gui: Gui, node: number, target_ty: number): void;
/**
* @param {Gui} gui
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_clear_color(gui: Gui, r: number, g: number, b: number, a: number): void;
/**
* @param {Gui} gui
* @param {Uint8Array} bin
*/
export function create_class_by_bin(gui: Gui, bin: Uint8Array): void;
/**
* @param {Gui} gui
* @param {number} root
*/
export function set_render_dirty(gui: Gui, root: number): void;
/**
* @param {Gui} _gui
*/
export function bind_render_target(_gui: Gui): void;
/**
* @param {Gui} _gui
* @param {number} _pixel_ratio
*/
export function set_pixel_ratio(_gui: Gui, _pixel_ratio: number): void;
/**
* @param {Gui} _gui
*/
export function nullify_clear_color(_gui: Gui): void;
/**
* @param {Gui} _gui
* @param {number} _x
* @param {number} _y
* @param {number} _width
* @param {number} _height
*/
export function set_scissor(_gui: Gui, _x: number, _y: number, _width: number, _height: number): void;
/**
* @param {Gui} _gui
* @param {number} _scale_x
* @param {number} _scale_y
* @param {number} _translate_x
* @param {number} _translate_y
* @param {number} _rotate
* @param {number} _width
* @param {number} _height
*/
export function set_project_transfrom(_gui: Gui, _scale_x: number, _scale_y: number, _translate_x: number, _translate_y: number, _rotate: number, _width: number, _height: number): void;
/**
* @param {Gui} _gui
* @param {number} _node
*/
export function force_update_text(_gui: Gui, _node: number): void;
/**
* @param {Gui} _gui
* @param {string} _shader_name
* @param {string} _shader_code
*/
export function set_shader(_gui: Gui, _shader_name: string, _shader_code: string): void;
/**
* @param {Gui} _gui
* @returns {number}
*/
export function get_font_sheet(_gui: Gui): number;
/**
* @param {Gui} _gui
* @returns {number}
*/
export function get_class_sheet(_gui: Gui): number;
/**
* @param {Gui} _gui
* @param {number} _fbo
* @returns {number}
*/
export function create_render_target(_gui: Gui, _fbo: number): number;
/**
* @param {Gui} _gui
* @param {number} _fbo
* @returns {number}
*/
export function destroy_render_target(_gui: Gui, _fbo: number): number;
/**
* @param {Gui} _gui
* @returns {Gui}
*/
export function clone_engine(_gui: Gui): Gui;
/**
* @param {Gui} _gui
* @returns {number}
*/
export function get_text_texture_width(_gui: Gui): number;
/**
* @param {Gui} _gui
* @returns {number}
*/
export function get_text_texture_height(_gui: Gui): number;
/**
* @param {Gui} _gui
* @param {number} _node
* @returns {boolean}
*/
export function node_is_exist(_gui: Gui, _node: number): boolean;
/**
* @param {Gui} _gui
* @param {Engine} _engine
* @param {number} _node
* @returns {boolean}
*/
export function node_is_visibility(_gui: Gui, _engine: Engine, _node: number): boolean;
/**
* @param {Gui} _gui
* @param {number} _parent
* @returns {number | undefined}
*/
export function first_child(_gui: Gui, _parent: number): number | undefined;
/**
* @param {Gui} _gui
* @param {number} _parent
* @returns {number | undefined}
*/
export function last_child(_gui: Gui, _parent: number): number | undefined;
/**
* @param {Gui} _gui
* @param {number} _node
* @returns {number | undefined}
*/
export function next_sibling(_gui: Gui, _node: number): number | undefined;
/**
* @param {Gui} _gui
* @param {number} _node
* @returns {number | undefined}
*/
export function previous_sibling(_gui: Gui, _node: number): number | undefined;
/**
* @param {Gui} _gui
* @param {number} _node
* @returns {number}
*/
export function get_layer(_gui: Gui, _node: number): number;
/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {boolean}
*/
export function get_enable(gui: Gui, engine: Engine, node: number): boolean;
/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {number}
*/
export function offset_top(gui: Gui, engine: Engine, node: number): number;
/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {number}
*/
export function offset_left(gui: Gui, engine: Engine, node: number): number;
/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {number}
*/
export function offset_width(gui: Gui, engine: Engine, node: number): number;
/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {number}
*/
export function offset_height(gui: Gui, engine: Engine, node: number): number;
/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {string}
*/
export function get_class_name(gui: Gui, engine: Engine, node: number): string;
/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {string}
*/
export function offset_document(gui: Gui, engine: Engine, node: number): string;
/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {string}
*/
export function content_box(gui: Gui, engine: Engine, node: number): string;
/**
* @param {Engine} engine
* @returns {number}
*/
export function get_animation_events_max_len(engine: Engine): number;
/**
* @param {Uint32Array} arr
* @param {Engine} engine
* @returns {number}
*/
export function get_animation_events(arr: Uint32Array, engine: Engine): number;
/**
* @param {number} value
* @returns {number}
*/
export function get_entity_offset(value: number): number;
/**
* @param {number} value
* @returns {number}
*/
export function get_entity_version(value: number): number;
/**
* @param {Engine} engine
* @param {Gui} gui
* @param {number} x
* @param {number} y
* @returns {number | undefined}
*/
export function query(engine: Engine, gui: Gui, x: number, y: number): number | undefined;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} fill_color
*/
export function set_svg_fill_color(gui: Gui, node_id: number, fill_color: Float32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_fill_color(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} fill_color_url
*/
export function set_svg_fill_color_id(gui: Gui, node_id: number, fill_color_url: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_fill_color_id(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} storke_color
*/
export function set_svg_storke_color(gui: Gui, node_id: number, storke_color: Float32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_storke_color(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} width
*/
export function set_svg_storke_width(gui: Gui, node_id: number, width: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_storke_width(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} width
*/
export function set_svg_shape_width(gui: Gui, node_id: number, width: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_width(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} height
*/
export function set_svg_shape_height(gui: Gui, node_id: number, height: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_height(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} x
*/
export function set_svg_shape_x(gui: Gui, node_id: number, x: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_x(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} y
*/
export function set_svg_shape_y(gui: Gui, node_id: number, y: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_y(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} width
*/
export function set_svg_width(gui: Gui, node_id: number, width: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_width(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} height
*/
export function set_svg_height(gui: Gui, node_id: number, height: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_height(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} shape
*/
export function set_svg_shape(gui: Gui, node_id: number, shape: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} center_x
*/
export function set_svg_shape_cx(gui: Gui, node_id: number, center_x: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_cx(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} center_y
*/
export function set_svg_shape_cy(gui: Gui, node_id: number, center_y: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_cy(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} radius
*/
export function set_svg_shape_radius(gui: Gui, node_id: number, radius: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_radius(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} radius_x
*/
export function set_svg_shape_radius_x(gui: Gui, node_id: number, radius_x: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_radius_x(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} radius_y
*/
export function set_svg_shape_radius_y(gui: Gui, node_id: number, radius_y: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_radius_y(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} ax
*/
export function set_svg_shape_ax(gui: Gui, node_id: number, ax: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_ax(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} ay
*/
export function set_svg_shape_ay(gui: Gui, node_id: number, ay: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_ay(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} bx
*/
export function set_svg_shape_bx(gui: Gui, node_id: number, bx: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_bx(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} by
*/
export function set_svg_shape_by(gui: Gui, node_id: number, by: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_by(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} points
*/
export function set_svg_shape_points(gui: Gui, node_id: number, points: Float32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_points(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} verb
* @param {Float32Array} points
*/
export function set_svg_shape_path(gui: Gui, node_id: number, verb: Float32Array, points: Float32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_path(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} stroke_dasharray
*/
export function set_svg_stroke_dasharray(gui: Gui, node_id: number, stroke_dasharray: Float32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_stroke_dasharray(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} x
*/
export function set_svg_shadow_offset_dx(gui: Gui, node_id: number, x: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shadow_offset_dx(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} y
*/
export function set_svg_shadow_offset_dy(gui: Gui, node_id: number, y: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shadow_offset_dy(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} level
*/
export function set_svg_blur_level(gui: Gui, node_id: number, level: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_blur_level(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} other_id
*/
export function set_svg_filter(gui: Gui, node_id: number, other_id: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_filter(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} other_id
*/
export function set_svg_filter_id(gui: Gui, node_id: number, other_id: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_filter_id(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} color
*/
export function set_svg_gradient_stop(gui: Gui, node_id: number, color: Float32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_gradient_stop(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} offset
*/
export function set_svg_gradient_offset(gui: Gui, node_id: number, offset: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_gradient_offset(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} other_id
*/
export function set_svg_gradient(gui: Gui, node_id: number, other_id: string): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_gradient(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} color
*/
export function set_svg_shadow_color(gui: Gui, node_id: number, color: Float32Array): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shadow_color(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @returns {number}
*/
export function create_node(gui: Gui): number;
/**
* @param {Gui} gui
* @returns {number}
*/
export function create_vnode(gui: Gui): number;
/**
* @param {Gui} gui
* @returns {number}
*/
export function create_text_node(gui: Gui): number;
/**
* @param {Gui} gui
* @returns {number}
*/
export function create_image_node(gui: Gui): number;
/**
* @param {Gui} gui
* @returns {number}
*/
export function create_canvas_node(gui: Gui): number;
/**
* @param {Gui} gui
* @param {number} node
*/
export function destroy_node(gui: Gui, node: number): void;
/**
* @param {Gui} gui
* @param {number} node
*/
export function remove_node(gui: Gui, node: number): void;
/**
* @param {Gui} gui
* @param {number} node_id
*/
export function insert_as_root(gui: Gui, node_id: number): void;
/**
* @param {Gui} gui
* @param {number} node
* @param {number} parent
*/
export function append_child(gui: Gui, node: number, parent: number): void;
/**
* @param {Gui} gui
* @param {number} node
* @param {number} borther
*/
export function insert_before(gui: Gui, node: number, borther: number): void;
/**
* @param {Gui} gui
* @param {Uint8Array} bin
*/
export function create_fragment_by_bin(gui: Gui, bin: Uint8Array): void;
/**
* @param {Gui} gui
* @param {Engine} engine
*/
export function render_gui(gui: Gui, engine: Engine): void;
/**
* @param {Gui} gui
* @param {Engine} engine
*/
export function calc(gui: Gui, engine: Engine): void;
/**
* @param {Gui} gui
* @param {Engine} engine
*/
export function calc_layout(gui: Gui, engine: Engine): void;
/**
* @param {Gui} gui
* @param {Engine} engine
*/
export function calc_geo(gui: Gui, engine: Engine): void;
/**
* @param {Engine} engine
* @param {Atom} name
* @param {number} scope_hash
* @returns {string}
*/
export function get_keyframes(engine: Engine, name: Atom, scope_hash: number): string;
/**
* @param {Engine} engine
* @param {boolean} value
*/
export function set_is_run(engine: Engine, value: boolean): void;
/**
* @param {Engine} engine
* @returns {Uint8Array}
*/
export function get_record(engine: Engine): Uint8Array;
/**
* @param {Engine} engine
* @returns {number}
*/
export function get_record_len(engine: Engine): number;
/**
* @param {Engine} engine
* @param {Uint8Array} bin
*/
export function set_next_record(engine: Engine, bin: Uint8Array): void;
/**
* @param {Engine} engine
*/
export function set_next_record_last(engine: Engine): void;
/**
* @param {Engine} engine
* @returns {boolean}
*/
export function is_play_end(engine: Engine): boolean;
/**
* @param {Engine} engine
* @param {number} node_id
*/
export function set_debug_entity(engine: Engine, node_id: number): void;
/**
*
* * -buffer Vec<Vec<u8>>
* 
* @param {number} key
* @param {Array<any>} buffer
*/
export function sdf_on_load(key: number, buffer: Array<any>): void;
/**
* @param {Gui} gui
* @param {Uint8Array} bin
*/
export function add_sdf_font(gui: Gui, bin: Uint8Array): void;
/**
* @param {Gui} gui
* @param {Atom} font_name
* @param {Uint8Array} blob
*/
export function add_sdf2_font(gui: Gui, font_name: Atom, blob: Uint8Array): void;
/**
* @param {Engine} engine
* @param {number} node_id
* @param {number} x
* @param {number} y
* @returns {CharPos}
*/
export function query_text(engine: Engine, node_id: number, x: number, y: number): CharPos;
/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node_id
* @param {number} index
* @returns {CharPos}
*/
export function get_text_pos(gui: Gui, engine: Engine, node_id: number, index: number): CharPos;
/**
* 是否存在资源
* @param {Engine} engine
* @param {Atom} path
* @returns {boolean}
*/
export function has_res(engine: Engine, path: Atom): boolean;
/**
* 加载资源
* @param {Gui} gui
* @param {Atom} path
*/
export function load_res(gui: Gui, path: Atom): void;
/**
* 获取已经加载成功的资源
* @param {Engine} engine
* @returns {number}
*/
export function get_success_res_len(engine: Engine): number;
/**
* @param {Engine} engine
* @param {Array<any>} result
* @param {Float64Array} result_keys
*/
export function get_success_res(engine: Engine, result: Array<any>, result_keys: Float64Array): void;
/**
* @param {Engine} engine
* @param {CommandsExchangeSpine} cmds
*/
export function spine_exchange_commands(engine: Engine, cmds: CommandsExchangeSpine): void;
/**
* @param {Engine} engine
*/
export function init_spine_context(engine: Engine): void;
/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {string} name
* @param {number | undefined} [width]
* @param {number | undefined} [height]
* @returns {number}
*/
export function spine_renderer_create(app: Engine, cmds: CommandsExchangeSpine, name: string, width?: number, height?: number): number;
/**
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
*/
export function spine_renderer_dispose(cmds: CommandsExchangeSpine, id_renderer: number): void;
/**
* @param {CommandsExchangeSpine} cmds
* @param {Atom} key
* @param {boolean} srgb
* @param {boolean} compressed
* @param {boolean} file
* @returns {number}
*/
export function spine_texture_load(cmds: CommandsExchangeSpine, key: Atom, srgb: boolean, compressed: boolean, file: boolean): number;
/**
* @param {Engine} app
* @param {SpineTextureLoadRecord} record
*/
export function spine_texture_loaded_query(app: Engine, record: SpineTextureLoadRecord): void;
/**
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {TextureDefaultView} texture
*/
export function spine_texture_record(cmds: CommandsExchangeSpine, id_renderer: number, texture: TextureDefaultView): void;
/**
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {number} key
*/
export function spine_remove_texture(cmds: CommandsExchangeSpine, id_renderer: number, key: number): void;
/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {TextureDefaultView} texture
* @param {number} address_mode_u
* @param {number} address_mode_v
* @param {number} address_mode_w
* @param {number} mag_filter
* @param {number} min_filter
* @param {number} mipmap_filter
*/
export function spine_use_texture(app: Engine, cmds: CommandsExchangeSpine, id_renderer: number, texture: TextureDefaultView, address_mode_u: number, address_mode_v: number, address_mode_w: number, mag_filter: number, min_filter: number, mipmap_filter: number): void;
/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {KeySpineShader} shader
*/
export function spine_shader(app: Engine, cmds: CommandsExchangeSpine, id_renderer: number, shader: KeySpineShader): void;
/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {boolean} val
*/
export function spine_blend(app: Engine, cmds: CommandsExchangeSpine, id_renderer: number, val: boolean): void;
/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {number} src
* @param {number} dst
*/
export function spine_blend_mode(app: Engine, cmds: CommandsExchangeSpine, id_renderer: number, src: number, dst: number): void;
/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {Float32Array} val
*/
export function spine_uniform(app: Engine, cmds: CommandsExchangeSpine, id_renderer: number, val: Float32Array): void;
/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {Float32Array} vertices
* @param {Uint16Array} indices
* @param {number} vlen
* @param {number} ilen
*/
export function spine_draw(app: Engine, cmds: CommandsExchangeSpine, id_renderer: number, vertices: Float32Array, indices: Uint16Array, vlen: number, ilen: number): void;
/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
*/
export function spine_reset(app: Engine, cmds: CommandsExchangeSpine, id_renderer: number): void;
/**
*/
export function bon_debug(): void;
/**
* @param {Uint8Array} data
* @returns {Uint8Array}
*/
export function decompress_br(data: Uint8Array): Uint8Array;
/**
* @returns {Uint8Array}
*/
export function test_uint8array(): Uint8Array;
/**
* @returns {Map<any, any>}
*/
export function test_map(): Map<any, any>;
/**
* @returns {Array<any>}
*/
export function test_arr(): Array<any>;
/**
* @returns {object}
*/
export function test_obj(): object;
/**
* @returns {ConfigMgr}
*/
export function test_mgr(): ConfigMgr;
/**
*/
export enum TileFlagType {
  All = 0,
  Center = 1,
  Right = 2,
  Down = 4,
}
/**
* Initializes the global logger setting `max_log_level` to the given value.
*/
export enum Level {
/**
* The "error" level.
*
* Designates very serious errors.
*/
  Error = 1,
/**
* The "warn" level.
*
* Designates hazardous situations.
*/
  Warn = 2,
/**
* The "info" level.
*
* Designates useful information.
*/
  Info = 3,
/**
* The "debug" level.
*
* Designates lower priority information.
*/
  Debug = 4,
/**
* The "trace" level.
*
* Designates very low priority, often extremely verbose, information.
*/
  Trace = 5,
}
/**
*/
export enum EAnimationGroupListen {
  Start = 0,
  End = 1,
  Loop = 2,
  Frame = 3,
}
/**
* blocks.regist::<(.*)>\(\);
*/
export enum BuiltinNodeMaterialBlock {
  BlockFloat = 0,
  BlockViewDirection = 1,
  BlockColorSpace = 2,
  BlockColorGray = 3,
  BlockColorHSV = 4,
  BlockTextureChannel = 5,
  BlockUVOffsetSpeed = 6,
  BlockFog = 7,
  BlockCutoff = 8,
  BlockMainTexture = 9,
  BlockMainTextureUVOffsetSpeed = 10,
  BlockOpacity = 11,
  BlockOpacityTexture = 12,
  BlockOpacityTextureUVOffsetSpeed = 13,
  BlockOpacity2Texture = 14,
  BlockOpacity2TextureUVOffsetSpeed = 15,
  BlockEmissiveTexture = 16,
  BlockEmissiveTextureUVOffsetSpeed = 17,
  BlockMixTexture = 18,
  BlockMixTextureUVOffsetSpeed = 19,
  BlockMaskTexture = 20,
  BlockMaskTextureUVOffsetSpeed = 21,
  BlockFresnel = 22,
  BlockEmissiveFresnel = 23,
  BlockOpacityFresnel = 24,
  BlockPremultiplyResult = 25,
}
/**
*/
export enum EAnimePropertyID {
  LocalPosition = 0,
  LocalRotation = 1,
  LocalScaling = 2,
  MainTexUScale = 3,
  MainTexVScale = 4,
  MainTexUOffset = 5,
  MainTexVOffset = 6,
  Alpha = 7,
  MainColor = 8,
  CameraOrthSize = 9,
  CameraFov = 10,
  Enable = 11,
  LocalEulerAngles = 12,
  Intensity = 13,
  LightDiffuse = 14,
  AlphaCutoff = 15,
  CellId = 16,
  OpacityTexUScale = 17,
  OpacityTexVScale = 18,
  OpacityTexUOffset = 19,
  OpacityTexVOffset = 20,
  MaskCutoff = 21,
  MaskTexUScale = 22,
  MaskTexVScale = 23,
  MaskTexUOffset = 24,
  MaskTexVOffset = 25,
  MainTexTilloff = 50,
  MaskTexTilloff = 51,
  OpacityTexTilloff = 52,
  BoneOffset = 100,
  IndicesRange = 101,
}
/**
*/
export enum EAmountMode {
  None = 0,
  BackIn = 1,
  BackOut = 2,
  BackInOut = 3,
  CircleIn = 4,
  CircleOut = 5,
  CircleInOut = 6,
  CubicIn = 7,
  CubicOut = 8,
  CubicInOut = 9,
  SineIn = 10,
  SineOut = 11,
  SineInOut = 12,
  QuadIn = 13,
  QuadOut = 14,
  QuadInOut = 15,
  QuartIn = 16,
  QuartOut = 17,
  QuartInOut = 18,
  QuintIn = 19,
  QuintOut = 20,
  QuintInOut = 21,
  ExpoIn = 22,
  ExpoOut = 23,
  ExpoInOut = 24,
  ElasticIn = 25,
  ElasticOut = 26,
  ElasticInOut = 27,
  BounceIn = 28,
  BounceOut = 29,
  BounceInOut = 30,
  JumpStart = 31,
  JumpEnd = 32,
  JumpNone = 33,
  JumpBoth = 34,
  CubicBezier = 35,
}
/**
*/
export enum ELoopMode {
/**
* 不循环
*/
  Not = 0,
/**
* 正向循环
* * 指定循环次数 - None 无限循环
*/
  Positive = 1,
/**
* 反向循环
* * 指定循环次数 - None 无限循环
*/
  Opposite = 2,
/**
* 正向反复循环
* * 指定循环次数 - None 无限循环
*/
  PositivePly = 3,
/**
* 反向反复循环
* * 指定循环次数 - None 无限循环
*/
  OppositePly = 4,
}
/**
*/
export enum EFillMode {
  None = 0,
  Forwards = 1,
  Backwards = 2,
  Both = 3,
}
/**
*/
export enum TraceOption {
  None = 0,
  Record = 1,
  Play = 2,
}
/**
*/
export enum BlendMode {
  Normal = 0,
  AlphaAdd = 1,
  Subtract = 2,
  Multiply = 3,
  OneOne = 4,
}
/**
*/
export enum KeySpineShader {
  Colored = 0,
  ColoredTextured = 1,
  TwoColoredTextured = 2,
}
/**
*/
export enum Direction {
  Left = 0,
  Right = 1,
  Up = 2,
  Down = 3,
}
/**
*/
export enum EAnimeCurve {
  FrameValues = 0,
  FrameValuesStep = 1,
  EasingCurve = 2,
  MinMaxCurve = 3,
  CubicBezierCurve = 4,
  GLTFCubicSpline = 5,
}
/**
*/
export class AStar {
  free(): void;
/**
* @param {number} width
* @param {number} height
* @param {number} node_number
* @returns {AStar}
*/
  static new(width: number, height: number, node_number: number): AStar;
/**
* @param {TileMap} tile_map
* @param {number} max_number
* @param {number} start
* @param {number} end
* @param {number} center_flag
* @param {number} side_flag
* @returns {number | undefined}
*/
  find_path(tile_map: TileMap, max_number: number, start: number, end: number, center_flag: number, side_flag: number): number | undefined;
/**
* @param {number} node
* @param {TileMap} tile_map
* @param {number} center_flag
* @param {number} side_flag
*/
  result(node: number, tile_map: TileMap, center_flag: number, side_flag: number): void;
}
/**
*/
export class ActionSetScene3D {
  free(): void;
/**
* @param {Engine} app
* @returns {ActionSetScene3D}
*/
  static create(app: Engine): ActionSetScene3D;
}
/**
*/
export class Atom {
  free(): void;
/**
* @param {string} value
* @returns {Atom}
*/
  static from_string(value: string): Atom;
/**
* @param {number} value
* @returns {string | undefined}
*/
  static get_string_by_hash(value: number): string | undefined;
/**
* @returns {number}
*/
  get_hash(): number;
}
/**
*/
export class CharPos {
  free(): void;
/**
* @returns {number}
*/
  index(): number;
/**
* @returns {number}
*/
  x(): number;
/**
* @returns {number}
*/
  y(): number;
}
/**
*/
export class CommandsExchangeD3 {
  free(): void;
/**
* @returns {CommandsExchangeD3}
*/
  static create(): CommandsExchangeD3;
}
/**
*/
export class CommandsExchangeSpine {
  free(): void;
/**
* @returns {CommandsExchangeSpine}
*/
  static create(): CommandsExchangeSpine;
}
/**
*/
export class ConfigMgr {
  free(): void;
/**
* @param {number} cache_size
* @param {number} timeout
* @returns {ConfigMgr}
*/
  static init(cache_size: number, timeout: number): ConfigMgr;
/**
* @param {Uint8Array} buffer
*/
  add_buffer(buffer: Uint8Array): void;
/**
* @param {number} tab
* @param {any} key
* @returns {any}
*/
  get_config(tab: number, key: any): any;
/**
* @param {number} tab
* @returns {string | undefined}
*/
  get_struct_info(tab: number): string | undefined;
/**
* @param {number} tab
* @returns {any}
*/
  get_tab(tab: number): any;
/**
* @param {number} tab
* @param {any} key
* @returns {boolean}
*/
  get_config_buffer(tab: number, key: any): boolean;
/**
* @param {number} tab
* @returns {TabBuffer | undefined}
*/
  get_tab_buffer(tab: number): TabBuffer | undefined;
/**
* @param {number} tab
* @returns {any}
*/
  get_keys(tab: number): any;
/**
* @param {number} tab
* @returns {any}
*/
  get_infos(tab: number): any;
}
/**
*/
export class DataTextureRes {
  free(): void;
}
/**
*/
export class Engine {
  free(): void;
}
/**
*/
export class GLTFRes {
  free(): void;
}
/**
*/
export class GeometryMeta {
  free(): void;
/**
* @returns {GeometryMeta}
*/
  static create_empty(): GeometryMeta;
/**
* @returns {GeometryMeta}
*/
  static create_box(): GeometryMeta;
/**
* @returns {GeometryMeta}
*/
  static create_quad(): GeometryMeta;
}
/**
*/
export class Gui {
  free(): void;
}
/**
*/
export class ImageRes {
  free(): void;
}
/**
*/
export class MaterialUniformDefines {
  free(): void;
/**
* @returns {MaterialUniformDefines}
*/
  static create(): MaterialUniformDefines;
}
/**
*/
export class NodeMaterialBlock {
  free(): void;
/**
* @param {Atom} key
* @param {string} vs_define
* @param {string} vs_surface
* @param {string} fs_define
* @param {string} fs_surface
* @param {number | undefined} [bind_defines]
* @returns {NodeMaterialBlock}
*/
  static create(key: Atom, vs_define: string, vs_surface: string, fs_define: string, fs_surface: string, bind_defines?: number): NodeMaterialBlock;
}
/**
*/
export class NodematerialIncludes {
  free(): void;
/**
* @returns {NodematerialIncludes}
*/
  static create(): NodematerialIncludes;
}
/**
*/
export class P3DShaderMeta {
  free(): void;
}
/**
*/
export class P3DShaderVaryings {
  free(): void;
/**
* @returns {P3DShaderVaryings}
*/
  static create(): P3DShaderVaryings;
}
/**
*/
export class PTextureFrameAtlas {
  free(): void;
}
/**
*/
export class QuadTree {
  free(): void;
/**
* @returns {QuadTree}
*/
  static default(): QuadTree;
/**
* @param {number} min_x
* @param {number} min_y
* @param {number} max_x
* @param {number} max_y
* @param {number} min_loose_x
* @param {number} min_loose_y
* @param {number} max_loose_x
* @param {number} max_loose_y
* @returns {QuadTree}
*/
  static new(min_x: number, min_y: number, max_x: number, max_y: number, min_loose_x: number, min_loose_y: number, max_loose_x: number, max_loose_y: number): QuadTree;
/**
* @param {number} min_x
* @param {number} min_y
* @param {number} max_x
* @param {number} max_y
* @returns {number}
*/
  add(min_x: number, min_y: number, max_x: number, max_y: number): number;
/**
* @param {number} id
*/
  remove(id: number): void;
/**
* @param {number} id
* @param {number} min_x
* @param {number} min_y
* @param {number} max_x
* @param {number} max_y
*/
  update(id: number, min_x: number, min_y: number, max_x: number, max_y: number): void;
/**
* @param {number} min_x
* @param {number} min_y
* @param {number} max_x
* @param {number} max_y
* @returns {Float64Array}
*/
  query(min_x: number, min_y: number, max_x: number, max_y: number): Float64Array;
/**
* @param {number} min_x
* @param {number} min_y
* @param {number} max_x
* @param {number} max_y
* @param {Float64Array} result
* @param {number} max_len
* @returns {number}
*/
  query_max(min_x: number, min_y: number, max_x: number, max_y: number, result: Float64Array, max_len: number): number;
}
/**
*/
export class RVOSimulator {
  free(): void;
/**
* @param {number} time_step
* @param {number} neighbor_dist
* @param {number} max_neighbors
* @param {number} time_horizon
* @param {number} time_horizon_obst
* @param {number} radius
* @param {number} max_speed
* @param {number} velocity_x
* @param {number} velocity_y
* @param {number} rng_seed
* @returns {RVOSimulator}
*/
  static new(time_step: number, neighbor_dist: number, max_neighbors: number, time_horizon: number, time_horizon_obst: number, radius: number, max_speed: number, velocity_x: number, velocity_y: number, rng_seed: number): RVOSimulator;
/**
* @returns {RVOSimulator}
*/
  static default(): RVOSimulator;
/**
* @param {number} position_x
* @param {number} position_y
* @param {number} speed
* @returns {number}
*/
  add_agent(position_x: number, position_y: number, speed: number): number;
/**
* @param {number} position_x
* @param {number} position_y
* @param {number} neighbor_dist
* @param {number} max_neighbors
* @param {number} time_horizon
* @param {number} time_horizon_obst
* @param {number} radius
* @param {number} max_speed
* @param {number} velocity_x
* @param {number} velocity_y
* @returns {number}
*/
  add_agent2(position_x: number, position_y: number, neighbor_dist: number, max_neighbors: number, time_horizon: number, time_horizon_obst: number, radius: number, max_speed: number, velocity_x: number, velocity_y: number): number;
/**
* @param {number} id
* @returns {boolean}
*/
  remove_agent(id: number): boolean;
/**
*
*     * @brief 为模拟添加新障碍。
*     * @param[in] vertices 逆时针顺序排列的多边形障碍物的顶点列表。
*     * @return 障碍物第一个顶点的编号，当顶点数小于2时为返回usize::MAX。
*     * @note 要添加“负面”障碍，例如环境周围的边界多边形，顶点应按顺时针顺序列出。
*     
* @param {Float32Array} vertices
* @returns {number}
*/
  add_obstacle(vertices: Float32Array): number;
/**
* @param {number} id
* @returns {boolean}
*/
  remove_obstacle(id: number): boolean;
/**
* @returns {boolean}
*/
  do_step(): boolean;
/**
*
*    * @brief     为添加的任何新代理设置默认属性。
*    * @param[in] neighborDist    新代理在导航中考虑的默认最大中心点到中心点到其他代理的最大距离。
*                                 这个数字越大，模拟的运行时间就越长。
*                                 如果数字太低，模拟将不安全。
*                                 必须是非负数。
*    * @param[in] maxNeighbors    新代理在导航中考虑的默认最大其他代理数。
*                                 这个数字越大，模拟的运行时间越长。
*                                 如果数字太低，模拟将不安全。
*    * @param[in] timeHorizon     模拟计算的新代理速度相对于其他代理安全的默认最小时间量。
*                                 这个数字越大，代理就会越快响应其他代理的存在，但代理在选择速度方面的自由度就越小。
*                                 必须是正数。
*    * @param[in] timeHorizonObst 通过模拟计算的新代理的速度相对于障碍物是安全的默认最小时间量。
*                                 这个数字越大，代理越快响应障碍的存在，但代理的自由度越低 选择它的速度。
*                                 必须是正数。
*    * @param[in] radius          新代理的默认半径。 必须是非负数。
*    * @param[in] maxSpeed        新代理的默认最大速度。 必须是非负数。
*    
* @param {number} neighbor_dist
* @param {number} max_neighbors
* @param {number} time_horizon
* @param {number} time_horizon_obst
* @param {number} radius
* @param {number} max_speed
* @param {number} velocity_x
* @param {number} velocity_y
*/
  set_agent_defaults(neighbor_dist: number, max_neighbors: number, time_horizon: number, time_horizon_obst: number, radius: number, max_speed: number, velocity_x: number, velocity_y: number): void;
/**
* @param {number} agent_no
* @param {number} neighbor_no
* @returns {number | undefined}
*/
  get_agent_agent_neighbor(agent_no: number, neighbor_no: number): number | undefined;
/**
* @param {number} agent_no
* @returns {number | undefined}
*/
  get_agent_max_neighbors(agent_no: number): number | undefined;
/**
* @param {number} agent_no
* @returns {number | undefined}
*/
  get_agent_max_speed(agent_no: number): number | undefined;
/**
* @param {number} agent_no
* @returns {number | undefined}
*/
  get_agent_neighbor_dist(agent_no: number): number | undefined;
/**
* @param {number} agent_no
* @returns {number | undefined}
*/
  get_agent_num_agent_neighbors(agent_no: number): number | undefined;
/**
* @param {number} agent_no
* @returns {number | undefined}
*/
  get_agent_num_obstacle_neighbors(agent_no: number): number | undefined;
/**
* @param {number} agent_no
* @returns {number | undefined}
*/
  get_agent_num_orcalines(agent_no: number): number | undefined;
/**
* @param {number} agent_no
* @param {number} neighbor_no
* @returns {number | undefined}
*/
  get_agent_obstacle_neighbor(agent_no: number, neighbor_no: number): number | undefined;
/**
* @param {number} agent_no
* @returns {any}
*/
  get_agent_position(agent_no: number): any;
/**
* @param {number} agent_no
* @returns {any}
*/
  get_agent_pref_velocity(agent_no: number): any;
/**
* @param {number} agent_no
* @returns {number | undefined}
*/
  get_agent_radius(agent_no: number): number | undefined;
/**
* @param {number} agent_no
* @returns {number | undefined}
*/
  get_agent_time_horizon(agent_no: number): number | undefined;
/**
* @param {number} agent_no
* @returns {number | undefined}
*/
  get_agent_time_horizon_obst(agent_no: number): number | undefined;
/**
* @param {number} agent_no
* @returns {any}
*/
  get_agent_velocity(agent_no: number): any;
/**
* @returns {number}
*/
  get_global_time(): number;
/**
* @returns {number}
*/
  get_num_agents(): number;
/**
* @returns {number}
*/
  get_num_obstacle_vertices(): number;
/**
* @param {number} vertex_no
* @returns {any}
*/
  get_obstacle_vertex(vertex_no: number): any;
/**
* @param {number} vertex_no
* @returns {number | undefined}
*/
  get_next_obstacle_vertex_no(vertex_no: number): number | undefined;
/**
* @param {number} vertex_no
* @returns {number | undefined}
*/
  get_prev_obstacle_vertex_no(vertex_no: number): number | undefined;
/**
* @returns {number}
*/
  get_time_step(): number;
/**
* @param {number} agent_no
* @param {number} max_neighbors
* @returns {boolean}
*/
  set_agent_max_neighbors(agent_no: number, max_neighbors: number): boolean;
/**
* @param {number} agent_no
* @param {number} max_speed
* @returns {boolean}
*/
  set_agent_max_speed(agent_no: number, max_speed: number): boolean;
/**
* @param {number} agent_no
* @param {number} neighbor_dist
* @returns {boolean}
*/
  set_agent_neighbor_dist(agent_no: number, neighbor_dist: number): boolean;
/**
* @param {number} agent_no
* @param {number} position_x
* @param {number} position_y
* @returns {boolean}
*/
  set_agent_position(agent_no: number, position_x: number, position_y: number): boolean;
/**
* @param {number} agent_no
* @param {number} pref_velocity_x
* @param {number} pref_velocity_y
* @returns {boolean}
*/
  set_agent_pref_velocity(agent_no: number, pref_velocity_x: number, pref_velocity_y: number): boolean;
/**
* @param {number} agent_no
* @param {number} radius
* @returns {boolean}
*/
  set_agent_radius(agent_no: number, radius: number): boolean;
/**
* @param {number} agent_no
* @param {number} time_horizon
* @returns {boolean}
*/
  set_agent_time_horizon(agent_no: number, time_horizon: number): boolean;
/**
* @param {number} agent_no
* @param {number} time_horizon_obst
* @returns {boolean}
*/
  set_agent_time_horizon_obst(agent_no: number, time_horizon_obst: number): boolean;
/**
* @param {number} agent_no
* @param {number} velocity_x
* @param {number} velocity_y
* @returns {boolean}
*/
  set_agent_velocity(agent_no: number, velocity_x: number, velocity_y: number): boolean;
/**
* @param {number} time_step
*/
  set_time_step(time_step: number): void;
/**
*
*     * @brief     为代理设置目标点。
*     * @param[in] agent_no   代理id
*     * @param[in] goal       目标点
*     * @return 设置成功返回true，失败返回false。
*     
* @param {number} agent_no
* @param {number | undefined} [goal_x]
* @param {number | undefined} [goal_y]
* @returns {boolean}
*/
  set_agent_goal(agent_no: number, goal_x?: number, goal_y?: number): boolean;
/**
*
*     * @brief     为代理设置自定义速度。
*     * @param[in] agent_no   代理id
*     * @param[in] speed      速度，应该小于代理的最大速度，否则使用最大速度。
*     * @return 设置成功返回true，失败返回false。
*     
* @param {number} agent_no
* @param {number} speed
* @returns {boolean}
*/
  set_agent_custom_speed(agent_no: number, speed: number): boolean;
/**
* @param {number} agent_no
* @returns {any}
*/
  get_agent_goal(agent_no: number): any;
/**
* @param {number} agent_no
* @returns {number | undefined}
*/
  get_agent_custom_speed(agent_no: number): number | undefined;
/**
* @param {number} seed
*/
  set_rng_seed(seed: number): void;
/**
* @param {number} agent_no
* @param {number} line_no
* @returns {any}
*/
  get_agent_orcaline(agent_no: number, line_no: number): any;
/**
* 设置代理的质量; 1.0为默认值, 必须大于0
* @param {number} agent_no
* @param {number} quality
* @returns {boolean}
*/
  set_agent_quality(agent_no: number, quality: number): boolean;
/**
* 获取代理的质量
* @param {number} agent_no
* @returns {number | undefined}
*/
  get_agent_quality(agent_no: number): number | undefined;
}
/**
* 资源管理器
*/
export class ResAllocator {
  free(): void;
/**
* 创建资源管理器的实例
* @param {number} total_capacity
* @returns {ResAllocator}
*/
  static new(total_capacity: number): ResAllocator;
/**
* 整理方法， 将无人使用的资源放入到LruCache， 清理过时的资源
* 就是LruMgr有总内存上限， 按权重分给其下的LRU。 如果有LRU有空闲， 则会减少其max_size, 按权重提高那些满的LRU的max_size
*/
  collect(): void;
/**
* 创建一个资源， 如果资源已经存在，则会修改资源的配置
* @param {number} ty
* @param {number} min_capacity
* @param {number} weight
* @param {number} time_out
* @returns {ResMgr}
*/
  register_to_resmgr(ty: number, min_capacity: number, weight: number, time_out: number): ResMgr;
/**
* @returns {number}
*/
  size(): number;
/**
* @returns {string}
*/
  account_details(): string;
}
/**
*/
export class ResHandle {
  free(): void;
}
/**
* 资源管理器
*/
export class ResMgr {
  free(): void;
/**
* 创建一个资源， 如果资源已经存在，旧的资源将被覆盖
* 如果创建的资源类型未注册，将崩溃
* @param {number} key
* @param {number} cost
* @returns {ResRef}
*/
  create_res(key: number, cost: number): ResRef;
/**
* 获取资源
* @param {number} key
* @returns {ResRef | undefined}
*/
  get_res(key: number): ResRef | undefined;
}
/**
* 资源包装
*/
export class ResRef {
  free(): void;
}
/**
*/
export class ResTextureFrameAtlas {
  free(): void;
}
/**
*/
export class SpineTextureLoadRecord {
  free(): void;
/**
* @returns {SpineTextureLoadRecord}
*/
  static new(): SpineTextureLoadRecord;
/**
* @param {Atom} key
* @returns {TextureDefaultView | undefined}
*/
  success(key: Atom): TextureDefaultView | undefined;
/**
* @param {Atom} key
* @returns {string | undefined}
*/
  fail(key: Atom): string | undefined;
/**
*/
  clear(): void;
}
/**
*/
export class TabBuffer {
  free(): void;
/**
* @returns {boolean}
*/
  next(): boolean;
/**
* @returns {boolean}
*/
  next_tab(): boolean;
}
/**
*/
export class TextureDefaultView {
  free(): void;
}
/**
*/
export class TileMap {
  free(): void;
/**
* @param {number} width
* @param {number} height
* @returns {TileMap}
*/
  static new(width: number, height: number): TileMap;
/**
* @param {number} index
* @param {TileFlagType} flag_type
* @param {number} value
* @returns {number}
*/
  set_node_flag(index: number, flag_type: TileFlagType, value: number): number;
/**
* @param {number} index
* @param {TileFlagType} flag_type
* @returns {number}
*/
  get_node_flag(index: number, flag_type: TileFlagType): number;
/**
* @param {number} x1
* @param {number} y1
* @param {number} x2
* @param {number} y2
* @param {number} value
*/
  set_range_flag(x1: number, y1: number, x2: number, y2: number, value: number): void;
/**
* @param {number} index
* @param {number} count
* @param {number} spacing
* @param {Direction} d
* @param {number} flag
* @returns {any}
*/
  find_round(index: number, count: number, spacing: number, d: Direction, flag: number): any;
/**
* @param {number} index
* @param {number} count
* @param {number} spacing
* @param {Direction} d
* @param {number} flag
* @param {number} target_x
* @param {number} target_y
* @returns {any}
*/
  find_round_and_sort_by_dist(index: number, count: number, spacing: number, d: Direction, flag: number, target_x: number, target_y: number): any;
/**
* @param {number} start_x
* @param {number} start_y
* @param {number} end_x
* @param {number} end_y
* @param {number} center_flag
* @param {number} side_flag
* @returns {any}
*/
  test_line(start_x: number, start_y: number, end_x: number, end_y: number, center_flag: number, side_flag: number): any;
}
/**
*/
export class TileMapTree {
  free(): void;
/**
* @param {number} min_x
* @param {number} min_y
* @param {number} max_x
* @param {number} max_y
* @param {number} width
* @param {number} height
* @returns {TileMapTree}
*/
  static new(min_x: number, min_y: number, max_x: number, max_y: number, width: number, height: number): TileMapTree;
/**
* @param {number} min_x
* @param {number} min_y
* @param {number} max_x
* @param {number} max_y
* @returns {number}
*/
  add(min_x: number, min_y: number, max_x: number, max_y: number): number;
/**
* @param {number} id
*/
  remove(id: number): void;
/**
* @param {number} id
* @param {number} min_x
* @param {number} min_y
* @param {number} max_x
* @param {number} max_y
*/
  update(id: number, min_x: number, min_y: number, max_x: number, max_y: number): void;
/**
* @param {number} min_x
* @param {number} min_y
* @param {number} max_x
* @param {number} max_y
* @returns {Uint32Array}
*/
  query(min_x: number, min_y: number, max_x: number, max_y: number): Uint32Array;
}
/**
*/
export class VBMeta {
  free(): void;
/**
* @param {string} name
* @param {number | undefined} [start]
* @param {number | undefined} [end]
* @returns {VBMeta}
*/
  static create(name: string, start?: number, end?: number): VBMeta;
}
/**
*/
export class VInstanceAttributes {
  free(): void;
/**
* @param {boolean} instane_matrix
* @returns {VInstanceAttributes}
*/
  static create(instane_matrix: boolean): VInstanceAttributes;
}
/**
*/
export class VertexBufferRes {
  free(): void;
}

export type InitInput = RequestInfo | URL | Response | BufferSource | WebAssembly.Module;

export interface InitOutput {
  readonly memory: WebAssembly.Memory;
  readonly get_counters: (a: number) => void;
  readonly init_logger: (a: number) => void;
  readonly decompress_br: (a: number, b: number, c: number) => void;
  readonly __wbg_tabbuffer_free: (a: number) => void;
  readonly tabbuffer_next: (a: number) => number;
  readonly tabbuffer_next_tab: (a: number) => number;
  readonly __wbg_configmgr_free: (a: number) => void;
  readonly configmgr_init: (a: number, b: number) => number;
  readonly configmgr_add_buffer: (a: number, b: number, c: number) => void;
  readonly configmgr_get_config: (a: number, b: number, c: number) => number;
  readonly configmgr_get_struct_info: (a: number, b: number, c: number) => void;
  readonly configmgr_get_tab: (a: number, b: number) => number;
  readonly configmgr_get_config_buffer: (a: number, b: number, c: number) => number;
  readonly configmgr_get_tab_buffer: (a: number, b: number) => number;
  readonly configmgr_get_keys: (a: number, b: number) => number;
  readonly configmgr_get_infos: (a: number, b: number) => number;
  readonly test_uint8array: () => number;
  readonly test_map: () => number;
  readonly test_arr: () => number;
  readonly test_obj: () => number;
  readonly test_mgr: () => number;
  readonly bon_debug: () => void;
  readonly __wbg_rvosimulator_free: (a: number) => void;
  readonly rvosimulator_new: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number) => number;
  readonly rvosimulator_default: () => number;
  readonly rvosimulator_add_agent: (a: number, b: number, c: number, d: number) => number;
  readonly rvosimulator_add_agent2: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number) => number;
  readonly rvosimulator_remove_agent: (a: number, b: number) => number;
  readonly rvosimulator_add_obstacle: (a: number, b: number, c: number) => number;
  readonly rvosimulator_remove_obstacle: (a: number, b: number) => number;
  readonly rvosimulator_do_step: (a: number) => number;
  readonly rvosimulator_set_agent_defaults: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number) => void;
  readonly rvosimulator_get_agent_agent_neighbor: (a: number, b: number, c: number, d: number) => void;
  readonly rvosimulator_get_agent_max_neighbors: (a: number, b: number, c: number) => void;
  readonly rvosimulator_get_agent_max_speed: (a: number, b: number, c: number) => void;
  readonly rvosimulator_get_agent_neighbor_dist: (a: number, b: number, c: number) => void;
  readonly rvosimulator_get_agent_num_agent_neighbors: (a: number, b: number, c: number) => void;
  readonly rvosimulator_get_agent_num_obstacle_neighbors: (a: number, b: number, c: number) => void;
  readonly rvosimulator_get_agent_num_orcalines: (a: number, b: number, c: number) => void;
  readonly rvosimulator_get_agent_obstacle_neighbor: (a: number, b: number, c: number, d: number) => void;
  readonly rvosimulator_get_agent_position: (a: number, b: number) => number;
  readonly rvosimulator_get_agent_pref_velocity: (a: number, b: number) => number;
  readonly rvosimulator_get_agent_radius: (a: number, b: number, c: number) => void;
  readonly rvosimulator_get_agent_time_horizon: (a: number, b: number, c: number) => void;
  readonly rvosimulator_get_agent_velocity: (a: number, b: number) => number;
  readonly rvosimulator_get_global_time: (a: number) => number;
  readonly rvosimulator_get_num_agents: (a: number) => number;
  readonly rvosimulator_get_num_obstacle_vertices: (a: number) => number;
  readonly rvosimulator_get_obstacle_vertex: (a: number, b: number) => number;
  readonly rvosimulator_get_next_obstacle_vertex_no: (a: number, b: number, c: number) => void;
  readonly rvosimulator_get_prev_obstacle_vertex_no: (a: number, b: number, c: number) => void;
  readonly rvosimulator_get_time_step: (a: number) => number;
  readonly rvosimulator_set_agent_max_neighbors: (a: number, b: number, c: number) => number;
  readonly rvosimulator_set_agent_max_speed: (a: number, b: number, c: number) => number;
  readonly rvosimulator_set_agent_neighbor_dist: (a: number, b: number, c: number) => number;
  readonly rvosimulator_set_agent_position: (a: number, b: number, c: number, d: number) => number;
  readonly rvosimulator_set_agent_pref_velocity: (a: number, b: number, c: number, d: number) => number;
  readonly rvosimulator_set_agent_radius: (a: number, b: number, c: number) => number;
  readonly rvosimulator_set_agent_time_horizon: (a: number, b: number, c: number) => number;
  readonly rvosimulator_set_agent_time_horizon_obst: (a: number, b: number, c: number) => number;
  readonly rvosimulator_set_agent_velocity: (a: number, b: number, c: number, d: number) => number;
  readonly rvosimulator_set_time_step: (a: number, b: number) => void;
  readonly rvosimulator_set_agent_goal: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly rvosimulator_set_agent_custom_speed: (a: number, b: number, c: number) => number;
  readonly rvosimulator_get_agent_goal: (a: number, b: number) => number;
  readonly rvosimulator_get_agent_custom_speed: (a: number, b: number, c: number) => void;
  readonly rvosimulator_set_rng_seed: (a: number, b: number) => void;
  readonly rvosimulator_get_agent_orcaline: (a: number, b: number, c: number) => number;
  readonly rvosimulator_set_agent_quality: (a: number, b: number, c: number) => number;
  readonly rvosimulator_get_agent_quality: (a: number, b: number, c: number) => void;
  readonly rvosimulator_get_agent_time_horizon_obst: (a: number, b: number, c: number) => void;
  readonly __wbg_tilemap_free: (a: number) => void;
  readonly tilemap_new: (a: number, b: number) => number;
  readonly tilemap_set_node_flag: (a: number, b: number, c: number, d: number) => number;
  readonly tilemap_get_node_flag: (a: number, b: number, c: number) => number;
  readonly tilemap_set_range_flag: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly tilemap_find_round: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly tilemap_find_round_and_sort_by_dist: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => number;
  readonly tilemap_test_line: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => number;
  readonly __wbg_astar_free: (a: number) => void;
  readonly astar_new: (a: number, b: number, c: number) => number;
  readonly astar_find_path: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => void;
  readonly astar_result: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly __wbg_imageres_free: (a: number) => void;
  readonly p3d_device_limis: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_init_engine: (a: number) => void;
  readonly __wbg_actionsetscene3d_free: (a: number) => void;
  readonly actionsetscene3d_create: (a: number) => number;
  readonly p3d_entity: (a: number) => number;
  readonly p3d_dispose: (a: number, b: number) => void;
  readonly p3d_scene_dispose: (a: number, b: number) => void;
  readonly p3d_lighting_shadow_limit: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number) => void;
  readonly p3d_render_graphic: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_query_world_matrix: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_query_scene_state: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_engine_state: (a: number, b: number, c: number) => void;
  readonly p3d_engine_debug: (a: number, b: number, c: number) => void;
  readonly p3d_query_performance_state: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_query_resource_state: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_query_resource_memory: (a: number, b: number, c: number, d: number, e: number) => number;
  readonly p3d_material_state: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_mesh_state: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_transform_state: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_query_transform_state: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => number;
  readonly p3d_camera_state: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_texture_loader_state: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_errors: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_global_state: (a: number, b: number, c: number) => void;
  readonly p3d_query_local_matrix: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_query_view_matrix: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_query_project_matrix: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_query_viewproject_matrix: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly __wbg_gltfres_free: (a: number) => void;
  readonly p3d_gltf_val: (a: number, b: number) => void;
  readonly p3d_animation_curve_id_bygltf: (a: number, b: number, c: number) => number;
  readonly p3d_create_gltf_load: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_query_gltf_load: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => void;
  readonly p3d_get_gltf: (a: number, b: number, c: number) => number;
  readonly p3d_get_gltf_fail_reason: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_create_image_load: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_query_image_load: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => void;
  readonly p3d_get_image: (a: number, b: number, c: number) => number;
  readonly p3d_get_image_fail_reason: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_query_children: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_query_mesh_info: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_query_material_info: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_scene: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_scene_animation_enable: (a: number, b: number, c: number) => void;
  readonly p3d_scene_time: (a: number, b: number, c: number) => void;
  readonly p3d_scene_fogcolor: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_scene_fogparam: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_scene_ambientcolor: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_scene_ambientintensity: (a: number, b: number, c: number) => void;
  readonly p3d_layermask: (a: number, b: number, c: number) => void;
  readonly p3d_scene_brdf_texture: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_scene_env_texture: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_scene_shadowmap: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_scene_boundingbox: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_collider: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number) => void;
  readonly p3d_create_pickingray: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => number;
  readonly p3d_scene_pick: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number) => number;
  readonly p3d_transform_node: (a: number, b: number, c: number) => number;
  readonly p3d_transform_node_parent: (a: number, b: number, c: number) => void;
  readonly p3d_transform_node_parent_arr: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_node_enable: (a: number, b: number, c: number) => void;
  readonly p3d_node_enable_arr: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_local_position: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_local_position_arr: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_local_scaling: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_local_scaling_arr: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_local_euler: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_local_euler_arr: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_local_quaternion: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_local_quaternion_arr: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_camera: (a: number, b: number, c: number) => number;
  readonly p3d_camera_size: (a: number, b: number, c: number) => void;
  readonly p3d_camera_fov: (a: number, b: number, c: number) => void;
  readonly p3d_camera_active: (a: number, b: number, c: number) => void;
  readonly p3d_camera_mode: (a: number, b: number, c: number) => void;
  readonly p3d_camera_fixed_mode: (a: number, b: number, c: number) => void;
  readonly p3d_camera_target: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_camera_nearfar: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_camera_aspect: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_viewer_force_include: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_create_render: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => number;
  readonly p3d_render_target_key: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_render_target_auto: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_render_auto_clear_color: (a: number, b: number, c: number) => void;
  readonly p3d_render_auto_clear_depth: (a: number, b: number, c: number) => void;
  readonly p3d_render_auto_clear_stencil: (a: number, b: number, c: number) => void;
  readonly p3d_render_clear_color: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_render_clear_depth: (a: number, b: number, c: number) => void;
  readonly p3d_render_clear_stencil: (a: number, b: number, c: number) => void;
  readonly p3d_render_viewport: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_create_render_target: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number) => void;
  readonly p3d_dispose_render_target: (a: number, b: number, c: number) => void;
  readonly __wbg_vinstanceattributes_free: (a: number) => void;
  readonly vinstanceattributes_create: (a: number) => number;
  readonly p3d_instance_attribute: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_mesh: (a: number, b: number, c: number, d: number, e: number) => number;
  readonly p3d_mesh_geometry: (a: number, b: number, c: number, d: number) => number;
  readonly p3d_mesh_indexrange: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_mesh_vertexrange: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_mesh_blend: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number) => void;
  readonly p3d_mesh_cull_mode: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_frontface: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_topology: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_polygon_mode: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_unclip_depth: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_cast_shadow: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_receive_shadow: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_depth_write: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_depth_compare: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_depth_bias: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_mesh_stencil_front: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_mesh_stencil_back: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_mesh_stencil_read: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_stencil_write: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_bounding_box: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => void;
  readonly p3d_mesh_bounding_cullingmode: (a: number, b: number, c: number) => void;
  readonly p3d_mesh_render_queue: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_render_queue_arr: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_mesh_render_alignment: (a: number, b: number, c: number) => void;
  readonly p3d_mesh_instance_sort_mode: (a: number, b: number, c: number) => void;
  readonly p3d_abstruct_mesh_scaling_mode: (a: number, b: number, c: number) => void;
  readonly p3d_abstruct_mesh_velocity: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_abstruct_mesh_velocity_arr: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_attribute_target_animation: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_abstruct_pose_matrix: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_instance_mesh: (a: number, b: number, c: number) => number;
  readonly p3d_instance_mesh_vec4: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_instance_mesh_vec3: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_instance_mesh_vec2: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_instance_mesh_float: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_instance_mesh_sint: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_instance_mesh_uint: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_instance_mesh_ivec4: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_instance_mesh_u16x2: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_instance_mesh_u16x4: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_instance_mesh_u8x4: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_mesh_bone_offset: (a: number, b: number, c: number) => void;
  readonly p3d_mesh_bone_offset_arr: (a: number, b: number, c: number, d: number) => void;
  readonly __wbg_vbmeta_free: (a: number) => void;
  readonly vbmeta_create: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_vbmeta_attr: (a: number, b: number, c: number) => void;
  readonly p3d_vbmeta_custom_attr: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly __wbg_geometrymeta_free: (a: number) => void;
  readonly geometrymeta_create_empty: () => number;
  readonly geometrymeta_create_box: () => number;
  readonly geometrymeta_create_quad: () => number;
  readonly p3d_geo_set_vertex: (a: number, b: number) => void;
  readonly p3d_geo_set_indice: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => void;
  readonly p3d_create_vertex_buffer: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_create_indices_buffer: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_create_indices_buffer_u32: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_material_shader: (a: number, b: number, c: number) => void;
  readonly p3d_material_apply: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_material_uniform_mat4: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number, m: number, n: number, o: number, p: number, q: number, r: number, s: number) => void;
  readonly p3d_material_uniform_vec2: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_material_uniform_vec4: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_material_uniform_float: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_material_uniform_uint: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_material_uniform_tex: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number, m: number, n: number, o: number, p: number, q: number, r: number, s: number) => void;
  readonly p3d_material_uniform_tex_from_render_target: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number, m: number, n: number, o: number, p: number) => void;
  readonly p3d_uniform_target_animation: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_light: (a: number, b: number, c: number, d: number) => number;
  readonly p3d_light_direction: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_light_strength: (a: number, b: number, c: number) => void;
  readonly p3d_light_spot_angle: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_light_radius: (a: number, b: number, c: number) => void;
  readonly p3d_light_color: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_abstructmesh_force_point_light: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_abstructmesh_force_spot_light: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_abstructmesh_force_hemi_light: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_shadow_generator: (a: number, b: number, c: number, d: number, e: number) => number;
  readonly p3d_shadow_base_param: (a: number, b: number, c: number, d: number, e: number) => number;
  readonly p3d_shadow_frustum: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly __wbg_nodematerialblock_free: (a: number) => void;
  readonly nodematerialblock_create: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number) => number;
  readonly p3d_node_material_block_extend_depend: (a: number, b: number) => void;
  readonly p3d_node_material_block_extend_bind_define: (a: number, b: number) => void;
  readonly p3d_node_material_block_mat4: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number, m: number, n: number, o: number, p: number, q: number, r: number) => void;
  readonly p3d_node_material_block_vec4: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_node_material_block_vec3: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_node_material_block_vec2: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_node_material_block_float: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_node_material_block_uint: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_node_material_block_varying: (a: number, b: number, c: number) => void;
  readonly p3d_node_material_block_texture: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_node_material_block_regist: (a: number, b: number, c: number) => void;
  readonly __wbg_nodematerialincludes_free: (a: number) => void;
  readonly nodematerialincludes_create: () => number;
  readonly p3d_material_include: (a: number, b: number) => void;
  readonly p3d_material_include_by_name: (a: number, b: number) => void;
  readonly p3d_material_includes_reset: (a: number) => void;
  readonly __wbg_materialuniformdefines_free: (a: number) => void;
  readonly materialuniformdefines_create: () => number;
  readonly p3d_shader_uniform_float: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_shader_uniform_vec2: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly p3d_shader_uniform_vec4: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => void;
  readonly p3d_shader_uniform_uint: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_shader_uniform_tex: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_check_shader: (a: number, b: number, c: number, d: number) => number;
  readonly __wbg_p3dshadermeta_free: (a: number) => void;
  readonly __wbg_p3dshadervaryings_free: (a: number) => void;
  readonly p3d_varying: (a: number, b: number, c: number) => void;
  readonly p3d_regist_material: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number, m: number, n: number, o: number, p: number, q: number, r: number, s: number) => number;
  readonly __wbg_datatextureres_free: (a: number) => void;
  readonly p3d_create_data_texture: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_update_data_texture: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number) => void;
  readonly p3d_remove_data_texture: (a: number, b: number) => void;
  readonly p3d_query_texture: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number) => number;
  readonly p3d_texture_combine_add_frame: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number) => void;
  readonly p3d_texture_combine_remove: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_texture_combine_query: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly p3d_texture_combine_param: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_animation_group: (a: number, b: number, c: number) => number;
  readonly p3d_animation_curve_id: (a: number) => number;
  readonly p3d_animation_group_weight: (a: number, b: number, c: number) => void;
  readonly p3d_animation_group_target_reset: (a: number, b: number) => void;
  readonly p3d_anime_group_start: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number, m: number, n: number, o: number, p: number) => void;
  readonly p3d_anime_group_pause: (a: number, b: number) => void;
  readonly p3d_anime_group_stop: (a: number, b: number) => void;
  readonly p3d_anime_group_goto: (a: number, b: number, c: number) => void;
  readonly p3d_animation_group_listen: (a: number, b: number, c: number) => void;
  readonly p3d_animation_group_add_frame_event: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_animation_group_delete: (a: number, b: number) => void;
  readonly p3d_query_anime_events: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly p3d_anime_curve_query: (a: number, b: number, c: number, d: number) => number;
  readonly p3d_anime_curve_create: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => number;
  readonly p3d_property_target_animation: (a: number, b: number, c: number, d: number, e: number) => number;
  readonly p3d_particle_system: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number, l: number) => void;
  readonly p3d_particle_system_with_gltf: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number) => void;
  readonly p3d_particle_system_start: (a: number, b: number) => void;
  readonly p3d_particle_system_timescale: (a: number, b: number, c: number) => void;
  readonly p3d_particle_system_stop: (a: number, b: number) => void;
  readonly p3d_trail: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_trail_age: (a: number, b: number, c: number) => void;
  readonly __wbg_commandsexchanged3_free: (a: number) => void;
  readonly commandsexchanged3_create: () => number;
  readonly p3d_commands_exchange: (a: number, b: number, c: number) => void;
  readonly p3d_skeleton: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => number;
  readonly p3d_bone: (a: number, b: number, c: number) => number;
  readonly p3d_bone_link: (a: number, b: number, c: number) => void;
  readonly p3d_bone_pose: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_skin_use: (a: number, b: number, c: number) => void;
  readonly p3d_sprite: (a: number, b: number, c: number, d: number) => number;
  readonly p3d_sprite_frame: (a: number, b: number, c: number, d: number) => void;
  readonly p3d_sprite_frame_data: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly p3d_record_sprite_frame_data: (a: number, b: number, c: number) => number;
  readonly __wbg_ptextureframeatlas_free: (a: number) => void;
  readonly __wbg_restextureframeatlas_free: (a: number) => void;
  readonly p3d_texture_frame_atlas: (a: number, b: number, c: number) => number;
  readonly p3d_texture_frame_atlas_append_frame: (a: number, b: number, c: number, d: number) => number;
  readonly p3d_texture_frame_atlas_append_animation: (a: number, b: number, c: number, d: number) => number;
  readonly p3d_texture_frame_atlas_cache: (a: number, b: number) => number;
  readonly p3d_material: (a: number) => number;
  readonly p3dshadervaryings_create: () => number;
  readonly __wbg_commandsexchangespine_free: (a: number) => void;
  readonly commandsexchangespine_create: () => number;
  readonly spine_exchange_commands: (a: number, b: number) => void;
  readonly init_spine_context: (a: number) => void;
  readonly spine_renderer_create: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => number;
  readonly spine_renderer_dispose: (a: number, b: number) => void;
  readonly spine_texture_load: (a: number, b: number, c: number, d: number, e: number) => number;
  readonly __wbg_spinetextureloadrecord_free: (a: number) => void;
  readonly spinetextureloadrecord_new: () => number;
  readonly spinetextureloadrecord_success: (a: number, b: number) => number;
  readonly spinetextureloadrecord_fail: (a: number, b: number, c: number) => void;
  readonly spinetextureloadrecord_clear: (a: number) => void;
  readonly spine_texture_loaded_query: (a: number, b: number) => void;
  readonly spine_texture_record: (a: number, b: number, c: number) => void;
  readonly spine_remove_texture: (a: number, b: number, c: number) => void;
  readonly spine_use_texture: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number) => void;
  readonly spine_shader: (a: number, b: number, c: number, d: number) => void;
  readonly spine_blend: (a: number, b: number, c: number, d: number) => void;
  readonly spine_blend_mode: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly spine_uniform: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly spine_draw: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number) => void;
  readonly spine_reset: (a: number, b: number, c: number) => void;
  readonly get_layout: (a: number, b: number, c: number) => void;
  readonly get_class: (a: number, b: number, c: number) => void;
  readonly node_info: (a: number, b: number, c: number) => void;
  readonly texture_info: (a: number, b: number) => void;
  readonly debug_info: (a: number, b: number) => void;
  readonly get_world_matrix: (a: number, b: number, c: number) => void;
  readonly get_transform: (a: number, b: number, c: number) => void;
  readonly create_gui: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number) => number;
  readonly create_fragment: (a: number, b: number, c: number, d: number) => void;
  readonly log_animation: (a: number) => void;
  readonly set_align_content: (a: number, b: number, c: number) => void;
  readonly reset_align_content: (a: number, b: number) => void;
  readonly set_align_items: (a: number, b: number, c: number) => void;
  readonly reset_align_items: (a: number, b: number) => void;
  readonly set_justify_content: (a: number, b: number, c: number) => void;
  readonly reset_justify_content: (a: number, b: number) => void;
  readonly set_flex_direction: (a: number, b: number, c: number) => void;
  readonly reset_flex_direction: (a: number, b: number) => void;
  readonly set_flex_wrap: (a: number, b: number, c: number) => void;
  readonly reset_flex_wrap: (a: number, b: number) => void;
  readonly set_align_self: (a: number, b: number, c: number) => void;
  readonly reset_align_self: (a: number, b: number) => void;
  readonly set_position_type: (a: number, b: number, c: number) => void;
  readonly reset_position_type: (a: number, b: number) => void;
  readonly set_flex_grow: (a: number, b: number, c: number) => void;
  readonly reset_flex_grow: (a: number, b: number) => void;
  readonly set_flex_basis_percent: (a: number, b: number, c: number) => void;
  readonly set_flex_basis: (a: number, b: number, c: number) => void;
  readonly reset_flex_basis: (a: number, b: number) => void;
  readonly set_flex_basis_auto: (a: number, b: number) => void;
  readonly set_width_percent: (a: number, b: number, c: number) => void;
  readonly set_width: (a: number, b: number, c: number) => void;
  readonly reset_width: (a: number, b: number) => void;
  readonly set_width_auto: (a: number, b: number) => void;
  readonly set_height_percent: (a: number, b: number, c: number) => void;
  readonly set_height: (a: number, b: number, c: number) => void;
  readonly reset_height: (a: number, b: number) => void;
  readonly set_height_auto: (a: number, b: number) => void;
  readonly set_min_width_percent: (a: number, b: number, c: number) => void;
  readonly set_min_width: (a: number, b: number, c: number) => void;
  readonly reset_min_width: (a: number, b: number) => void;
  readonly set_min_width_auto: (a: number, b: number) => void;
  readonly set_min_height_percent: (a: number, b: number, c: number) => void;
  readonly set_min_height: (a: number, b: number, c: number) => void;
  readonly reset_min_height: (a: number, b: number) => void;
  readonly set_min_height_auto: (a: number, b: number) => void;
  readonly set_max_width_percent: (a: number, b: number, c: number) => void;
  readonly set_max_width: (a: number, b: number, c: number) => void;
  readonly reset_max_width: (a: number, b: number) => void;
  readonly set_max_width_auto: (a: number, b: number) => void;
  readonly set_max_height_percent: (a: number, b: number, c: number) => void;
  readonly set_max_height: (a: number, b: number, c: number) => void;
  readonly reset_max_height: (a: number, b: number) => void;
  readonly set_max_height_auto: (a: number, b: number) => void;
  readonly set_padding_percent: (a: number, b: number, c: number, d: number) => void;
  readonly set_padding: (a: number, b: number, c: number, d: number) => void;
  readonly reset_padding: (a: number, b: number, c: number) => void;
  readonly set_padding_auto: (a: number, b: number, c: number) => void;
  readonly set_margin_percent: (a: number, b: number, c: number, d: number) => void;
  readonly set_margin: (a: number, b: number, c: number, d: number) => void;
  readonly reset_margin: (a: number, b: number, c: number) => void;
  readonly set_margin_auto: (a: number, b: number, c: number) => void;
  readonly set_border_percent: (a: number, b: number, c: number, d: number) => void;
  readonly set_border: (a: number, b: number, c: number, d: number) => void;
  readonly reset_border: (a: number, b: number, c: number) => void;
  readonly set_border_auto: (a: number, b: number, c: number) => void;
  readonly set_position_percent: (a: number, b: number, c: number, d: number) => void;
  readonly set_position: (a: number, b: number, c: number, d: number) => void;
  readonly reset_position: (a: number, b: number, c: number) => void;
  readonly set_position_auto: (a: number, b: number, c: number) => void;
  readonly set_background_rgba_color: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly set_background_linear_color: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly reset_background_linear_color: (a: number, b: number) => void;
  readonly set_border_color: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly reset_border_color: (a: number, b: number) => void;
  readonly set_border_radius: (a: number, b: number, c: number, d: number) => void;
  readonly reset_border_radius: (a: number, b: number) => void;
  readonly set_box_shadow: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number) => void;
  readonly reset_box_shadow: (a: number, b: number) => void;
  readonly set_object_fit: (a: number, b: number, c: number) => void;
  readonly reset_object_fit: (a: number, b: number) => void;
  readonly set_background_repeat: (a: number, b: number, c: number, d: number) => void;
  readonly reset_background_repeat: (a: number, b: number) => void;
  readonly set_mask_image_linear: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly set_image_clip: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly reset_image_clip: (a: number, b: number) => void;
  readonly set_mask_image_clip: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly reset_mask_image_clip: (a: number, b: number) => void;
  readonly set_border_image_clip: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly reset_border_image_clip: (a: number, b: number) => void;
  readonly set_border_image_slice: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly reset_border_image_slice: (a: number, b: number) => void;
  readonly set_border_image_repeat: (a: number, b: number, c: number, d: number) => void;
  readonly reset_border_image_repeat: (a: number, b: number) => void;
  readonly set_overflow: (a: number, b: number, c: number) => void;
  readonly reset_overflow: (a: number, b: number) => void;
  readonly set_opacity: (a: number, b: number, c: number) => void;
  readonly reset_opacity: (a: number, b: number) => void;
  readonly set_display: (a: number, b: number, c: number) => void;
  readonly reset_display: (a: number, b: number) => void;
  readonly set_visibility: (a: number, b: number, c: number) => void;
  readonly reset_visibility: (a: number, b: number) => void;
  readonly set_enable: (a: number, b: number, c: number) => void;
  readonly reset_enable: (a: number, b: number) => void;
  readonly set_blend_mode: (a: number, b: number, c: number) => void;
  readonly reset_blend_mode: (a: number, b: number) => void;
  readonly set_zindex: (a: number, b: number, c: number) => void;
  readonly reset_zindex: (a: number, b: number) => void;
  readonly set_as_image: (a: number, b: number, c: number, d: number) => void;
  readonly reset_as_image: (a: number, b: number) => void;
  readonly set_filter_blur: (a: number, b: number, c: number) => void;
  readonly reset_filter_blur: (a: number, b: number) => void;
  readonly set_transform_will_change: (a: number, b: number, c: number) => void;
  readonly reset_transform_will_change: (a: number, b: number) => void;
  readonly set_filter_hsi: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly reset_filter_hsi: (a: number, b: number) => void;
  readonly set_translate: (a: number, b: number, c: number, d: number) => void;
  readonly reset_translate: (a: number, b: number) => void;
  readonly set_scale: (a: number, b: number, c: number, d: number) => void;
  readonly reset_scale: (a: number, b: number) => void;
  readonly set_rotate: (a: number, b: number, c: number, d: number) => void;
  readonly reset_rotate: (a: number, b: number) => void;
  readonly set_transform: (a: number, b: number, c: number, d: number) => void;
  readonly reset_transform: (a: number, b: number) => void;
  readonly set_text_overflow: (a: number, b: number, c: number, d: number) => void;
  readonly reset_text_overflow: (a: number, b: number) => void;
  readonly set_overflow_wrap: (a: number, b: number, c: number, d: number) => void;
  readonly reset_overflow_wrap: (a: number, b: number) => void;
  readonly set_transform_origin: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly reset_transform_origin: (a: number, b: number) => void;
  readonly set_letter_spacing: (a: number, b: number, c: number) => void;
  readonly reset_letter_spacing: (a: number, b: number) => void;
  readonly set_word_spacing: (a: number, b: number, c: number) => void;
  readonly reset_word_spacing: (a: number, b: number) => void;
  readonly set_text_rgba_color: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly set_text_linear_gradient_color: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly reset_text_linear_gradient_color: (a: number, b: number) => void;
  readonly set_line_height_normal: (a: number, b: number) => void;
  readonly set_line_height: (a: number, b: number, c: number) => void;
  readonly reset_line_height: (a: number, b: number) => void;
  readonly set_line_height_percent: (a: number, b: number, c: number) => void;
  readonly set_text_indent: (a: number, b: number, c: number) => void;
  readonly reset_text_indent: (a: number, b: number) => void;
  readonly set_text_align: (a: number, b: number, c: number) => void;
  readonly reset_text_align: (a: number, b: number) => void;
  readonly set_vertical_align: (a: number, b: number, c: number) => void;
  readonly reset_vertical_align: (a: number, b: number) => void;
  readonly set_text_stroke: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly reset_text_stroke: (a: number, b: number) => void;
  readonly set_white_space: (a: number, b: number, c: number) => void;
  readonly reset_white_space: (a: number, b: number) => void;
  readonly set_font_style: (a: number, b: number, c: number) => void;
  readonly reset_font_style: (a: number, b: number) => void;
  readonly set_font_weight: (a: number, b: number, c: number) => void;
  readonly reset_font_weight: (a: number, b: number) => void;
  readonly set_font_size_none: (a: number, b: number) => void;
  readonly set_font_size: (a: number, b: number, c: number) => void;
  readonly reset_font_size: (a: number, b: number) => void;
  readonly set_font_size_percent: (a: number, b: number, c: number) => void;
  readonly set_text_content_utf8: (a: number, b: number, c: number, d: number) => void;
  readonly set_clip_path_str: (a: number, b: number, c: number, d: number) => void;
  readonly reset_clip_path_str: (a: number, b: number) => void;
  readonly set_animation_duration: (a: number, b: number, c: number, d: number) => void;
  readonly reset_animation_duration: (a: number, b: number) => void;
  readonly set_animation_delay: (a: number, b: number, c: number, d: number) => void;
  readonly reset_animation_delay: (a: number, b: number) => void;
  readonly set_animation_iteration_count: (a: number, b: number, c: number, d: number) => void;
  readonly reset_animation_iteration_count: (a: number, b: number) => void;
  readonly set_animation_direction: (a: number, b: number, c: number, d: number) => void;
  readonly reset_animation_direction: (a: number, b: number) => void;
  readonly set_animation_fill_mode: (a: number, b: number, c: number, d: number) => void;
  readonly reset_animation_fill_mode: (a: number, b: number) => void;
  readonly set_animation_play_state: (a: number, b: number, c: number, d: number) => void;
  readonly reset_animation_play_state: (a: number, b: number) => void;
  readonly set_animation_name_str: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly reset_animation_name_str: (a: number, b: number) => void;
  readonly set_runtime_animation: (a: number, b: number, c: number, d: number, e: number, f: number, g: number) => void;
  readonly set_animation_str: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly reset_animation_str: (a: number, b: number) => void;
  readonly set_mask_image: (a: number, b: number, c: number) => void;
  readonly reset_mask_image: (a: number, b: number) => void;
  readonly set_background_image: (a: number, b: number, c: number) => void;
  readonly reset_background_image: (a: number, b: number) => void;
  readonly set_border_image: (a: number, b: number, c: number) => void;
  readonly reset_border_image: (a: number, b: number) => void;
  readonly set_text_shadow: (a: number, b: number, c: number, d: number) => void;
  readonly reset_text_shadow: (a: number, b: number) => void;
  readonly set_text_outer_glow: (a: number, b: number, c: number, d: number) => void;
  readonly reset_text_outer_glow: (a: number, b: number) => void;
  readonly set_font_family: (a: number, b: number, c: number) => void;
  readonly reset_font_family: (a: number, b: number) => void;
  readonly set_text_content: (a: number, b: number, c: number, d: number) => void;
  readonly reset_text_content: (a: number, b: number) => void;
  readonly set_animation_timing_function_str: (a: number, b: number, c: number, d: number) => void;
  readonly reset_animation_timing_function_str: (a: number, b: number) => void;
  readonly set_default_style: (a: number, b: number, c: number) => void;
  readonly create_class_by_str: (a: number, b: number, c: number, d: number) => void;
  readonly set_class: (a: number, b: number, c: number, d: number) => void;
  readonly set_view_port: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly set_brush: (a: number, b: number, c: number, d: number) => void;
  readonly set_radial_wave: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number) => void;
  readonly set_rendertarget_type: (a: number, b: number, c: number) => void;
  readonly set_clear_color: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly create_class_by_bin: (a: number, b: number, c: number) => void;
  readonly bind_render_target: (a: number) => void;
  readonly set_pixel_ratio: (a: number, b: number) => void;
  readonly set_scissor: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly set_project_transfrom: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => void;
  readonly force_update_text: (a: number, b: number) => void;
  readonly set_shader: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly get_class_sheet: (a: number) => number;
  readonly create_render_target: (a: number, b: number) => number;
  readonly clone_engine: (a: number) => number;
  readonly node_is_exist: (a: number, b: number) => number;
  readonly node_is_visibility: (a: number, b: number, c: number) => number;
  readonly first_child: (a: number, b: number, c: number) => void;
  readonly get_layer: (a: number, b: number) => number;
  readonly get_enable: (a: number, b: number, c: number) => number;
  readonly offset_top: (a: number, b: number, c: number) => number;
  readonly offset_left: (a: number, b: number, c: number) => number;
  readonly offset_width: (a: number, b: number, c: number) => number;
  readonly offset_height: (a: number, b: number, c: number) => number;
  readonly get_class_name: (a: number, b: number, c: number, d: number) => void;
  readonly offset_document: (a: number, b: number, c: number, d: number) => void;
  readonly content_box: (a: number, b: number, c: number, d: number) => void;
  readonly get_animation_events_max_len: (a: number) => number;
  readonly get_animation_events: (a: number, b: number, c: number, d: number) => number;
  readonly get_entity_offset: (a: number) => number;
  readonly get_entity_version: (a: number) => number;
  readonly query: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly set_svg_fill_color: (a: number, b: number, c: number, d: number) => void;
  readonly reset_svg_fill_color: (a: number, b: number) => void;
  readonly set_svg_fill_color_id: (a: number, b: number, c: number, d: number) => void;
  readonly set_svg_storke_color: (a: number, b: number, c: number, d: number) => void;
  readonly set_svg_storke_width: (a: number, b: number, c: number) => void;
  readonly reset_svg_storke_width: (a: number, b: number) => void;
  readonly set_svg_shape_width: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_width: (a: number, b: number) => void;
  readonly set_svg_shape_height: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_height: (a: number, b: number) => void;
  readonly set_svg_shape_x: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_x: (a: number, b: number) => void;
  readonly set_svg_shape_y: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_y: (a: number, b: number) => void;
  readonly set_svg_width: (a: number, b: number, c: number) => void;
  readonly reset_svg_width: (a: number, b: number) => void;
  readonly set_svg_height: (a: number, b: number, c: number) => void;
  readonly reset_svg_height: (a: number, b: number) => void;
  readonly set_svg_shape: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape: (a: number, b: number) => void;
  readonly set_svg_shape_cx: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_cx: (a: number, b: number) => void;
  readonly set_svg_shape_cy: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_cy: (a: number, b: number) => void;
  readonly set_svg_shape_radius: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_radius: (a: number, b: number) => void;
  readonly set_svg_shape_radius_x: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_radius_x: (a: number, b: number) => void;
  readonly set_svg_shape_radius_y: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_radius_y: (a: number, b: number) => void;
  readonly set_svg_shape_ax: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_ax: (a: number, b: number) => void;
  readonly set_svg_shape_ay: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_ay: (a: number, b: number) => void;
  readonly set_svg_shape_bx: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_bx: (a: number, b: number) => void;
  readonly set_svg_shape_by: (a: number, b: number, c: number) => void;
  readonly reset_svg_shape_by: (a: number, b: number) => void;
  readonly set_svg_shape_points: (a: number, b: number, c: number, d: number) => void;
  readonly reset_svg_shape_points: (a: number, b: number) => void;
  readonly set_svg_shape_path: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly reset_svg_shape_path: (a: number, b: number) => void;
  readonly set_svg_stroke_dasharray: (a: number, b: number, c: number, d: number) => void;
  readonly reset_svg_stroke_dasharray: (a: number, b: number) => void;
  readonly set_svg_shadow_offset_dx: (a: number, b: number, c: number) => void;
  readonly reset_svg_shadow_offset_dx: (a: number, b: number) => void;
  readonly set_svg_shadow_offset_dy: (a: number, b: number, c: number) => void;
  readonly reset_svg_shadow_offset_dy: (a: number, b: number) => void;
  readonly set_svg_blur_level: (a: number, b: number, c: number) => void;
  readonly reset_svg_blur_level: (a: number, b: number) => void;
  readonly set_svg_filter: (a: number, b: number, c: number, d: number) => void;
  readonly reset_svg_filter: (a: number, b: number) => void;
  readonly set_svg_filter_id: (a: number, b: number, c: number, d: number) => void;
  readonly reset_svg_filter_id: (a: number, b: number) => void;
  readonly set_svg_gradient_stop: (a: number, b: number, c: number, d: number) => void;
  readonly reset_svg_gradient_stop: (a: number, b: number) => void;
  readonly set_svg_gradient_offset: (a: number, b: number, c: number) => void;
  readonly reset_svg_gradient_offset: (a: number, b: number) => void;
  readonly set_svg_gradient: (a: number, b: number, c: number, d: number) => void;
  readonly reset_svg_gradient: (a: number, b: number) => void;
  readonly set_svg_shadow_color: (a: number, b: number, c: number, d: number) => void;
  readonly reset_svg_shadow_color: (a: number, b: number) => void;
  readonly __wbg_gui_free: (a: number) => void;
  readonly create_node: (a: number) => number;
  readonly create_vnode: (a: number) => number;
  readonly create_text_node: (a: number) => number;
  readonly create_image_node: (a: number) => number;
  readonly create_canvas_node: (a: number) => number;
  readonly destroy_node: (a: number, b: number) => void;
  readonly remove_node: (a: number, b: number) => void;
  readonly insert_as_root: (a: number, b: number) => void;
  readonly append_child: (a: number, b: number, c: number) => void;
  readonly insert_before: (a: number, b: number, c: number) => void;
  readonly create_fragment_by_bin: (a: number, b: number, c: number) => void;
  readonly render_gui: (a: number, b: number) => void;
  readonly calc: (a: number, b: number) => void;
  readonly calc_layout: (a: number, b: number) => void;
  readonly calc_geo: (a: number, b: number) => void;
  readonly get_keyframes: (a: number, b: number, c: number, d: number) => void;
  readonly set_is_run: (a: number, b: number) => void;
  readonly get_record: (a: number, b: number) => void;
  readonly get_record_len: (a: number) => number;
  readonly set_next_record: (a: number, b: number, c: number) => void;
  readonly set_next_record_last: (a: number) => void;
  readonly is_play_end: (a: number) => number;
  readonly set_debug_entity: (a: number, b: number) => void;
  readonly add_sdf_font: (a: number, b: number, c: number) => void;
  readonly add_sdf2_font: (a: number, b: number, c: number, d: number) => void;
  readonly query_text: (a: number, b: number, c: number, d: number) => number;
  readonly get_text_pos: (a: number, b: number, c: number, d: number) => number;
  readonly has_res: (a: number, b: number) => number;
  readonly __wbg_reshandle_free: (a: number) => void;
  readonly load_res: (a: number, b: number) => void;
  readonly get_success_res_len: (a: number) => number;
  readonly get_success_res: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly __wbg_charpos_free: (a: number) => void;
  readonly charpos_index: (a: number) => number;
  readonly charpos_x: (a: number) => number;
  readonly charpos_y: (a: number) => number;
  readonly last_child: (a: number, b: number, c: number) => void;
  readonly next_sibling: (a: number, b: number, c: number) => void;
  readonly previous_sibling: (a: number, b: number, c: number) => void;
  readonly reset_flex_shrink: (a: number, b: number) => void;
  readonly reset_flex_basis_percent: (a: number, b: number) => void;
  readonly reset_flex_basis_auto: (a: number, b: number) => void;
  readonly reset_width_percent: (a: number, b: number) => void;
  readonly reset_width_auto: (a: number, b: number) => void;
  readonly reset_height_percent: (a: number, b: number) => void;
  readonly reset_height_auto: (a: number, b: number) => void;
  readonly reset_min_width_percent: (a: number, b: number) => void;
  readonly reset_min_width_auto: (a: number, b: number) => void;
  readonly reset_min_height_percent: (a: number, b: number) => void;
  readonly reset_min_height_auto: (a: number, b: number) => void;
  readonly reset_max_width_percent: (a: number, b: number) => void;
  readonly reset_max_width_auto: (a: number, b: number) => void;
  readonly reset_max_height_percent: (a: number, b: number) => void;
  readonly reset_max_height_auto: (a: number, b: number) => void;
  readonly reset_background_rgba_color: (a: number, b: number) => void;
  readonly reset_text_rgba_color: (a: number, b: number) => void;
  readonly reset_line_height_normal: (a: number, b: number) => void;
  readonly reset_line_height_percent: (a: number, b: number) => void;
  readonly reset_font_size_none: (a: number, b: number) => void;
  readonly reset_font_size_percent: (a: number, b: number) => void;
  readonly reset_mask_image_linear: (a: number, b: number) => void;
  readonly reset_text_content_utf8: (a: number, b: number) => void;
  readonly reset_svg_fill_color_id: (a: number, b: number) => void;
  readonly reset_svg_storke_color: (a: number, b: number) => void;
  readonly set_flex_shrink: (a: number, b: number, c: number) => void;
  readonly nullify_clear_color: (a: number) => void;
  readonly get_font_sheet: (a: number) => number;
  readonly get_text_texture_width: (a: number) => number;
  readonly get_text_texture_height: (a: number) => number;
  readonly sdf_on_load: (a: number, b: number) => void;
  readonly set_render_dirty: (a: number, b: number) => void;
  readonly reset_runtime_animation: (a: number, b: number) => void;
  readonly destroy_render_target: (a: number, b: number) => number;
  readonly reset_padding_percent: (a: number, b: number, c: number) => void;
  readonly reset_padding_auto: (a: number, b: number, c: number) => void;
  readonly reset_margin_percent: (a: number, b: number, c: number) => void;
  readonly reset_margin_auto: (a: number, b: number, c: number) => void;
  readonly reset_border_percent: (a: number, b: number, c: number) => void;
  readonly reset_border_auto: (a: number, b: number, c: number) => void;
  readonly reset_position_percent: (a: number, b: number, c: number) => void;
  readonly reset_position_auto: (a: number, b: number, c: number) => void;
  readonly __wbg_engine_free: (a: number) => void;
  readonly __wbg_atom_free: (a: number) => void;
  readonly atom_from_string: (a: number, b: number) => number;
  readonly atom_get_string_by_hash: (a: number, b: number) => void;
  readonly atom_get_hash: (a: number) => number;
  readonly set_log_filter: (a: number, b: number, c: number) => void;
  readonly set_is_not_run: (a: number, b: number) => void;
  readonly create_engine: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number, k: number) => number;
  readonly dump_graphviz: (a: number, b: number) => void;
  readonly fram_call: (a: number, b: number) => void;
  readonly entity_to_asimage_url: (a: number, b: number) => void;
  readonly entity_from_number: (a: number, b: number) => number;
  readonly init_engine_3d: (a: number, b: number, c: number, d: number) => void;
  readonly __wbg_vertexbufferres_free: (a: number) => void;
  readonly __wbg_texturedefaultview_free: (a: number) => void;
  readonly p3d_texture_default_view_width: (a: number) => number;
  readonly p3d_texture_default_view_height: (a: number) => number;
  readonly query_texture_default_view: (a: number, b: number) => number;
  readonly __wbg_quadtree_free: (a: number) => void;
  readonly quadtree_default: () => number;
  readonly quadtree_new: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number) => number;
  readonly quadtree_add: (a: number, b: number, c: number, d: number, e: number) => number;
  readonly quadtree_remove: (a: number, b: number) => void;
  readonly quadtree_update: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly quadtree_query: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly quadtree_query_max: (a: number, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number) => number;
  readonly __wbg_tilemaptree_free: (a: number) => void;
  readonly tilemaptree_new: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly tilemaptree_add: (a: number, b: number, c: number, d: number, e: number) => number;
  readonly tilemaptree_remove: (a: number, b: number) => void;
  readonly tilemaptree_update: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly tilemaptree_query: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly __wbg_resref_free: (a: number) => void;
  readonly __wbg_resmgr_free: (a: number) => void;
  readonly resmgr_create_res: (a: number, b: number, c: number) => number;
  readonly resmgr_get_res: (a: number, b: number) => number;
  readonly __wbg_resallocator_free: (a: number) => void;
  readonly resallocator_new: (a: number) => number;
  readonly resallocator_collect: (a: number) => void;
  readonly resallocator_register_to_resmgr: (a: number, b: number, c: number, d: number, e: number) => number;
  readonly resallocator_size: (a: number) => number;
  readonly resallocator_account_details: (a: number, b: number) => void;
  readonly set_destroy_callback: (a: number) => void;
  readonly __wbindgen_malloc: (a: number, b: number) => number;
  readonly __wbindgen_realloc: (a: number, b: number, c: number, d: number) => number;
  readonly __wbindgen_export_2: WebAssembly.Table;
  readonly wasm_bindgen__convert__closures__invoke1_mut__h96f467bb5995d94d: (a: number, b: number, c: number) => void;
  readonly wasm_bindgen__convert__closures__invoke1_mut__hb2a1c1a9d3a0e24d: (a: number, b: number, c: number) => void;
  readonly wasm_bindgen__convert__closures__invoke0_mut__heaecc72ace6d61ac: (a: number, b: number) => void;
  readonly __wbindgen_add_to_stack_pointer: (a: number) => number;
  readonly __wbindgen_free: (a: number, b: number, c: number) => void;
  readonly __wbindgen_exn_store: (a: number) => void;
}

export type SyncInitInput = BufferSource | WebAssembly.Module;
/**
* Instantiates the given `module`, which can either be bytes or
* a precompiled `WebAssembly.Module`.
*
* @param {SyncInitInput} module
*
* @returns {InitOutput}
*/
export function initSync(module: SyncInitInput): InitOutput;

/**
* If `module_or_path` is {RequestInfo} or {URL}, makes a request and
* for everything else, calls `WebAssembly.instantiate` directly.
*
* @param {InitInput | Promise<InitInput>} module_or_path
*
* @returns {Promise<InitOutput>}
*/
export default function __wbg_init (module_or_path?: InitInput | Promise<InitInput>): Promise<InitOutput>;
