import { bon_buffer } from './snippets/pi_bon_decode/src/bon_buffer';
import { loadFile, loadImageAsCanvas, loadKtx, loadImage, setAtom, initLocalStore, get, write, createFace, horizontalAdvance, ascender, descender, maxBox, toOutline, glyphIndex, debugSize, createCircle, createRect, createSegment, createEllipse, createPolygon, createPolyline, createPath, getSvgInfo, computeNearArcs, free, loadFontSdf, computeLayout, computeSvgLayout, computeSdfTexOfWasm, computeSvgSdfTexOfWasm, computeSvgSdfTexOfWasmSync, computeSdfCellOfWasm, computePositionsAndUv } from './snippets/pi_hal/js/utils';
import { path_result, round_result } from './snippets/pi_path_finding-5adffefcd0cb3062/src/web/path_result';
import * as __wbg_star0 from './snippets/pi_hal/js/utils';

let wasm;

const heap = new Array(128).fill(undefined);

heap.push(undefined, null, true, false);

let heap_next = heap.length;

function addHeapObject(obj) {
    if (heap_next === heap.length) heap.push(heap.length + 1);
    const idx = heap_next;
    heap_next = heap[idx];

    heap[idx] = obj;
    return idx;
}

function getObject(idx) { let result = heap[idx]; if (result === undefined) { return null } else { return result }; }

function isLikeNone(x) {
    return x === undefined || x === null;
}

let cachedFloat64Memory0 = null;

function getFloat64Memory0() {
    if (cachedFloat64Memory0 === null || cachedFloat64Memory0.byteLength === 0) {
        cachedFloat64Memory0 = new Float64Array(wasm.memory.buffer);
    }
    return cachedFloat64Memory0;
}

let cachedInt32Memory0 = null;

function getInt32Memory0() {
    if (cachedInt32Memory0 === null || cachedInt32Memory0.byteLength === 0) {
        cachedInt32Memory0 = new Int32Array(wasm.memory.buffer);
    }
    return cachedInt32Memory0;
}

function dropObject(idx) {
    if (idx < 132) return;
    heap[idx] = heap_next;
    heap_next = idx;
}

function takeObject(idx) {
    const ret = getObject(idx);
    dropObject(idx);
    return ret;
}

function debugString(val) {
    // primitive types
    const type = typeof val;
    if (type == 'number' || type == 'boolean' || val == null) {
        return  `${val}`;
    }
    if (type == 'string') {
        return `"${val}"`;
    }
    if (type == 'symbol') {
        const description = val.description;
        if (description == null) {
            return 'Symbol';
        } else {
            return `Symbol(${description})`;
        }
    }
    if (type == 'function') {
        const name = val.name;
        if (typeof name == 'string' && name.length > 0) {
            return `Function(${name})`;
        } else {
            return 'Function';
        }
    }
    // objects
    if (Array.isArray(val)) {
        const length = val.length;
        let debug = '[';
        if (length > 0) {
            debug += debugString(val[0]);
        }
        for(let i = 1; i < length; i++) {
            debug += ', ' + debugString(val[i]);
        }
        debug += ']';
        return debug;
    }
    // Test for built-in
    const builtInMatches = /\[object ([^\]]+)\]/.exec(toString.call(val));
    let className;
    if (builtInMatches.length > 1) {
        className = builtInMatches[1];
    } else {
        // Failed to match the standard '[object ClassName]'
        return toString.call(val);
    }
    if (className == 'Object') {
        // we're a user defined class or Object
        // JSON.stringify avoids problems with cycles, and is generally much
        // easier than looping through ownProperties of `val`.
        try {
            return 'Object(' + JSON.stringify(val) + ')';
        } catch (_) {
            return 'Object';
        }
    }
    // errors
    if (val instanceof Error) {
        return `${val.name}: ${val.message}\n${val.stack}`;
    }
    // TODO we could test for more things here, like `Set`s and `Map`s.
    return className;
}

let WASM_VECTOR_LEN = 0;

let cachedUint8Memory0 = null;

function getUint8Memory0() {
    if (cachedUint8Memory0 === null || cachedUint8Memory0.byteLength === 0) {
        cachedUint8Memory0 = new Uint8Array(wasm.memory.buffer);
    }
    return cachedUint8Memory0;
}

const cachedTextEncoder = (typeof TextEncoder !== 'undefined' ? new TextEncoder('utf-8') : { encode: () => { throw Error('TextEncoder not available') } } );

const encodeString = (typeof cachedTextEncoder.encodeInto === 'function'
    ? function (arg, view) {
    return cachedTextEncoder.encodeInto(arg, view);
}
    : function (arg, view) {
    const buf = cachedTextEncoder.encode(arg);
    view.set(buf);
    return {
        read: arg.length,
        written: buf.length
    };
});

function passStringToWasm0(arg, malloc, realloc) {

    if (realloc === undefined) {
        const buf = cachedTextEncoder.encode(arg);
        const ptr = malloc(buf.length, 1) >>> 0;
        getUint8Memory0().subarray(ptr, ptr + buf.length).set(buf);
        WASM_VECTOR_LEN = buf.length;
        return ptr;
    }

    let len = arg.length;
    let ptr = malloc(len, 1) >>> 0;

    const mem = getUint8Memory0();

    let offset = 0;

    for (; offset < len; offset++) {
        const code = arg.charCodeAt(offset);
        if (code > 0x7F) break;
        mem[ptr + offset] = code;
    }

    if (offset !== len) {
        if (offset !== 0) {
            arg = arg.slice(offset);
        }
        ptr = realloc(ptr, len, len = offset + arg.length * 3, 1) >>> 0;
        const view = getUint8Memory0().subarray(ptr + offset, ptr + len);
        const ret = encodeString(arg, view);

        offset += ret.written;
        ptr = realloc(ptr, len, offset, 1) >>> 0;
    }

    WASM_VECTOR_LEN = offset;
    return ptr;
}

const cachedTextDecoder = (typeof TextDecoder !== 'undefined' ? new TextDecoder('utf-8', { ignoreBOM: true, fatal: true }) : { decode: () => { throw Error('TextDecoder not available') } } );

if (typeof TextDecoder !== 'undefined') { cachedTextDecoder.decode(); };

function getStringFromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return cachedTextDecoder.decode(getUint8Memory0().subarray(ptr, ptr + len));
}

function getArrayU8FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getUint8Memory0().subarray(ptr / 1, ptr / 1 + len);
}

const CLOSURE_DTORS = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(state => {
    wasm.__wbindgen_export_2.get(state.dtor)(state.a, state.b)
});

function makeMutClosure(arg0, arg1, dtor, f) {
    const state = { a: arg0, b: arg1, cnt: 1, dtor };
    const real = (...args) => {
        // First up with a closure we increment the internal reference
        // count. This ensures that the Rust closure environment won't
        // be deallocated while we're invoking it.
        state.cnt++;
        const a = state.a;
        state.a = 0;
        try {
            return f(a, state.b, ...args);
        } finally {
            if (--state.cnt === 0) {
                wasm.__wbindgen_export_2.get(state.dtor)(a, state.b);
                CLOSURE_DTORS.unregister(state);
            } else {
                state.a = a;
            }
        }
    };
    real.original = state;
    CLOSURE_DTORS.register(real, state, state);
    return real;
}
function __wbg_adapter_46(arg0, arg1, arg2) {
    wasm.wasm_bindgen__convert__closures__invoke1_mut__h96f467bb5995d94d(arg0, arg1, addHeapObject(arg2));
}

function __wbg_adapter_49(arg0, arg1, arg2) {
    wasm.wasm_bindgen__convert__closures__invoke1_mut__hb2a1c1a9d3a0e24d(arg0, arg1, addHeapObject(arg2));
}

function __wbg_adapter_52(arg0, arg1) {
    wasm.wasm_bindgen__convert__closures__invoke0_mut__heaecc72ace6d61ac(arg0, arg1);
}

/**
* @returns {string}
*/
export function get_counters() {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        wasm.get_counters(retptr);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {Level} _level
*/
export function init_logger(_level) {
    wasm.init_logger(_level);
}

function handleError(f, args) {
    try {
        return f.apply(this, args);
    } catch (e) {
        wasm.__wbindgen_exn_store(addHeapObject(e));
    }
}

function passArray8ToWasm0(arg, malloc) {
    const ptr = malloc(arg.length * 1, 1) >>> 0;
    getUint8Memory0().set(arg, ptr / 1);
    WASM_VECTOR_LEN = arg.length;
    return ptr;
}

let cachedFloat32Memory0 = null;

function getFloat32Memory0() {
    if (cachedFloat32Memory0 === null || cachedFloat32Memory0.byteLength === 0) {
        cachedFloat32Memory0 = new Float32Array(wasm.memory.buffer);
    }
    return cachedFloat32Memory0;
}

function getArrayF32FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getFloat32Memory0().subarray(ptr / 4, ptr / 4 + len);
}

function getArrayF64FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getFloat64Memory0().subarray(ptr / 8, ptr / 8 + len);
}

function passArrayF64ToWasm0(arg, malloc) {
    const ptr = malloc(arg.length * 8, 8) >>> 0;
    getFloat64Memory0().set(arg, ptr / 8);
    WASM_VECTOR_LEN = arg.length;
    return ptr;
}

let cachedUint32Memory0 = null;

function getUint32Memory0() {
    if (cachedUint32Memory0 === null || cachedUint32Memory0.byteLength === 0) {
        cachedUint32Memory0 = new Uint32Array(wasm.memory.buffer);
    }
    return cachedUint32Memory0;
}

function getArrayU32FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getUint32Memory0().subarray(ptr / 4, ptr / 4 + len);
}
/**
* @param {Function} f
*/
export function set_destroy_callback(f) {
    wasm.set_destroy_callback(addHeapObject(f));
}

function _assertClass(instance, klass) {
    if (!(instance instanceof klass)) {
        throw new Error(`expected instance of ${klass.name}`);
    }
    return instance.ptr;
}
/**
* 设置日志过滤器
* 如果过滤器格式错误， 日志过滤器未初始化， 则设置将失败， 但不会panic
* @param {Engine} engine
* @param {string} filter
*/
export function set_log_filter(engine, filter) {
    _assertClass(engine, Engine);
    const ptr0 = passStringToWasm0(filter, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_log_filter(engine.__wbg_ptr, ptr0, len0);
}

/**
* @param {Engine} app
* @param {boolean} value
*/
export function set_is_not_run(app, value) {
    _assertClass(app, Engine);
    wasm.set_is_not_run(app.__wbg_ptr, value);
}

/**
* width、height为physical_size
* @param {HTMLCanvasElement} canvas
* @param {number} width
* @param {number} height
* @param {ResAllocator} asset_mgr
* @param {number} asset_total_capacity
* @param {string} asset_config
* @param {string | undefined} log_filter
* @param {number} log_level
* @param {number} collect_interval
* @returns {Engine}
*/
export function create_engine(canvas, width, height, asset_mgr, asset_total_capacity, asset_config, log_filter, log_level, collect_interval) {
    _assertClass(asset_mgr, ResAllocator);
    const ptr0 = passStringToWasm0(asset_config, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    var ptr1 = isLikeNone(log_filter) ? 0 : passStringToWasm0(log_filter, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len1 = WASM_VECTOR_LEN;
    const ret = wasm.create_engine(addHeapObject(canvas), width, height, asset_mgr.__wbg_ptr, asset_total_capacity, ptr0, len0, ptr1, len1, log_level, collect_interval);
    return Engine.__wrap(ret);
}

/**
* @param {Engine} engine
* @returns {string}
*/
export function dump_graphviz(engine) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(engine, Engine);
        wasm.dump_graphviz(retptr, engine.__wbg_ptr);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {Engine} engine
* @param {boolean} reset_state
*/
export function fram_call(engine, reset_state) {
    _assertClass(engine, Engine);
    wasm.fram_call(engine.__wbg_ptr, reset_state);
}

/**
* @param {number} entity
* @returns {string}
*/
export function entity_to_asimage_url(entity) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        wasm.entity_to_asimage_url(retptr, entity);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {number} index
* @param {number} version
* @returns {number}
*/
export function entity_from_number(index, version) {
    const ret = wasm.entity_from_number(index, version);
    return ret;
}

function passArray32ToWasm0(arg, malloc) {
    const ptr = malloc(arg.length * 4, 4) >>> 0;
    getUint32Memory0().set(arg, ptr / 4);
    WASM_VECTOR_LEN = arg.length;
    return ptr;
}
/**
* @param {Engine} app
* @param {boolean} spine
* @param {Uint32Array} param
*/
export function init_engine_3d(app, spine, param) {
    _assertClass(app, Engine);
    const ptr0 = passArray32ToWasm0(param, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.init_engine_3d(app.__wbg_ptr, spine, ptr0, len0);
}

/**
* @param {TextureDefaultView} item
* @returns {number}
*/
export function p3d_texture_default_view_width(item) {
    _assertClass(item, TextureDefaultView);
    const ret = wasm.p3d_texture_default_view_width(item.__wbg_ptr);
    return ret;
}

/**
* @param {TextureDefaultView} item
* @returns {number}
*/
export function p3d_texture_default_view_height(item) {
    _assertClass(item, TextureDefaultView);
    const ret = wasm.p3d_texture_default_view_height(item.__wbg_ptr);
    return ret;
}

/**
* @param {Engine} app
* @param {bigint} key
* @returns {TextureDefaultView | undefined}
*/
export function query_texture_default_view(app, key) {
    _assertClass(app, Engine);
    const ret = wasm.query_texture_default_view(app.__wbg_ptr, key);
    return ret === 0 ? null : TextureDefaultView.__wrap(ret);
}

/**
* @param {Engine} app
* @param {Uint32Array} data
*/
export function p3d_device_limis(app, data) {
    _assertClass(app, Engine);
    var ptr0 = passArray32ToWasm0(data, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    wasm.p3d_device_limis(app.__wbg_ptr, ptr0, len0, addHeapObject(data));
}

/**
* @param {Engine} app
*/
export function p3d_init_engine(app) {
    _assertClass(app, Engine);
    wasm.p3d_init_engine(app.__wbg_ptr);
}

/**
* @param {Engine} app
* @returns {number}
*/
export function p3d_entity(app) {
    _assertClass(app, Engine);
    const ret = wasm.p3d_entity(app.__wbg_ptr);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} entity
*/
export function p3d_dispose(cmds, entity) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_dispose(cmds.__wbg_ptr, entity);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
*/
export function p3d_scene_dispose(cmds, scene) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_scene_dispose(cmds.__wbg_ptr, scene);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} scene_max_direct_light_count
* @param {number} scene_max_point_light_count
* @param {number} scene_max_spot_light_count
* @param {number} scene_max_hemi_light_count
* @param {number} scene_max_shadow_count
* @param {number} model_max_direct_light_count
* @param {number} model_max_point_light_count
* @param {number} model_max_spot_light_count
* @param {number} model_max_hemi_light_count
*/
export function p3d_lighting_shadow_limit(app, param, scene_max_direct_light_count, scene_max_point_light_count, scene_max_spot_light_count, scene_max_hemi_light_count, scene_max_shadow_count, model_max_direct_light_count, model_max_point_light_count, model_max_spot_light_count, model_max_hemi_light_count) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    wasm.p3d_lighting_shadow_limit(app.__wbg_ptr, param.__wbg_ptr, scene_max_direct_light_count, scene_max_point_light_count, scene_max_spot_light_count, scene_max_hemi_light_count, scene_max_shadow_count, model_max_direct_light_count, model_max_point_light_count, model_max_spot_light_count, model_max_hemi_light_count);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} before
* @param {number} after
* @param {boolean} isdisconnect
*/
export function p3d_render_graphic(cmds, before, after, isdisconnect) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_render_graphic(cmds.__wbg_ptr, before, after, isdisconnect);
}

function passArrayF32ToWasm0(arg, malloc) {
    const ptr = malloc(arg.length * 4, 4) >>> 0;
    getFloat32Memory0().set(arg, ptr / 4);
    WASM_VECTOR_LEN = arg.length;
    return ptr;
}
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} matrix
* @returns {boolean}
*/
export function p3d_query_world_matrix(app, param, entity, matrix) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(matrix, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_world_matrix(app.__wbg_ptr, param.__wbg_ptr, entity, ptr0, len0, addHeapObject(matrix));
    return ret !== 0;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} result
* @returns {boolean}
*/
export function p3d_query_scene_state(app, param, entity, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_scene_state(app.__wbg_ptr, param.__wbg_ptr, entity, ptr0, len0, addHeapObject(result));
    return ret !== 0;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {boolean} active
*/
export function p3d_engine_state(app, param, active) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    wasm.p3d_engine_state(app.__wbg_ptr, param.__wbg_ptr, active);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {boolean} debug
*/
export function p3d_engine_debug(app, param, debug) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    wasm.p3d_engine_debug(app.__wbg_ptr, param.__wbg_ptr, debug);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float32Array} result
*/
export function p3d_query_performance_state(app, param, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    wasm.p3d_query_performance_state(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, addHeapObject(result));
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {CommandsExchangeD3} commands
* @param {Float32Array} result
*/
export function p3d_query_resource_state(app, param, commands, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    _assertClass(commands, CommandsExchangeD3);
    var ptr0 = passArrayF32ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    wasm.p3d_query_resource_state(app.__wbg_ptr, param.__wbg_ptr, commands.__wbg_ptr, ptr0, len0, addHeapObject(result));
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float64Array} result
* @returns {number}
*/
export function p3d_query_resource_memory(app, param, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF64ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_resource_memory(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, addHeapObject(result));
    return ret;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float32Array} result
*/
export function p3d_material_state(app, param, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    wasm.p3d_material_state(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, addHeapObject(result));
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number | undefined} scene
* @param {Float32Array} result
*/
export function p3d_mesh_state(app, param, scene, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    wasm.p3d_mesh_state(app.__wbg_ptr, param.__wbg_ptr, !isLikeNone(scene), isLikeNone(scene) ? 0 : scene, ptr0, len0, addHeapObject(result));
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number | undefined} scene
* @param {Float32Array} result
*/
export function p3d_transform_state(app, param, scene, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    wasm.p3d_transform_state(app.__wbg_ptr, param.__wbg_ptr, !isLikeNone(scene), isLikeNone(scene) ? 0 : scene, ptr0, len0, addHeapObject(result));
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number | undefined} transform
* @param {Float32Array} result
* @returns {boolean}
*/
export function p3d_query_transform_state(app, param, transform, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_transform_state(app.__wbg_ptr, param.__wbg_ptr, !isLikeNone(transform), isLikeNone(transform) ? 0 : transform, ptr0, len0, addHeapObject(result));
    return ret !== 0;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number | undefined} camera
* @param {Float32Array} result
*/
export function p3d_camera_state(app, param, camera, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    wasm.p3d_camera_state(app.__wbg_ptr, param.__wbg_ptr, !isLikeNone(camera), isLikeNone(camera) ? 0 : camera, ptr0, len0, addHeapObject(result));
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float32Array} result
*/
export function p3d_texture_loader_state(app, param, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    wasm.p3d_texture_loader_state(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, addHeapObject(result));
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Uint32Array} info
* @param {boolean} flag
* @returns {number}
*/
export function p3d_errors(app, param, info, flag) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArray32ToWasm0(info, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_errors(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, addHeapObject(info), flag);
    return ret;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {boolean} val
*/
export function p3d_global_state(app, param, val) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    wasm.p3d_global_state(app.__wbg_ptr, param.__wbg_ptr, val);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} matrix
* @returns {boolean}
*/
export function p3d_query_local_matrix(app, param, entity, matrix) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(matrix, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_local_matrix(app.__wbg_ptr, param.__wbg_ptr, entity, ptr0, len0, addHeapObject(matrix));
    return ret !== 0;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} matrix
* @returns {boolean}
*/
export function p3d_query_view_matrix(app, param, entity, matrix) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(matrix, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_view_matrix(app.__wbg_ptr, param.__wbg_ptr, entity, ptr0, len0, addHeapObject(matrix));
    return ret !== 0;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} matrix
* @returns {boolean}
*/
export function p3d_query_project_matrix(app, param, entity, matrix) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(matrix, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_project_matrix(app.__wbg_ptr, param.__wbg_ptr, entity, ptr0, len0, addHeapObject(matrix));
    return ret !== 0;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Float32Array} matrix
* @returns {boolean}
*/
export function p3d_query_viewproject_matrix(app, param, entity, matrix) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(matrix, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_viewproject_matrix(app.__wbg_ptr, param.__wbg_ptr, entity, ptr0, len0, addHeapObject(matrix));
    return ret !== 0;
}

/**
* @param {GLTFRes} item
* @returns {string}
*/
export function p3d_gltf_val(item) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(item, GLTFRes);
        wasm.p3d_gltf_val(retptr, item.__wbg_ptr);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* 创建动画组
* @param {GLTFRes} gltf
* @param {number} group_index
* @param {number} channel_index
* @returns {number}
*/
export function p3d_animation_curve_id_bygltf(gltf, group_index, channel_index) {
    _assertClass(gltf, GLTFRes);
    const ret = wasm.p3d_animation_curve_id_bygltf(gltf.__wbg_ptr, group_index, channel_index);
    return ret;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @param {Atom} baseurl
* @param {string} dyndesc
*/
export function p3d_create_gltf_load(app, param, entity, baseurl, dyndesc) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    _assertClass(baseurl, Atom);
    const ptr0 = passStringToWasm0(dyndesc, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_create_gltf_load(app.__wbg_ptr, param.__wbg_ptr, entity, baseurl.__wbg_ptr, ptr0, len0);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float64Array} success
* @param {Float64Array} failed
*/
export function p3d_query_gltf_load(app, param, success, failed) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF64ToWasm0(success, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    var ptr1 = passArrayF64ToWasm0(failed, wasm.__wbindgen_malloc);
    var len1 = WASM_VECTOR_LEN;
    wasm.p3d_query_gltf_load(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, addHeapObject(success), ptr1, len1, addHeapObject(failed));
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @returns {GLTFRes | undefined}
*/
export function p3d_get_gltf(app, param, entity) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    const ret = wasm.p3d_get_gltf(app.__wbg_ptr, param.__wbg_ptr, entity);
    return ret === 0 ? null : GLTFRes.__wrap(ret);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} entity
* @returns {string | undefined}
*/
export function p3d_get_gltf_fail_reason(app, param, entity) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(app, Engine);
        _assertClass(param, ActionSetScene3D);
        wasm.p3d_get_gltf_fail_reason(retptr, app.__wbg_ptr, param.__wbg_ptr, entity);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        let v1;
        if (r0 !== 0) {
            v1 = getStringFromWasm0(r0, r1).slice();
            wasm.__wbindgen_free(r0, r1 * 1, 1);
        }
        return v1;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Atom} url
* @param {boolean} cancombine
* @param {boolean} compressed
* @param {number} depth_or_array_layers
* @returns {number}
*/
export function p3d_create_image_load(app, param, url, cancombine, compressed, depth_or_array_layers) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    _assertClass(url, Atom);
    const ret = wasm.p3d_create_image_load(app.__wbg_ptr, param.__wbg_ptr, url.__wbg_ptr, cancombine, compressed, depth_or_array_layers);
    return ret;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float64Array} success
* @param {Float64Array} failed
*/
export function p3d_query_image_load(app, param, success, failed) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF64ToWasm0(success, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    var ptr1 = passArrayF64ToWasm0(failed, wasm.__wbindgen_malloc);
    var len1 = WASM_VECTOR_LEN;
    wasm.p3d_query_image_load(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, addHeapObject(success), ptr1, len1, addHeapObject(failed));
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} id
* @returns {ImageRes | undefined}
*/
export function p3d_get_image(app, param, id) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    const ret = wasm.p3d_get_image(app.__wbg_ptr, param.__wbg_ptr, id);
    return ret === 0 ? null : ImageRes.__wrap(ret);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} id
* @returns {string | undefined}
*/
export function p3d_get_image_fail_reason(app, param, id) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(app, Engine);
        _assertClass(param, ActionSetScene3D);
        wasm.p3d_get_image_fail_reason(retptr, app.__wbg_ptr, param.__wbg_ptr, id);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        let v1;
        if (r0 !== 0) {
            v1 = getStringFromWasm0(r0, r1).slice();
            wasm.__wbindgen_free(r0, r1 * 1, 1);
        }
        return v1;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} id
* @param {Float64Array} info
* @returns {number}
*/
export function p3d_query_children(app, param, id, info) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF64ToWasm0(info, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_children(app.__wbg_ptr, param.__wbg_ptr, id, ptr0, len0, addHeapObject(info));
    return ret;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} id
* @param {Uint32Array} info
* @returns {boolean}
*/
export function p3d_query_mesh_info(app, param, id, info) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArray32ToWasm0(info, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_mesh_info(app.__wbg_ptr, param.__wbg_ptr, id, ptr0, len0, addHeapObject(info));
    return ret !== 0;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} id
* @param {Uint32Array} info
* @returns {boolean}
*/
export function p3d_query_material_info(app, param, id, info) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArray32ToWasm0(info, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_material_info(app.__wbg_ptr, param.__wbg_ptr, id, ptr0, len0, addHeapObject(info));
    return ret !== 0;
}

/**
* 正向渲染
* Pass 配置使用默认值
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} cullingmode
* @param {number} collidermode
* @param {Int32Array} vals
* @returns {number}
*/
export function p3d_scene(app, cmds, cullingmode, collidermode, vals) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArray32ToWasm0(vals, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_scene(app.__wbg_ptr, cmds.__wbg_ptr, cullingmode, collidermode, ptr0, len0);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {boolean} val
*/
export function p3d_scene_animation_enable(cmds, scene, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_scene_animation_enable(cmds.__wbg_ptr, scene, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} val
*/
export function p3d_scene_time(cmds, scene, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_scene_time(cmds.__wbg_ptr, scene, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} r
* @param {number} g
* @param {number} b
*/
export function p3d_scene_fogcolor(cmds, scene, r, g, b) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_scene_fogcolor(cmds.__wbg_ptr, scene, r, g, b);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} mode
* @param {number} param0
* @param {number} param1
* @param {number} param2
*/
export function p3d_scene_fogparam(cmds, scene, mode, param0, param1, param2) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_scene_fogparam(cmds.__wbg_ptr, scene, mode, param0, param1, param2);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} r
* @param {number} g
* @param {number} b
*/
export function p3d_scene_ambientcolor(cmds, scene, r, g, b) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_scene_ambientcolor(cmds.__wbg_ptr, scene, r, g, b);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} val
*/
export function p3d_scene_ambientintensity(cmds, scene, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_scene_ambientintensity(cmds.__wbg_ptr, scene, val);
}

/**
*
* 相机渲染像素宽高
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} val
*/
export function p3d_layermask(cmds, node, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_layermask(cmds.__wbg_ptr, node, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {Atom} url
* @param {boolean} compressed
*/
export function p3d_scene_brdf_texture(cmds, scene, url, compressed) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(url, Atom);
    wasm.p3d_scene_brdf_texture(cmds.__wbg_ptr, scene, url.__wbg_ptr, compressed);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {Atom} url
* @param {boolean} data_is_image
*/
export function p3d_scene_env_texture(cmds, scene, url, data_is_image) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(url, Atom);
    wasm.p3d_scene_env_texture(cmds.__wbg_ptr, scene, url.__wbg_ptr, data_is_image);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number | undefined} [url]
*/
export function p3d_scene_shadowmap(cmds, scene, url) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_scene_shadowmap(cmds.__wbg_ptr, scene, !isLikeNone(url), isLikeNone(url) ? 0 : url);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {boolean} display
* @param {number} pass
*/
export function p3d_scene_boundingbox(cmds, scene, display, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_scene_boundingbox(cmds.__wbg_ptr, scene, display, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} minx
* @param {number} miny
* @param {number} minz
* @param {number} maxx
* @param {number} maxy
* @param {number} maxz
* @param {number} intersection_treshold
*/
export function p3d_collider(cmds, node, minx, miny, minz, maxx, maxy, maxz, intersection_treshold) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_collider(cmds.__wbg_ptr, node, minx, miny, minz, maxx, maxy, maxz, intersection_treshold);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} camera
* @param {number} projectx
* @param {number} projecty
* @param {Float32Array} result
* @returns {boolean}
*/
export function p3d_create_pickingray(app, param, camera, projectx, projecty, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF32ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_create_pickingray(app.__wbg_ptr, param.__wbg_ptr, camera, projectx, projecty, ptr0, len0, addHeapObject(result));
    return ret !== 0;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} scene
* @param {number} viewer
* @param {number} projectx
* @param {number} projecty
* @param {boolean} not_ray_bounding
* @param {Float64Array} result
* @returns {boolean}
*/
export function p3d_scene_pick(app, param, scene, viewer, projectx, projecty, not_ray_bounding, result) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF64ToWasm0(result, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_scene_pick(app.__wbg_ptr, param.__wbg_ptr, scene, viewer, projectx, projecty, not_ray_bounding, ptr0, len0, addHeapObject(result));
    return ret !== 0;
}

/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @returns {number}
*/
export function p3d_transform_node(app, cmds, scene) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    const ret = wasm.p3d_transform_node(app.__wbg_ptr, cmds.__wbg_ptr, scene);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} parent
*/
export function p3d_transform_node_parent(cmds, node, parent) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_transform_node_parent(cmds.__wbg_ptr, node, parent);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_transform_node_parent_arr(cmds, data, len) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF64ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_transform_node_parent_arr(cmds.__wbg_ptr, ptr0, len0, len);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {boolean} val
*/
export function p3d_node_enable(cmds, node, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_node_enable(cmds.__wbg_ptr, node, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_node_enable_arr(cmds, data, len) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF64ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_node_enable_arr(cmds.__wbg_ptr, ptr0, len0, len);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_local_position(cmds, node, x, y, z) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_local_position(cmds.__wbg_ptr, node, x, y, z);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_local_position_arr(cmds, data, len) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF64ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_local_position_arr(cmds.__wbg_ptr, ptr0, len0, len);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_local_scaling(cmds, node, x, y, z) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_local_scaling(cmds.__wbg_ptr, node, x, y, z);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_local_scaling_arr(cmds, data, len) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF64ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_local_scaling_arr(cmds.__wbg_ptr, ptr0, len0, len);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_local_euler(cmds, node, x, y, z) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_local_euler(cmds.__wbg_ptr, node, x, y, z);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_local_euler_arr(cmds, data, len) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF64ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_local_euler_arr(cmds.__wbg_ptr, ptr0, len0, len);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} node
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
*/
export function p3d_local_quaternion(cmds, node, x, y, z, w) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_local_quaternion(cmds.__wbg_ptr, node, x, y, z, w);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_local_quaternion_arr(cmds, data, len) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF64ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_local_quaternion_arr(cmds.__wbg_ptr, ptr0, len0, len);
}

/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @returns {number}
*/
export function p3d_camera(app, cmds, scene) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    const ret = wasm.p3d_camera(app.__wbg_ptr, cmds.__wbg_ptr, scene);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {number} size
*/
export function p3d_camera_size(cmds, camera, size) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_camera_size(cmds.__wbg_ptr, camera, size);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {number} fov
*/
export function p3d_camera_fov(cmds, camera, fov) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_camera_fov(cmds.__wbg_ptr, camera, fov);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {boolean} active
*/
export function p3d_camera_active(cmds, camera, active) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_camera_active(cmds.__wbg_ptr, camera, active);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {boolean} as_orthographic
*/
export function p3d_camera_mode(cmds, camera, as_orthographic) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_camera_mode(cmds.__wbg_ptr, camera, as_orthographic);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {boolean} as_horizontal
*/
export function p3d_camera_fixed_mode(cmds, camera, as_horizontal) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_camera_fixed_mode(cmds.__wbg_ptr, camera, as_horizontal);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_camera_target(cmds, camera, x, y, z) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_camera_target(cmds.__wbg_ptr, camera, x, y, z);
}

/**
*
* 相机渲染像素宽高
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {number} near
* @param {number} far
*/
export function p3d_camera_nearfar(cmds, camera, near, far) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_camera_nearfar(cmds.__wbg_ptr, camera, near, far);
}

/**
*
* 相机宽高比
* * @tip 传入null值对应 自适应宽高比
* * @tip 传入正小数 表示自定义宽高比
* * @example 16/9 16/10 null
* @param {CommandsExchangeD3} cmds
* @param {number} camera
* @param {number | undefined} [val]
*/
export function p3d_camera_aspect(cmds, camera, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_camera_aspect(cmds.__wbg_ptr, camera, !isLikeNone(val), isLikeNone(val) ? 0 : val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} viewer
* @param {number} entity
* @param {boolean} add
*/
export function p3d_viewer_force_include(cmds, viewer, entity, add) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_viewer_force_include(cmds.__wbg_ptr, viewer, entity, add);
}

/**
* * pass_tag:
*     * 0b0000_0000_0000_0001
*     * 0b0000_0000_0000_0010
*     * 0b0000_0000_0000_0100
*     * 0b0000_0000_0000_1000
*     * 0b0000_0000_0001_0000
*     * 0b0000_0000_0010_0000
*     * 0b0000_0000_0100_0000
*     * 0b0000_0000_1000_0000
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} viewer
* @param {string} name
* @param {number} pass_tag
* @param {boolean} transparent
* @returns {number}
*/
export function p3d_create_render(app, cmds, viewer, name, pass_tag, transparent) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passStringToWasm0(name, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_create_render(app.__wbg_ptr, cmds.__wbg_ptr, viewer, ptr0, len0, pass_tag, transparent);
    return ret;
}

/**
*
* Renderer Modify
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number | undefined} [keytarget]
*/
export function p3d_render_target_key(cmds, renderer, keytarget) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_render_target_key(cmds.__wbg_ptr, renderer, !isLikeNone(keytarget), isLikeNone(keytarget) ? 0 : keytarget);
}

/**
*
* Renderer Modify
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number} width
* @param {number} height
* @param {number} colorformat
* @param {number} depthstencilformat
*/
export function p3d_render_target_auto(cmds, renderer, width, height, colorformat, depthstencilformat) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_render_target_auto(cmds.__wbg_ptr, renderer, width, height, colorformat, depthstencilformat);
}

/**
*
* Renderer Modify
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {boolean} val
*/
export function p3d_render_auto_clear_color(cmds, renderer, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_render_auto_clear_color(cmds.__wbg_ptr, renderer, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {boolean} val
*/
export function p3d_render_auto_clear_depth(cmds, renderer, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_render_auto_clear_depth(cmds.__wbg_ptr, renderer, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {boolean} val
*/
export function p3d_render_auto_clear_stencil(cmds, renderer, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_render_auto_clear_stencil(cmds.__wbg_ptr, renderer, val);
}

/**
* r g b a 数值为 0 ~ 255 u8
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function p3d_render_clear_color(cmds, renderer, r, g, b, a) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_render_clear_color(cmds.__wbg_ptr, renderer, r, g, b, a);
}

/**
* val 数值为 0.~1.
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number} val
*/
export function p3d_render_clear_depth(cmds, renderer, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_render_clear_depth(cmds.__wbg_ptr, renderer, val);
}

/**
*
* val 数值为 u32
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number} val
*/
export function p3d_render_clear_stencil(cmds, renderer, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_render_clear_stencil(cmds.__wbg_ptr, renderer, val);
}

/**
*
* val 数值为 u32
* @param {CommandsExchangeD3} cmds
* @param {number} renderer
* @param {number} x
* @param {number} y
* @param {number} w
* @param {number} h
*/
export function p3d_render_viewport(cmds, renderer, x, y, w, h) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_render_viewport(cmds.__wbg_ptr, renderer, x, y, w, h);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} color_format
* @param {number} depth_stencil_format
* @param {number} width
* @param {number} height
* @param {number} filter
* @param {number} address
* @param {number} anisotropy_clamp
* @returns {number | undefined}
*/
export function p3d_create_render_target(app, param, color_format, depth_stencil_format, width, height, filter, address, anisotropy_clamp) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(app, Engine);
        _assertClass(param, ActionSetScene3D);
        wasm.p3d_create_render_target(retptr, app.__wbg_ptr, param.__wbg_ptr, color_format, depth_stencil_format, width, height, filter, address, anisotropy_clamp);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r2 = getFloat64Memory0()[retptr / 8 + 1];
        return r0 === 0 ? null : r2;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} key
*/
export function p3d_dispose_render_target(app, param, key) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    wasm.p3d_dispose_render_target(app.__wbg_ptr, param.__wbg_ptr, key);
}

/**
* @param {VInstanceAttributes} item
* @param {Atom} key
* @param {Atom} code
* @param {Atom} foruniform
* @param {number} vtype
*/
export function p3d_instance_attribute(item, key, code, foruniform, vtype) {
    _assertClass(item, VInstanceAttributes);
    _assertClass(key, Atom);
    _assertClass(code, Atom);
    _assertClass(foruniform, Atom);
    wasm.p3d_instance_attribute(item.__wbg_ptr, key.__wbg_ptr, code.__wbg_ptr, foruniform.__wbg_ptr, vtype);
}

/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {VInstanceAttributes} instancestate
* @param {boolean} instance_use_single_buffer
* @returns {number}
*/
export function p3d_mesh(app, cmds, scene, instancestate, instance_use_single_buffer) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(instancestate, VInstanceAttributes);
    const ret = wasm.p3d_mesh(app.__wbg_ptr, cmds.__wbg_ptr, scene, instancestate.__wbg_ptr, instance_use_single_buffer);
    return ret;
}

/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {GeometryMeta} geometa
* @returns {number}
*/
export function p3d_mesh_geometry(app, cmds, mesh, geometa) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(geometa, GeometryMeta);
    const ret = wasm.p3d_mesh_geometry(app.__wbg_ptr, cmds.__wbg_ptr, mesh, geometa.__wbg_ptr);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number | undefined} [index_start]
* @param {number | undefined} [index_end]
*/
export function p3d_mesh_indexrange(cmds, mesh, index_start, index_end) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_indexrange(cmds.__wbg_ptr, mesh, !isLikeNone(index_start), isLikeNone(index_start) ? 0 : index_start, !isLikeNone(index_end), isLikeNone(index_end) ? 0 : index_end);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number | undefined} [vertex_start]
* @param {number | undefined} [vertex_count]
*/
export function p3d_mesh_vertexrange(cmds, mesh, vertex_start, vertex_count) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_vertexrange(cmds.__wbg_ptr, mesh, !isLikeNone(vertex_start), isLikeNone(vertex_start) ? 0 : vertex_start, !isLikeNone(vertex_count), isLikeNone(vertex_count) ? 0 : vertex_count);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {boolean} enable
* @param {number} src_color
* @param {number} dst_color
* @param {number} src_alpha
* @param {number} dst_alpha
* @param {number} opt_color
* @param {number} opt_alpha
* @param {number | undefined} [pass]
*/
export function p3d_mesh_blend(cmds, mesh, enable, src_color, dst_color, src_alpha, dst_alpha, opt_color, opt_alpha, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_blend(cmds.__wbg_ptr, mesh, enable, src_color, dst_color, src_alpha, dst_alpha, opt_color, opt_alpha, !isLikeNone(pass), isLikeNone(pass) ? 0 : pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_cull_mode(cmds, mesh, val, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_cull_mode(cmds.__wbg_ptr, mesh, val, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_frontface(cmds, mesh, val, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_frontface(cmds.__wbg_ptr, mesh, val, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_topology(cmds, mesh, val, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_topology(cmds.__wbg_ptr, mesh, val, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_polygon_mode(cmds, mesh, val, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_polygon_mode(cmds.__wbg_ptr, mesh, val, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {boolean} val
* @param {number} pass
*/
export function p3d_mesh_unclip_depth(cmds, mesh, val, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_unclip_depth(cmds.__wbg_ptr, mesh, val, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {boolean} val
* @param {number} pass
*/
export function p3d_mesh_cast_shadow(cmds, mesh, val, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_cast_shadow(cmds.__wbg_ptr, mesh, val, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {boolean} val
* @param {number} pass
*/
export function p3d_mesh_receive_shadow(cmds, mesh, val, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_receive_shadow(cmds.__wbg_ptr, mesh, val, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {boolean} val
* @param {number} pass
*/
export function p3d_mesh_depth_write(cmds, mesh, val, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_depth_write(cmds.__wbg_ptr, mesh, val, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_depth_compare(cmds, mesh, val, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_depth_compare(cmds.__wbg_ptr, mesh, val, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} constant
* @param {number} slope_scale
* @param {number} clamp
* @param {number} pass
*/
export function p3d_mesh_depth_bias(cmds, mesh, constant, slope_scale, clamp, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_depth_bias(cmds.__wbg_ptr, mesh, constant, slope_scale, clamp, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} compare
* @param {number} fail_op
* @param {number} depth_fail_op
* @param {number} pass_op
* @param {number} pass
*/
export function p3d_mesh_stencil_front(cmds, mesh, compare, fail_op, depth_fail_op, pass_op, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_stencil_front(cmds.__wbg_ptr, mesh, compare, fail_op, depth_fail_op, pass_op, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} compare
* @param {number} fail_op
* @param {number} depth_fail_op
* @param {number} pass_op
* @param {number} pass
*/
export function p3d_mesh_stencil_back(cmds, mesh, compare, fail_op, depth_fail_op, pass_op, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_stencil_back(cmds.__wbg_ptr, mesh, compare, fail_op, depth_fail_op, pass_op, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_stencil_read(cmds, mesh, val, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_stencil_read(cmds.__wbg_ptr, mesh, val, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
* @param {number} pass
*/
export function p3d_mesh_stencil_write(cmds, mesh, val, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_stencil_write(cmds.__wbg_ptr, mesh, val, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} minx
* @param {number} miny
* @param {number} minz
* @param {number} maxx
* @param {number} maxy
* @param {number} maxz
*/
export function p3d_mesh_bounding_box(cmds, mesh, minx, miny, minz, maxx, maxy, maxz) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_bounding_box(cmds.__wbg_ptr, mesh, minx, miny, minz, maxx, maxy, maxz);
}

/**
*
* * `mode` = `1`: ECullingStrategy::Optimistic
* * `mode` = `2`: ECullingStrategy::STANDARD
* * `mode` = `_`: ECullingStrategy::None
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} mode
*/
export function p3d_mesh_bounding_cullingmode(cmds, mesh, mode) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_bounding_cullingmode(cmds.__wbg_ptr, mesh, mode);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} group
* @param {number} index
*/
export function p3d_mesh_render_queue(cmds, mesh, group, index) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_render_queue(cmds.__wbg_ptr, mesh, group, index);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_mesh_render_queue_arr(cmds, data, len) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF64ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_mesh_render_queue_arr(cmds.__wbg_ptr, ptr0, len0, len);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
*/
export function p3d_mesh_render_alignment(cmds, mesh, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_render_alignment(cmds.__wbg_ptr, mesh, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
*/
export function p3d_mesh_instance_sort_mode(cmds, mesh, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_instance_sort_mode(cmds.__wbg_ptr, mesh, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} val
*/
export function p3d_abstruct_mesh_scaling_mode(cmds, mesh, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_abstruct_mesh_scaling_mode(cmds.__wbg_ptr, mesh, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_abstruct_mesh_velocity(cmds, mesh, x, y, z) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_abstruct_mesh_velocity(cmds.__wbg_ptr, mesh, x, y, z);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_abstruct_mesh_velocity_arr(cmds, data, len) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF64ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_abstruct_mesh_velocity_arr(cmds.__wbg_ptr, ptr0, len0, len);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} abstructmesh
* @param {number} group
* @param {Atom} key
* @param {number} curve_key
*/
export function p3d_attribute_target_animation(cmds, abstructmesh, group, key, curve_key) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(key, Atom);
    wasm.p3d_attribute_target_animation(cmds.__wbg_ptr, abstructmesh, group, key.__wbg_ptr, curve_key);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh
* @param {Float32Array} data
*/
export function p3d_abstruct_pose_matrix(cmds, mesh, data) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF32ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_abstruct_pose_matrix(cmds.__wbg_ptr, mesh, ptr0, len0);
}

/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} source
* @returns {number}
*/
export function p3d_instance_mesh(app, cmds, source) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    const ret = wasm.p3d_instance_mesh(app.__wbg_ptr, cmds.__wbg_ptr, source);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} uscale
* @param {number} vscale
* @param {number} uoffset
* @param {number} voffset
* @param {Atom} attr
*/
export function p3d_instance_mesh_vec4(cmds, instance, uscale, vscale, uoffset, voffset, attr) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(attr, Atom);
    wasm.p3d_instance_mesh_vec4(cmds.__wbg_ptr, instance, uscale, vscale, uoffset, voffset, attr.__wbg_ptr);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} r
* @param {number} g
* @param {number} b
* @param {Atom} attr
*/
export function p3d_instance_mesh_vec3(cmds, instance, r, g, b, attr) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(attr, Atom);
    wasm.p3d_instance_mesh_vec3(cmds.__wbg_ptr, instance, r, g, b, attr.__wbg_ptr);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {number} y
* @param {Atom} attr
*/
export function p3d_instance_mesh_vec2(cmds, instance, x, y, attr) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(attr, Atom);
    wasm.p3d_instance_mesh_vec2(cmds.__wbg_ptr, instance, x, y, attr.__wbg_ptr);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} val
* @param {Atom} attr
*/
export function p3d_instance_mesh_float(cmds, instance, val, attr) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(attr, Atom);
    wasm.p3d_instance_mesh_float(cmds.__wbg_ptr, instance, val, attr.__wbg_ptr);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {Atom} attr
*/
export function p3d_instance_mesh_sint(cmds, instance, x, attr) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(attr, Atom);
    wasm.p3d_instance_mesh_sint(cmds.__wbg_ptr, instance, x, attr.__wbg_ptr);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {Atom} attr
*/
export function p3d_instance_mesh_uint(cmds, instance, x, attr) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(attr, Atom);
    wasm.p3d_instance_mesh_uint(cmds.__wbg_ptr, instance, x, attr.__wbg_ptr);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @param {Atom} attr
*/
export function p3d_instance_mesh_ivec4(cmds, instance, x, y, z, w, attr) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(attr, Atom);
    wasm.p3d_instance_mesh_ivec4(cmds.__wbg_ptr, instance, x, y, z, w, attr.__wbg_ptr);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {number} y
* @param {Atom} attr
*/
export function p3d_instance_mesh_u16x2(cmds, instance, x, y, attr) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(attr, Atom);
    wasm.p3d_instance_mesh_u16x2(cmds.__wbg_ptr, instance, x, y, attr.__wbg_ptr);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @param {Atom} attr
*/
export function p3d_instance_mesh_u16x4(cmds, instance, x, y, z, w, attr) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(attr, Atom);
    wasm.p3d_instance_mesh_u16x4(cmds.__wbg_ptr, instance, x, y, z, w, attr.__wbg_ptr);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @param {Atom} attr
*/
export function p3d_instance_mesh_u8x4(cmds, instance, x, y, z, w, attr) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(attr, Atom);
    wasm.p3d_instance_mesh_u8x4(cmds.__wbg_ptr, instance, x, y, z, w, attr.__wbg_ptr);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} instance
* @param {number} val
*/
export function p3d_mesh_bone_offset(cmds, instance, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_mesh_bone_offset(cmds.__wbg_ptr, instance, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {Float64Array} data
* @param {number} len
*/
export function p3d_mesh_bone_offset_arr(cmds, data, len) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF64ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_mesh_bone_offset_arr(cmds.__wbg_ptr, ptr0, len0, len);
}

/**
* @param {VBMeta} meta
* @param {number} attr
* @param {number} format
*/
export function p3d_vbmeta_attr(meta, attr, format) {
    _assertClass(meta, VBMeta);
    wasm.p3d_vbmeta_attr(meta.__wbg_ptr, attr, format);
}

/**
* @param {VBMeta} meta
* @param {Atom} key
* @param {number} format
* @param {Atom} code
* @param {Atom} foruniform
*/
export function p3d_vbmeta_custom_attr(meta, key, format, code, foruniform) {
    _assertClass(meta, VBMeta);
    _assertClass(key, Atom);
    _assertClass(code, Atom);
    _assertClass(foruniform, Atom);
    wasm.p3d_vbmeta_custom_attr(meta.__wbg_ptr, key.__wbg_ptr, format, code.__wbg_ptr, foruniform.__wbg_ptr);
}

/**
* @param {GeometryMeta} geo
* @param {VBMeta} vb
*/
export function p3d_geo_set_vertex(geo, vb) {
    _assertClass(geo, GeometryMeta);
    _assertClass(vb, VBMeta);
    wasm.p3d_geo_set_vertex(geo.__wbg_ptr, vb.__wbg_ptr);
}

/**
* @param {GeometryMeta} geo
* @param {string} name
* @param {number | undefined} start
* @param {number | undefined} end
* @param {boolean} as_u16
*/
export function p3d_geo_set_indice(geo, name, start, end, as_u16) {
    _assertClass(geo, GeometryMeta);
    const ptr0 = passStringToWasm0(name, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_geo_set_indice(geo.__wbg_ptr, ptr0, len0, !isLikeNone(start), isLikeNone(start) ? 0 : start, !isLikeNone(end), isLikeNone(end) ? 0 : end, as_u16);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {string} key
* @param {Float32Array} data
* @param {number} length
*/
export function p3d_create_vertex_buffer(app, param, key, data, length) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    const ptr0 = passStringToWasm0(key, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passArrayF32ToWasm0(data, wasm.__wbindgen_malloc);
    const len1 = WASM_VECTOR_LEN;
    wasm.p3d_create_vertex_buffer(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, ptr1, len1, length);
}

let cachedUint16Memory0 = null;

function getUint16Memory0() {
    if (cachedUint16Memory0 === null || cachedUint16Memory0.byteLength === 0) {
        cachedUint16Memory0 = new Uint16Array(wasm.memory.buffer);
    }
    return cachedUint16Memory0;
}

function passArray16ToWasm0(arg, malloc) {
    const ptr = malloc(arg.length * 2, 2) >>> 0;
    getUint16Memory0().set(arg, ptr / 2);
    WASM_VECTOR_LEN = arg.length;
    return ptr;
}
/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {string} key
* @param {Uint16Array} data
* @param {number} length
*/
export function p3d_create_indices_buffer(app, param, key, data, length) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    const ptr0 = passStringToWasm0(key, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passArray16ToWasm0(data, wasm.__wbindgen_malloc);
    const len1 = WASM_VECTOR_LEN;
    wasm.p3d_create_indices_buffer(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, ptr1, len1, length);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {string} key
* @param {Uint32Array} data
* @param {number} length
*/
export function p3d_create_indices_buffer_u32(app, param, key, data, length) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    const ptr0 = passStringToWasm0(key, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passArray32ToWasm0(data, wasm.__wbindgen_malloc);
    const len1 = WASM_VECTOR_LEN;
    wasm.p3d_create_indices_buffer_u32(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, ptr1, len1, length);
}

/**
* @param {Engine} app
* @returns {number}
*/
export function p3d_material(app) {
    _assertClass(app, Engine);
    const ret = wasm.p3d_entity(app.__wbg_ptr);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} shader
*/
export function p3d_material_shader(cmds, mat, shader) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(shader, Atom);
    wasm.p3d_material_shader(cmds.__wbg_ptr, mat, shader.__wbg_ptr);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {number} mesh
* @param {number} pass
*/
export function p3d_material_apply(cmds, mat, mesh, pass) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_material_apply(cmds.__wbg_ptr, mat, mesh, pass);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {number} m11
* @param {number} m12
* @param {number} m13
* @param {number} m14
* @param {number} m21
* @param {number} m22
* @param {number} m23
* @param {number} m24
* @param {number} m31
* @param {number} m32
* @param {number} m33
* @param {number} m34
* @param {number} m41
* @param {number} m42
* @param {number} m43
* @param {number} m44
*/
export function p3d_material_uniform_mat4(cmds, mat, key, m11, m12, m13, m14, m21, m22, m23, m24, m31, m32, m33, m34, m41, m42, m43, m44) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(key, Atom);
    wasm.p3d_material_uniform_mat4(cmds.__wbg_ptr, mat, key.__wbg_ptr, m11, m12, m13, m14, m21, m22, m23, m24, m31, m32, m33, m34, m41, m42, m43, m44);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {number} x
* @param {number} y
*/
export function p3d_material_uniform_vec2(cmds, mat, key, x, y) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(key, Atom);
    wasm.p3d_material_uniform_vec2(cmds.__wbg_ptr, mat, key.__wbg_ptr, x, y);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
*/
export function p3d_material_uniform_vec4(cmds, mat, key, x, y, z, w) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(key, Atom);
    wasm.p3d_material_uniform_vec4(cmds.__wbg_ptr, mat, key.__wbg_ptr, x, y, z, w);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {number} val
*/
export function p3d_material_uniform_float(cmds, mat, key, val) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(key, Atom);
    wasm.p3d_material_uniform_float(cmds.__wbg_ptr, mat, key.__wbg_ptr, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {number} val
*/
export function p3d_material_uniform_uint(cmds, mat, key, val) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(key, Atom);
    wasm.p3d_material_uniform_uint(cmds.__wbg_ptr, mat, key.__wbg_ptr, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {Atom} url
* @param {boolean} srgb
* @param {boolean} compressed
* @param {boolean} filter
* @param {number} address_mode_u
* @param {number} address_mode_v
* @param {number} address_mode_w
* @param {number} mag_filter
* @param {number} min_filter
* @param {number} mipmap_filter
* @param {number} anisotropy_clamp
* @param {number} border_color
* @param {boolean} isfile
* @param {boolean} cancombine
* @param {number | undefined} [compare]
*/
export function p3d_material_uniform_tex(cmds, mat, key, url, srgb, compressed, filter, address_mode_u, address_mode_v, address_mode_w, mag_filter, min_filter, mipmap_filter, anisotropy_clamp, border_color, isfile, cancombine, compare) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(key, Atom);
    _assertClass(url, Atom);
    wasm.p3d_material_uniform_tex(cmds.__wbg_ptr, mat, key.__wbg_ptr, url.__wbg_ptr, srgb, compressed, filter, address_mode_u, address_mode_v, address_mode_w, mag_filter, min_filter, mipmap_filter, anisotropy_clamp, border_color, isfile, cancombine, !isLikeNone(compare), isLikeNone(compare) ? 0 : compare);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {Atom} key
* @param {Atom} key_tilloff
* @param {number} url
* @param {boolean} filter
* @param {number} address_mode_u
* @param {number} address_mode_v
* @param {number} address_mode_w
* @param {number} mag_filter
* @param {number} min_filter
* @param {number} mipmap_filter
* @param {number} anisotropy_clamp
* @param {number} border_color
* @param {number | undefined} [compare]
*/
export function p3d_material_uniform_tex_from_render_target(cmds, mat, key, key_tilloff, url, filter, address_mode_u, address_mode_v, address_mode_w, mag_filter, min_filter, mipmap_filter, anisotropy_clamp, border_color, compare) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(key, Atom);
    _assertClass(key_tilloff, Atom);
    wasm.p3d_material_uniform_tex_from_render_target(cmds.__wbg_ptr, mat, key.__wbg_ptr, key_tilloff.__wbg_ptr, url, filter, address_mode_u, address_mode_v, address_mode_w, mag_filter, min_filter, mipmap_filter, anisotropy_clamp, border_color, !isLikeNone(compare), isLikeNone(compare) ? 0 : compare);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mat
* @param {number} group
* @param {Atom} key
* @param {number} curve_key
*/
export function p3d_uniform_target_animation(cmds, mat, group, key, curve_key) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(key, Atom);
    wasm.p3d_uniform_target_animation(cmds.__wbg_ptr, mat, group, key.__wbg_ptr, curve_key);
}

/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} ltype
* @returns {number}
*/
export function p3d_light(app, cmds, scene, ltype) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    const ret = wasm.p3d_light(app.__wbg_ptr, cmds.__wbg_ptr, scene, ltype);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} light
* @param {number} x
* @param {number} y
* @param {number} z
*/
export function p3d_light_direction(cmds, light, x, y, z) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_light_direction(cmds.__wbg_ptr, light, x, y, z);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} light
* @param {number} val
*/
export function p3d_light_strength(cmds, light, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_light_strength(cmds.__wbg_ptr, light, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} light
* @param {number} inner
* @param {number} outer
*/
export function p3d_light_spot_angle(cmds, light, inner, outer) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_light_spot_angle(cmds.__wbg_ptr, light, inner, outer);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} light
* @param {number} val
*/
export function p3d_light_radius(cmds, light, val) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_light_radius(cmds.__wbg_ptr, light, val);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} light
* @param {number} r
* @param {number} g
* @param {number} b
*/
export function p3d_light_color(cmds, light, r, g, b) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_light_color(cmds.__wbg_ptr, light, r, g, b);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh_or_instance
* @param {number} light
* @param {boolean} is_add
*/
export function p3d_abstructmesh_force_point_light(cmds, mesh_or_instance, light, is_add) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_abstructmesh_force_point_light(cmds.__wbg_ptr, mesh_or_instance, light, is_add);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh_or_instance
* @param {number} light
* @param {boolean} is_add
*/
export function p3d_abstructmesh_force_spot_light(cmds, mesh_or_instance, light, is_add) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_abstructmesh_force_spot_light(cmds.__wbg_ptr, mesh_or_instance, light, is_add);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} mesh_or_instance
* @param {number} light
* @param {boolean} is_add
*/
export function p3d_abstructmesh_force_hemi_light(cmds, mesh_or_instance, light, is_add) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_abstructmesh_force_hemi_light(cmds.__wbg_ptr, mesh_or_instance, light, is_add);
}

/**
* * pass_tag:
*     * 0b0000_0000_0000_0001
*     * 0b0000_0000_0000_0010
*     * 0b0000_0000_0000_0100
*     * 0b0000_0000_0000_1000
*     * 0b0000_0000_0001_0000
*     * 0b0000_0000_0010_0000
*     * 0b0000_0000_0100_0000
*     * 0b0000_0000_1000_0000
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} light
* @param {number} pass_tag
* @returns {number}
*/
export function p3d_shadow_generator(app, cmds, scene, light, pass_tag) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    const ret = wasm.p3d_shadow_generator(app.__wbg_ptr, cmds.__wbg_ptr, scene, light, pass_tag);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} shadow
* @param {number} bias
* @param {number} normal_bias
* @param {number} depthscale
* @returns {number}
*/
export function p3d_shadow_base_param(cmds, shadow, bias, normal_bias, depthscale) {
    _assertClass(cmds, CommandsExchangeD3);
    const ret = wasm.p3d_shadow_base_param(cmds.__wbg_ptr, shadow, bias, normal_bias, depthscale);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} shadow
* @param {number} frustum_size
* @param {number} minz
* @param {number} maxz
*/
export function p3d_shadow_frustum(cmds, shadow, frustum_size, minz, maxz) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_shadow_frustum(cmds.__wbg_ptr, shadow, frustum_size, minz, maxz);
}

/**
* @param {NodeMaterialBlock} block
* @param {Atom} depend
*/
export function p3d_node_material_block_extend_depend(block, depend) {
    _assertClass(block, NodeMaterialBlock);
    _assertClass(depend, Atom);
    wasm.p3d_node_material_block_extend_depend(block.__wbg_ptr, depend.__wbg_ptr);
}

/**
* @param {NodeMaterialBlock} block
* @param {number} bind_define
*/
export function p3d_node_material_block_extend_bind_define(block, bind_define) {
    _assertClass(block, NodeMaterialBlock);
    wasm.p3d_node_material_block_extend_bind_define(block.__wbg_ptr, bind_define);
}

/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} m11
* @param {number} m12
* @param {number} m13
* @param {number} m14
* @param {number} m21
* @param {number} m22
* @param {number} m23
* @param {number} m24
* @param {number} m31
* @param {number} m32
* @param {number} m33
* @param {number} m34
* @param {number} m41
* @param {number} m42
* @param {number} m43
* @param {number} m44
*/
export function p3d_node_material_block_mat4(block, key, m11, m12, m13, m14, m21, m22, m23, m24, m31, m32, m33, m34, m41, m42, m43, m44) {
    _assertClass(block, NodeMaterialBlock);
    _assertClass(key, Atom);
    wasm.p3d_node_material_block_mat4(block.__wbg_ptr, key.__wbg_ptr, m11, m12, m13, m14, m21, m22, m23, m24, m31, m32, m33, m34, m41, m42, m43, m44);
}

/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @param {boolean} caninstance
*/
export function p3d_node_material_block_vec4(block, key, x, y, z, w, caninstance) {
    _assertClass(block, NodeMaterialBlock);
    _assertClass(key, Atom);
    wasm.p3d_node_material_block_vec4(block.__wbg_ptr, key.__wbg_ptr, x, y, z, w, caninstance);
}

/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} x
* @param {number} y
* @param {number} z
* @param {boolean} caninstance
*/
export function p3d_node_material_block_vec3(block, key, x, y, z, caninstance) {
    _assertClass(block, NodeMaterialBlock);
    _assertClass(key, Atom);
    wasm.p3d_node_material_block_vec3(block.__wbg_ptr, key.__wbg_ptr, x, y, z, caninstance);
}

/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} x
* @param {number} y
* @param {boolean} caninstance
*/
export function p3d_node_material_block_vec2(block, key, x, y, caninstance) {
    _assertClass(block, NodeMaterialBlock);
    _assertClass(key, Atom);
    wasm.p3d_node_material_block_vec2(block.__wbg_ptr, key.__wbg_ptr, x, y, caninstance);
}

/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} x
* @param {boolean} caninstance
*/
export function p3d_node_material_block_float(block, key, x, caninstance) {
    _assertClass(block, NodeMaterialBlock);
    _assertClass(key, Atom);
    wasm.p3d_node_material_block_float(block.__wbg_ptr, key.__wbg_ptr, x, caninstance);
}

/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {number} x
* @param {boolean} caninstance
*/
export function p3d_node_material_block_uint(block, key, x, caninstance) {
    _assertClass(block, NodeMaterialBlock);
    _assertClass(key, Atom);
    wasm.p3d_node_material_block_uint(block.__wbg_ptr, key.__wbg_ptr, x, caninstance);
}

/**
* @param {NodeMaterialBlock} block
* @param {Atom} name
* @param {Atom} format
*/
export function p3d_node_material_block_varying(block, name, format) {
    _assertClass(block, NodeMaterialBlock);
    _assertClass(name, Atom);
    _assertClass(format, Atom);
    wasm.p3d_node_material_block_varying(block.__wbg_ptr, name.__wbg_ptr, format.__wbg_ptr);
}

/**
* @param {NodeMaterialBlock} block
* @param {Atom} key
* @param {boolean} filterable
* @param {number} stage
* @param {number} default_texture
* @param {number} demision
*/
export function p3d_node_material_block_texture(block, key, filterable, stage, default_texture, demision) {
    _assertClass(block, NodeMaterialBlock);
    _assertClass(key, Atom);
    wasm.p3d_node_material_block_texture(block.__wbg_ptr, key.__wbg_ptr, filterable, stage, default_texture, demision);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {NodeMaterialBlock} block
*/
export function p3d_node_material_block_regist(app, param, block) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    _assertClass(block, NodeMaterialBlock);
    wasm.p3d_node_material_block_regist(app.__wbg_ptr, param.__wbg_ptr, block.__wbg_ptr);
}

/**
* @param {NodematerialIncludes} includes
* @param {BuiltinNodeMaterialBlock} block
*/
export function p3d_material_include(includes, block) {
    _assertClass(includes, NodematerialIncludes);
    wasm.p3d_material_include(includes.__wbg_ptr, block);
}

/**
* @param {NodematerialIncludes} includes
* @param {Atom} block
*/
export function p3d_material_include_by_name(includes, block) {
    _assertClass(includes, NodematerialIncludes);
    _assertClass(block, Atom);
    wasm.p3d_material_include_by_name(includes.__wbg_ptr, block.__wbg_ptr);
}

/**
* @param {NodematerialIncludes} includes
*/
export function p3d_material_includes_reset(includes) {
    _assertClass(includes, NodematerialIncludes);
    wasm.p3d_material_includes_reset(includes.__wbg_ptr);
}

/**
* @param {MaterialUniformDefines} uniforms
* @param {string} key
* @param {number} val
* @param {boolean} caninstance
*/
export function p3d_shader_uniform_float(uniforms, key, val, caninstance) {
    _assertClass(uniforms, MaterialUniformDefines);
    const ptr0 = passStringToWasm0(key, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_shader_uniform_float(uniforms.__wbg_ptr, ptr0, len0, val, caninstance);
}

/**
* @param {MaterialUniformDefines} uniforms
* @param {string} key
* @param {number} x
* @param {number} y
* @param {boolean} caninstance
*/
export function p3d_shader_uniform_vec2(uniforms, key, x, y, caninstance) {
    _assertClass(uniforms, MaterialUniformDefines);
    const ptr0 = passStringToWasm0(key, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_shader_uniform_vec2(uniforms.__wbg_ptr, ptr0, len0, x, y, caninstance);
}

/**
* @param {MaterialUniformDefines} uniforms
* @param {string} key
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @param {boolean} caninstance
*/
export function p3d_shader_uniform_vec4(uniforms, key, x, y, z, w, caninstance) {
    _assertClass(uniforms, MaterialUniformDefines);
    const ptr0 = passStringToWasm0(key, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_shader_uniform_vec4(uniforms.__wbg_ptr, ptr0, len0, x, y, z, w, caninstance);
}

/**
* @param {MaterialUniformDefines} uniforms
* @param {string} key
* @param {number} val
* @param {boolean} caninstance
*/
export function p3d_shader_uniform_uint(uniforms, key, val, caninstance) {
    _assertClass(uniforms, MaterialUniformDefines);
    const ptr0 = passStringToWasm0(key, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_shader_uniform_uint(uniforms.__wbg_ptr, ptr0, len0, val, caninstance);
}

/**
* @param {MaterialUniformDefines} uniforms
* @param {string} key
* @param {boolean} filterable
* @param {number} stage
* @param {number} default_texture
* @param {number} demision
*/
export function p3d_shader_uniform_tex(uniforms, key, filterable, stage, default_texture, demision) {
    _assertClass(uniforms, MaterialUniformDefines);
    const ptr0 = passStringToWasm0(key, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_shader_uniform_tex(uniforms.__wbg_ptr, ptr0, len0, filterable, stage, default_texture, demision);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {string} key
* @returns {boolean}
*/
export function p3d_check_shader(app, param, key) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    const ptr0 = passStringToWasm0(key, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_check_shader(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0);
    return ret !== 0;
}

/**
* @param {P3DShaderVaryings} block
* @param {Atom} name
* @param {Atom} format
*/
export function p3d_varying(block, name, format) {
    _assertClass(block, P3DShaderVaryings);
    _assertClass(name, Atom);
    _assertClass(format, Atom);
    wasm.p3d_varying(block.__wbg_ptr, name.__wbg_ptr, format.__wbg_ptr);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {string} key
* @param {MaterialUniformDefines} uniforms
* @param {string} vs_define_code
* @param {string} fs_define_code
* @param {string} vs_code
* @param {string} fs_code
* @param {NodematerialIncludes} includes
* @param {string} instance_code
* @param {P3DShaderVaryings} varyings
* @param {number | undefined} [binds_defines_base]
* @returns {P3DShaderMeta | undefined}
*/
export function p3d_regist_material(app, param, key, uniforms, vs_define_code, fs_define_code, vs_code, fs_code, includes, instance_code, varyings, binds_defines_base) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    const ptr0 = passStringToWasm0(key, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    _assertClass(uniforms, MaterialUniformDefines);
    const ptr1 = passStringToWasm0(vs_define_code, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ptr2 = passStringToWasm0(fs_define_code, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len2 = WASM_VECTOR_LEN;
    const ptr3 = passStringToWasm0(vs_code, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len3 = WASM_VECTOR_LEN;
    const ptr4 = passStringToWasm0(fs_code, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len4 = WASM_VECTOR_LEN;
    _assertClass(includes, NodematerialIncludes);
    const ptr5 = passStringToWasm0(instance_code, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len5 = WASM_VECTOR_LEN;
    _assertClass(varyings, P3DShaderVaryings);
    const ret = wasm.p3d_regist_material(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, uniforms.__wbg_ptr, ptr1, len1, ptr2, len2, ptr3, len3, ptr4, len4, includes.__wbg_ptr, ptr5, len5, varyings.__wbg_ptr, !isLikeNone(binds_defines_base), isLikeNone(binds_defines_base) ? 0 : binds_defines_base);
    return ret === 0 ? null : P3DShaderMeta.__wrap(ret);
}

/**
* @param {CommandsExchangeD3} param
* @param {Atom} key
* @param {number} width
* @param {number} height
* @param {number} format
* @param {number | undefined} [aspect]
*/
export function p3d_create_data_texture(param, key, width, height, format, aspect) {
    _assertClass(param, CommandsExchangeD3);
    _assertClass(key, Atom);
    wasm.p3d_create_data_texture(param.__wbg_ptr, key.__wbg_ptr, width, height, format, !isLikeNone(aspect), isLikeNone(aspect) ? 0 : aspect);
}

/**
* @param {CommandsExchangeD3} param
* @param {Atom} key
* @param {Uint8Array} data
* @param {number} xoffset
* @param {number} yoffset
* @param {number} width
* @param {number} height
* @param {number | undefined} [aspect]
*/
export function p3d_update_data_texture(param, key, data, xoffset, yoffset, width, height, aspect) {
    _assertClass(param, CommandsExchangeD3);
    _assertClass(key, Atom);
    const ptr0 = passArray8ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_update_data_texture(param.__wbg_ptr, key.__wbg_ptr, ptr0, len0, xoffset, yoffset, width, height, !isLikeNone(aspect), isLikeNone(aspect) ? 0 : aspect);
}

/**
* @param {CommandsExchangeD3} param
* @param {Atom} key
*/
export function p3d_remove_data_texture(param, key) {
    _assertClass(param, CommandsExchangeD3);
    _assertClass(key, Atom);
    wasm.p3d_remove_data_texture(param.__wbg_ptr, key.__wbg_ptr);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {boolean} isfile
* @param {Atom} url
* @param {boolean} cancombine
* @param {boolean} compressed
* @param {number} depth_or_array_layers
* @param {Float32Array} info
* @returns {boolean}
*/
export function p3d_query_texture(app, param, isfile, url, cancombine, compressed, depth_or_array_layers, info) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    _assertClass(url, Atom);
    var ptr0 = passArrayF32ToWasm0(info, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_texture(app.__wbg_ptr, param.__wbg_ptr, isfile, url.__wbg_ptr, cancombine, compressed, depth_or_array_layers, ptr0, len0, addHeapObject(info));
    return ret !== 0;
}

/**
* @param {CommandsExchangeD3} cmd
* @param {number} requestid
* @param {Atom} targetkey
* @param {Atom} file
* @param {number} idx
* @param {boolean} iscompress
* @param {number} xoffset
* @param {number} yoffset
* @param {number} width
* @param {number} height
*/
export function p3d_texture_combine_add_frame(cmd, requestid, targetkey, file, idx, iscompress, xoffset, yoffset, width, height) {
    _assertClass(cmd, CommandsExchangeD3);
    _assertClass(targetkey, Atom);
    _assertClass(file, Atom);
    wasm.p3d_texture_combine_add_frame(cmd.__wbg_ptr, requestid, targetkey.__wbg_ptr, file.__wbg_ptr, idx, iscompress, xoffset, yoffset, width, height);
}

/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmd
* @param {number} requestid
* @param {Atom} targetkey
*/
export function p3d_texture_combine_remove(app, cmd, requestid, targetkey) {
    _assertClass(app, Engine);
    _assertClass(cmd, CommandsExchangeD3);
    _assertClass(targetkey, Atom);
    wasm.p3d_texture_combine_remove(app.__wbg_ptr, cmd.__wbg_ptr, requestid, targetkey.__wbg_ptr);
}

/**
* @param {Engine} app
* @param {Uint32Array} success
* @param {Uint32Array} fail
*/
export function p3d_texture_combine_query(app, success, fail) {
    _assertClass(app, Engine);
    var ptr0 = passArray32ToWasm0(success, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    var ptr1 = passArray32ToWasm0(fail, wasm.__wbindgen_malloc);
    var len1 = WASM_VECTOR_LEN;
    wasm.p3d_texture_combine_query(app.__wbg_ptr, ptr0, len0, addHeapObject(success), ptr1, len1, addHeapObject(fail));
}

/**
* @param {Engine} app
* @param {number} format
* @param {number} maxlayer
* @param {number} maxsize
* @param {number} maxcount
*/
export function p3d_texture_combine_param(app, format, maxlayer, maxsize, maxcount) {
    _assertClass(app, Engine);
    wasm.p3d_texture_combine_param(app.__wbg_ptr, format, maxlayer, maxsize, maxcount);
}

/**
* 创建动画组
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @returns {number}
*/
export function p3d_animation_group(app, cmds, scene) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    const ret = wasm.p3d_animation_group(app.__wbg_ptr, cmds.__wbg_ptr, scene);
    return ret;
}

/**
* 动画曲线ID
* @param {Atom} key
* @returns {number}
*/
export function p3d_animation_curve_id(key) {
    _assertClass(key, Atom);
    const ret = wasm.p3d_animation_curve_id(key.__wbg_ptr);
    return ret;
}

/**
* 设置 动画组 混合权重
* @param {CommandsExchangeD3} cmds
* @param {number} group
* @param {number} weight
*/
export function p3d_animation_group_weight(cmds, group, weight) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_animation_group_weight(cmds.__wbg_ptr, group, weight);
}

/**
* 重置动画组各动画作用目标到非动画操作状态
* @param {CommandsExchangeD3} cmds
* @param {number} group
*/
export function p3d_animation_group_target_reset(cmds, group) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_animation_group_target_reset(cmds.__wbg_ptr, group);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} group_key
* @param {number} speed
* @param {ELoopMode} loop_mode
* @param {number | undefined} loop_count
* @param {number} from
* @param {number} to
* @param {number} fps
* @param {EAmountMode} amount_mode
* @param {number} delay_ms
* @param {EFillMode} fillmode
* @param {number} amount_param0
* @param {number} amount_param1
* @param {number} amount_param2
* @param {number} amount_param3
*/
export function p3d_anime_group_start(cmds, group_key, speed, loop_mode, loop_count, from, to, fps, amount_mode, delay_ms, fillmode, amount_param0, amount_param1, amount_param2, amount_param3) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_anime_group_start(cmds.__wbg_ptr, group_key, speed, loop_mode, !isLikeNone(loop_count), isLikeNone(loop_count) ? 0 : loop_count, from, to, fps, amount_mode, delay_ms, fillmode, amount_param0, amount_param1, amount_param2, amount_param3);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} group_key
*/
export function p3d_anime_group_pause(cmds, group_key) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_anime_group_pause(cmds.__wbg_ptr, group_key);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} group_key
*/
export function p3d_anime_group_stop(cmds, group_key) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_anime_group_stop(cmds.__wbg_ptr, group_key);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} group_key
* @param {number} amount
*/
export function p3d_anime_group_goto(cmds, group_key, amount) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_anime_group_goto(cmds.__wbg_ptr, group_key, amount);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} group_key
* @param {EAnimationGroupListen} mode
*/
export function p3d_animation_group_listen(cmds, group_key, mode) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_animation_group_listen(cmds.__wbg_ptr, group_key, mode);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} group
* @param {number} percent
* @param {number} data
*/
export function p3d_animation_group_add_frame_event(cmds, group, percent, data) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_animation_group_add_frame_event(cmds.__wbg_ptr, group, percent, data);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} group
*/
export function p3d_animation_group_delete(cmds, group) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_animation_group_delete(cmds.__wbg_ptr, group);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {Float64Array} receive
* @param {number} receive_len
* @returns {number}
*/
export function p3d_query_anime_events(app, param, receive, receive_len) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    var ptr0 = passArrayF64ToWasm0(receive, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_query_anime_events(app.__wbg_ptr, param.__wbg_ptr, ptr0, len0, addHeapObject(receive), receive_len);
    return ret;
}

/**
* FrameCurve
* * `FrameValues` data: [design_frame_per_second, (frame, x, y, ..), (frame, x, y, ..) ...]
* * `FrameValuesStep` data: [design_frame_per_second, (frame, x, y, ..), (frame, x, y, ..) ...]
* * `EasingCurve` data: [design_frame_per_second, total_frame, mode, (x, y, ..), (x, y, ..)]
* * `MinMaxCurve` data: [design_frame_per_second, (x, y, ..), (x, y, ..), (frame, f32, it, ot), (frame, f32, it, ot) ...]
* * `CubicBezierCurve` data: [design_frame_per_second, total_frame, (x, y, ..), (x, y, ..), (x1, y1, x2, y2)]
* * `GLTFCubicSpline` data: [design_frame_per_second, (frame, (x, y, ..), (x, y, ..), (x, y, ..)), ...]
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} key
* @param {EAnimePropertyID} property
* @returns {boolean}
*/
export function p3d_anime_curve_query(app, param, key, property) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    const ret = wasm.p3d_anime_curve_query(app.__wbg_ptr, param.__wbg_ptr, key, property);
    return ret !== 0;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {number} key
* @param {EAnimePropertyID} property
* @param {Float32Array} data
* @param {EAnimeCurve} mode
* @returns {boolean}
*/
export function p3d_anime_curve_create(app, param, key, property, data, mode) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    const ptr0 = passArrayF32ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_anime_curve_create(app.__wbg_ptr, param.__wbg_ptr, key, property, ptr0, len0, mode);
    return ret !== 0;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} curve_key
* @param {EAnimePropertyID} property
* @param {number} group
* @param {number} curve_target
* @returns {boolean}
*/
export function p3d_property_target_animation(cmds, curve_key, property, group, curve_target) {
    _assertClass(cmds, CommandsExchangeD3);
    const ret = wasm.p3d_property_target_animation(cmds.__wbg_ptr, curve_key, property, group, curve_target);
    return ret !== 0;
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} entity
* @param {number} trailmesh
* @param {number} trailgeo
* @param {Atom} key
* @param {Atom} color_attr_key
* @param {Atom} tilloff_attr_key
* @param {number | undefined} [update_buffer_interval_frame]
*/
export function p3d_particle_system(app, param, cmds, scene, entity, trailmesh, trailgeo, key, color_attr_key, tilloff_attr_key, update_buffer_interval_frame) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(key, Atom);
    _assertClass(color_attr_key, Atom);
    _assertClass(tilloff_attr_key, Atom);
    wasm.p3d_particle_system(app.__wbg_ptr, param.__wbg_ptr, cmds.__wbg_ptr, scene, entity, trailmesh, trailgeo, key.__wbg_ptr, color_attr_key.__wbg_ptr, tilloff_attr_key.__wbg_ptr, !isLikeNone(update_buffer_interval_frame), isLikeNone(update_buffer_interval_frame) ? 0 : update_buffer_interval_frame);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} entity
* @param {number} trailmesh
* @param {number} trailgeo
* @param {GLTFRes} gltf
* @param {number} index_calculator
* @param {Atom} color_attr_key
* @param {Atom} tilloff_attr_key
* @param {number | undefined} [update_buffer_interval_frame]
*/
export function p3d_particle_system_with_gltf(cmds, scene, entity, trailmesh, trailgeo, gltf, index_calculator, color_attr_key, tilloff_attr_key, update_buffer_interval_frame) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(gltf, GLTFRes);
    _assertClass(color_attr_key, Atom);
    _assertClass(tilloff_attr_key, Atom);
    wasm.p3d_particle_system_with_gltf(cmds.__wbg_ptr, scene, entity, trailmesh, trailgeo, gltf.__wbg_ptr, index_calculator, color_attr_key.__wbg_ptr, tilloff_attr_key.__wbg_ptr, !isLikeNone(update_buffer_interval_frame), isLikeNone(update_buffer_interval_frame) ? 0 : update_buffer_interval_frame);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} entity
*/
export function p3d_particle_system_start(cmds, entity) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_particle_system_start(cmds.__wbg_ptr, entity);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} entity
* @param {number} speed
*/
export function p3d_particle_system_timescale(cmds, entity, speed) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_particle_system_timescale(cmds.__wbg_ptr, entity, speed);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} entity
*/
export function p3d_particle_system_stop(cmds, entity) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_particle_system_stop(cmds.__wbg_ptr, entity);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @param {number} entity
* @param {number} linked
*/
export function p3d_trail(cmds, scene, entity, linked) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_trail(cmds.__wbg_ptr, scene, entity, linked);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} entity
* @param {number} age_ms
*/
export function p3d_trail_age(cmds, entity, age_ms) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_trail_age(cmds.__wbg_ptr, entity, age_ms);
}

/**
* @param {Engine} app
* @param {ActionSetScene3D} param
* @param {CommandsExchangeD3} cmds
*/
export function p3d_commands_exchange(app, param, cmds) {
    _assertClass(app, Engine);
    _assertClass(param, ActionSetScene3D);
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_commands_exchange(app.__wbg_ptr, param.__wbg_ptr, cmds.__wbg_ptr);
}

/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} bonespervertex
* @param {number} root
* @param {Float64Array} bones
* @param {number} bonecount
* @param {number} cacheframe
* @returns {number}
*/
export function p3d_skeleton(app, cmds, bonespervertex, root, bones, bonecount, cacheframe) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF64ToWasm0(bones, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_skeleton(app.__wbg_ptr, cmds.__wbg_ptr, bonespervertex, root, ptr0, len0, bonecount, cacheframe);
    return ret;
}

/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} scene
* @returns {number}
*/
export function p3d_bone(app, cmds, scene) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    const ret = wasm.p3d_bone(app.__wbg_ptr, cmds.__wbg_ptr, scene);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} bone
* @param {number} link
*/
export function p3d_bone_link(cmds, bone, link) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_bone_link(cmds.__wbg_ptr, bone, link);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} bone
* @param {Float32Array} data
*/
export function p3d_bone_pose(cmds, bone, data) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArrayF32ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_bone_pose(cmds.__wbg_ptr, bone, ptr0, len0);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} id_mesh
* @param {number} skin
*/
export function p3d_skin_use(cmds, id_mesh, skin) {
    _assertClass(cmds, CommandsExchangeD3);
    wasm.p3d_skin_use(cmds.__wbg_ptr, id_mesh, skin);
}

/**
* @param {Engine} app
* @param {CommandsExchangeD3} cmds
* @param {number} source
* @param {Atom} atlas
* @returns {number}
*/
export function p3d_sprite(app, cmds, source, atlas) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(atlas, Atom);
    const ret = wasm.p3d_sprite(app.__wbg_ptr, cmds.__wbg_ptr, source, atlas.__wbg_ptr);
    return ret;
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} sprite
* @param {Atom} tilloffkey
* @param {number} idxframe
*/
export function p3d_sprite_frame(cmds, sprite, tilloffkey, idxframe) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(tilloffkey, Atom);
    wasm.p3d_sprite_frame(cmds.__wbg_ptr, sprite, tilloffkey.__wbg_ptr, idxframe);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {number} sprite
* @param {Atom} tilloffkey
* @param {Uint16Array} data
*/
export function p3d_sprite_frame_data(cmds, sprite, tilloffkey, data) {
    _assertClass(cmds, CommandsExchangeD3);
    _assertClass(tilloffkey, Atom);
    const ptr0 = passArray16ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.p3d_sprite_frame_data(cmds.__wbg_ptr, sprite, tilloffkey.__wbg_ptr, ptr0, len0);
}

/**
* @param {CommandsExchangeD3} cmds
* @param {Uint16Array} data
* @returns {number}
*/
export function p3d_record_sprite_frame_data(cmds, data) {
    _assertClass(cmds, CommandsExchangeD3);
    const ptr0 = passArray16ToWasm0(data, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_record_sprite_frame_data(cmds.__wbg_ptr, ptr0, len0);
    return ret;
}

/**
* @param {Atom} atlas
* @param {number} width
* @param {number} height
* @returns {PTextureFrameAtlas}
*/
export function p3d_texture_frame_atlas(atlas, width, height) {
    _assertClass(atlas, Atom);
    const ret = wasm.p3d_texture_frame_atlas(atlas.__wbg_ptr, width, height);
    return PTextureFrameAtlas.__wrap(ret);
}

/**
* @param {PTextureFrameAtlas} atlas
* @param {Atom} frame_name
* @param {Uint16Array} framedata
* @returns {number}
*/
export function p3d_texture_frame_atlas_append_frame(atlas, frame_name, framedata) {
    _assertClass(atlas, PTextureFrameAtlas);
    _assertClass(frame_name, Atom);
    const ptr0 = passArray16ToWasm0(framedata, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_texture_frame_atlas_append_frame(atlas.__wbg_ptr, frame_name.__wbg_ptr, ptr0, len0);
    return ret;
}

/**
* @param {PTextureFrameAtlas} atlas
* @param {Atom} anim_name
* @param {Uint16Array} animframeidxs
* @returns {number}
*/
export function p3d_texture_frame_atlas_append_animation(atlas, anim_name, animframeidxs) {
    _assertClass(atlas, PTextureFrameAtlas);
    _assertClass(anim_name, Atom);
    const ptr0 = passArray16ToWasm0(animframeidxs, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.p3d_texture_frame_atlas_append_animation(atlas.__wbg_ptr, anim_name.__wbg_ptr, ptr0, len0);
    return ret;
}

/**
* @param {Engine} app
* @param {PTextureFrameAtlas} atlas
* @returns {ResTextureFrameAtlas | undefined}
*/
export function p3d_texture_frame_atlas_cache(app, atlas) {
    _assertClass(app, Engine);
    _assertClass(atlas, PTextureFrameAtlas);
    const ret = wasm.p3d_texture_frame_atlas_cache(app.__wbg_ptr, atlas.__wbg_ptr);
    return ret === 0 ? null : ResTextureFrameAtlas.__wrap(ret);
}

/**
* @param {Engine} engine
* @param {number} node_id
* @returns {string}
*/
export function get_layout(engine, node_id) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(engine, Engine);
        wasm.get_layout(retptr, engine.__wbg_ptr, node_id);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {Engine} engine
* @param {number} class_name
* @returns {string}
*/
export function get_class(engine, class_name) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(engine, Engine);
        wasm.get_class(retptr, engine.__wbg_ptr, class_name);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {Engine} engine
* @param {number} node_id
* @returns {string}
*/
export function node_info(engine, node_id) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(engine, Engine);
        wasm.node_info(retptr, engine.__wbg_ptr, node_id);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {Engine} engine
* @returns {string}
*/
export function texture_info(engine) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(engine, Engine);
        wasm.texture_info(retptr, engine.__wbg_ptr);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {Engine} engine
* @returns {Float64Array}
*/
export function debug_info(engine) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(engine, Engine);
        wasm.debug_info(retptr, engine.__wbg_ptr);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        var v1 = getArrayF64FromWasm0(r0, r1).slice();
        wasm.__wbindgen_free(r0, r1 * 8, 8);
        return v1;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @param {Engine} engine
* @param {number} node_id
* @returns {string}
*/
export function get_world_matrix(engine, node_id) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(engine, Engine);
        wasm.get_world_matrix(retptr, engine.__wbg_ptr, node_id);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {Engine} engine
* @param {number} node_id
* @returns {string}
*/
export function get_transform(engine, node_id) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(engine, Engine);
        wasm.get_transform(retptr, engine.__wbg_ptr, node_id);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {any} context
* @param {Engine} engine
* @param {number} width
* @param {number} height
* @param {Function | undefined} load_sdf_fun
* @param {number} class_sheet
* @param {number} font_sheet
* @param {number} cur_time
* @param {Function} animation_event_fun
* @param {TraceOption} debug
* @returns {Gui}
*/
export function create_gui(context, engine, width, height, load_sdf_fun, class_sheet, font_sheet, cur_time, animation_event_fun, debug) {
    _assertClass(engine, Engine);
    const ret = wasm.create_gui(addHeapObject(context), engine.__wbg_ptr, width, height, isLikeNone(load_sdf_fun) ? 0 : addHeapObject(load_sdf_fun), class_sheet, font_sheet, cur_time, addHeapObject(animation_event_fun), debug);
    return Gui.__wrap(ret);
}

/**
* @param {Gui} gui
* @param {Float64Array} arr
* @param {number} count
* @param {number} key
*/
export function create_fragment(gui, arr, count, key) {
    _assertClass(gui, Gui);
    wasm.create_fragment(gui.__wbg_ptr, addHeapObject(arr), count, key);
}

/**
* @param {Engine} engine
*/
export function log_animation(engine) {
    _assertClass(engine, Engine);
    wasm.log_animation(engine.__wbg_ptr);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_align_content(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_align_content(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_align_content(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_align_content(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_align_items(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_align_items(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_align_items(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_align_items(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_justify_content(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_justify_content(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_justify_content(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_justify_content(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_direction(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_flex_direction(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_direction(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_flex_direction(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_wrap(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_flex_wrap(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_wrap(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_flex_wrap(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_align_self(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_align_self(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_align_self(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_align_self(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_position_type(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_position_type(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_position_type(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_position_type(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_grow(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_flex_grow(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_grow(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_flex_grow(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_shrink(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_flex_grow(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_shrink(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_flex_grow(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_basis_percent(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_flex_basis_percent(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_basis_percent(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_flex_basis(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_flex_basis(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_flex_basis(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_basis(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_flex_basis(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_flex_basis_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.set_flex_basis_auto(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_flex_basis_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_flex_basis(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_width_percent(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_width_percent(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_width_percent(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_width(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_width(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_width(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_width_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.set_width_auto(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_width_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_height_percent(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_height_percent(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_height_percent(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_height(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_height(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_height(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_height_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.set_height_auto(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_height_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_min_width_percent(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_min_width_percent(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_width_percent(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_min_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_min_width(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_min_width(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_width(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_min_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_min_width_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.set_min_width_auto(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_width_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_min_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_min_height_percent(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_min_height_percent(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_height_percent(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_min_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_min_height(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_min_height(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_height(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_min_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_min_height_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.set_min_height_auto(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_min_height_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_min_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_max_width_percent(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_max_width_percent(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_width_percent(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_max_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_max_width(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_max_width(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_width(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_max_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_max_width_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.set_max_width_auto(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_width_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_max_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_max_height_percent(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_max_height_percent(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_height_percent(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_max_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_max_height(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_max_height(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_height(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_max_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_max_height_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.set_max_height_auto(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_max_height_auto(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_max_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_padding_percent(gui, node_id, edge, v) {
    _assertClass(gui, Gui);
    wasm.set_padding_percent(gui.__wbg_ptr, node_id, edge, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_padding_percent(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_padding(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_padding(gui, node_id, edge, v) {
    _assertClass(gui, Gui);
    wasm.set_padding(gui.__wbg_ptr, node_id, edge, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_padding(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_padding(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function set_padding_auto(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.set_padding_auto(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_padding_auto(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_padding(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_margin_percent(gui, node_id, edge, v) {
    _assertClass(gui, Gui);
    wasm.set_margin_percent(gui.__wbg_ptr, node_id, edge, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_margin_percent(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_margin(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_margin(gui, node_id, edge, v) {
    _assertClass(gui, Gui);
    wasm.set_margin(gui.__wbg_ptr, node_id, edge, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_margin(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_margin(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function set_margin_auto(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.set_margin_auto(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_margin_auto(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_margin(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_border_percent(gui, node_id, edge, v) {
    _assertClass(gui, Gui);
    wasm.set_border_percent(gui.__wbg_ptr, node_id, edge, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_border_percent(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_border(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_border(gui, node_id, edge, v) {
    _assertClass(gui, Gui);
    wasm.set_border(gui.__wbg_ptr, node_id, edge, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_border(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_border(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function set_border_auto(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.set_border_auto(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_border_auto(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_border(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_position_percent(gui, node_id, edge, v) {
    _assertClass(gui, Gui);
    wasm.set_position_percent(gui.__wbg_ptr, node_id, edge, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_position_percent(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_position(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
* @param {number} v
*/
export function set_position(gui, node_id, edge, v) {
    _assertClass(gui, Gui);
    wasm.set_position(gui.__wbg_ptr, node_id, edge, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_position(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_position(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function set_position_auto(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.set_position_auto(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} edge
*/
export function reset_position_auto(gui, node_id, edge) {
    _assertClass(gui, Gui);
    wasm.reset_position(gui.__wbg_ptr, node_id, edge);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_background_rgba_color(gui, node_id, r, g, b, a) {
    _assertClass(gui, Gui);
    wasm.set_background_rgba_color(gui.__wbg_ptr, node_id, r, g, b, a);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_background_rgba_color(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_background_linear_color(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} direction
* @param {Float32Array} color_and_positions
*/
export function set_background_linear_color(gui, node_id, direction, color_and_positions) {
    _assertClass(gui, Gui);
    const ptr0 = passArrayF32ToWasm0(color_and_positions, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_background_linear_color(gui.__wbg_ptr, node_id, direction, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_background_linear_color(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_background_linear_color(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_border_color(gui, node_id, r, g, b, a) {
    _assertClass(gui, Gui);
    wasm.set_border_color(gui.__wbg_ptr, node_id, r, g, b, a);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_color(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_border_color(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_border_radius(gui, node_id, s) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(s, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_border_radius(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_radius(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_border_radius(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} h
* @param {number} v
* @param {number} blur
* @param {number} spread
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_box_shadow(gui, node_id, h, v, blur, spread, r, g, b, a) {
    _assertClass(gui, Gui);
    wasm.set_box_shadow(gui.__wbg_ptr, node_id, h, v, blur, spread, r, g, b, a);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_box_shadow(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_box_shadow(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_object_fit(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_object_fit(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_object_fit(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_object_fit(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} x
* @param {number} y
*/
export function set_background_repeat(gui, node_id, x, y) {
    _assertClass(gui, Gui);
    wasm.set_background_repeat(gui.__wbg_ptr, node_id, x, y);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_background_repeat(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_background_repeat(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} direction
* @param {Float32Array} color_and_positions
*/
export function set_mask_image_linear(gui, node_id, direction, color_and_positions) {
    _assertClass(gui, Gui);
    const ptr0 = passArrayF32ToWasm0(color_and_positions, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_mask_image_linear(gui.__wbg_ptr, node_id, direction, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_mask_image_linear(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_mask_image(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} u1
* @param {number} v1
* @param {number} u2
* @param {number} v2
*/
export function set_image_clip(gui, node_id, u1, v1, u2, v2) {
    _assertClass(gui, Gui);
    wasm.set_image_clip(gui.__wbg_ptr, node_id, u1, v1, u2, v2);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_image_clip(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_image_clip(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} u1
* @param {number} v1
* @param {number} u2
* @param {number} v2
*/
export function set_mask_image_clip(gui, node_id, u1, v1, u2, v2) {
    _assertClass(gui, Gui);
    wasm.set_mask_image_clip(gui.__wbg_ptr, node_id, u1, v1, u2, v2);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_mask_image_clip(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_mask_image_clip(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} u1
* @param {number} v1
* @param {number} u2
* @param {number} v2
*/
export function set_border_image_clip(gui, node_id, u1, v1, u2, v2) {
    _assertClass(gui, Gui);
    wasm.set_border_image_clip(gui.__wbg_ptr, node_id, u1, v1, u2, v2);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_image_clip(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_border_image_clip(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} top
* @param {number} right
* @param {number} bottom
* @param {number} left
* @param {boolean} fill
*/
export function set_border_image_slice(gui, node_id, top, right, bottom, left, fill) {
    _assertClass(gui, Gui);
    wasm.set_border_image_slice(gui.__wbg_ptr, node_id, top, right, bottom, left, fill);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_image_slice(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_border_image_slice(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} vertical
* @param {number} horizontal
*/
export function set_border_image_repeat(gui, node_id, vertical, horizontal) {
    _assertClass(gui, Gui);
    wasm.set_border_image_repeat(gui.__wbg_ptr, node_id, vertical, horizontal);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_image_repeat(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_border_image_repeat(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {boolean} v
*/
export function set_overflow(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_overflow(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_overflow(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_overflow(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_opacity(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_opacity(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_opacity(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_opacity(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_display(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_display(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_display(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_display(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {boolean} v
*/
export function set_visibility(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_visibility(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_visibility(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_visibility(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_enable(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_enable(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_enable(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_enable(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_blend_mode(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_blend_mode(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_blend_mode(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_blend_mode(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_zindex(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_zindex(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_zindex(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_zindex(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
*/
export function set_as_image(gui, node_id, value) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_as_image(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_as_image(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_as_image(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_filter_blur(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_filter_blur(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_filter_blur(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_filter_blur(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {boolean} v
*/
export function set_transform_will_change(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_transform_will_change(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_transform_will_change(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_transform_will_change(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} h
* @param {number} s
* @param {number} _i
*/
export function set_filter_hsi(gui, node_id, h, s, _i) {
    _assertClass(gui, Gui);
    wasm.set_filter_hsi(gui.__wbg_ptr, node_id, h, s, _i);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_filter_hsi(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_filter_hsi(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_translate(gui, node_id, s) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(s, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_translate(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_translate(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_translate(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_scale(gui, node_id, s) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(s, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_scale(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_scale(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_scale(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_rotate(gui, node_id, s) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(s, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_rotate(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_rotate(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_rotate(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_transform(gui, node_id, s) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(s, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_transform(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_transform(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_transform(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_text_overflow(gui, node_id, s) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(s, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_text_overflow(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_overflow(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_text_overflow(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_overflow_wrap(gui, node_id, s) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(s, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_overflow_wrap(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_overflow_wrap(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_overflow_wrap(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} x_ty
* @param {number} x
* @param {number} y_ty
* @param {number} y
*/
export function set_transform_origin(gui, node_id, x_ty, x, y_ty, y) {
    _assertClass(gui, Gui);
    wasm.set_transform_origin(gui.__wbg_ptr, node_id, x_ty, x, y_ty, y);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_transform_origin(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_transform_origin(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_letter_spacing(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_letter_spacing(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_letter_spacing(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_letter_spacing(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_word_spacing(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_word_spacing(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_word_spacing(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_word_spacing(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_text_rgba_color(gui, node_id, r, g, b, a) {
    _assertClass(gui, Gui);
    wasm.set_text_rgba_color(gui.__wbg_ptr, node_id, r, g, b, a);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_rgba_color(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_text_linear_gradient_color(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} direction
* @param {Float32Array} color_and_positions
*/
export function set_text_linear_gradient_color(gui, node_id, direction, color_and_positions) {
    _assertClass(gui, Gui);
    const ptr0 = passArrayF32ToWasm0(color_and_positions, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_text_linear_gradient_color(gui.__wbg_ptr, node_id, direction, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_linear_gradient_color(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_text_linear_gradient_color(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_line_height_normal(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.set_line_height_normal(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_line_height_normal(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_line_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} value
*/
export function set_line_height(gui, node_id, value) {
    _assertClass(gui, Gui);
    wasm.set_line_height(gui.__wbg_ptr, node_id, value);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_line_height(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_line_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} value
*/
export function set_line_height_percent(gui, node_id, value) {
    _assertClass(gui, Gui);
    wasm.set_line_height_percent(gui.__wbg_ptr, node_id, value);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_line_height_percent(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_line_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_text_indent(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_text_indent(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_indent(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_text_indent(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_text_align(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_text_align(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_align(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_text_align(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_vertical_align(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_vertical_align(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_vertical_align(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_vertical_align(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} width
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_text_stroke(gui, node_id, width, r, g, b, a) {
    _assertClass(gui, Gui);
    wasm.set_text_stroke(gui.__wbg_ptr, node_id, width, r, g, b, a);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_stroke(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_text_stroke(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_white_space(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_white_space(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_white_space(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_white_space(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_font_style(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_font_style(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_style(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_font_style(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} v
*/
export function set_font_weight(gui, node_id, v) {
    _assertClass(gui, Gui);
    wasm.set_font_weight(gui.__wbg_ptr, node_id, v);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_weight(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_font_weight(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function set_font_size_none(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.set_font_size_none(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_size_none(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_font_size(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} value
*/
export function set_font_size(gui, node_id, value) {
    _assertClass(gui, Gui);
    wasm.set_font_size(gui.__wbg_ptr, node_id, value);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_size(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_font_size(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} value
*/
export function set_font_size_percent(gui, node_id, value) {
    _assertClass(gui, Gui);
    wasm.set_font_size_percent(gui.__wbg_ptr, node_id, value);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_size_percent(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_font_size(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint8Array} content
*/
export function set_text_content_utf8(gui, node_id, content) {
    _assertClass(gui, Gui);
    const ptr0 = passArray8ToWasm0(content, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_text_content_utf8(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_content_utf8(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_text_content(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
*/
export function set_clip_path_str(gui, node_id, value) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_clip_path_str(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_clip_path_str(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_clip_path_str(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint32Array} name
*/
export function set_animation_duration(gui, node_id, name) {
    _assertClass(gui, Gui);
    const ptr0 = passArray32ToWasm0(name, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_animation_duration(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_duration(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_animation_duration(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint32Array} name
*/
export function set_animation_delay(gui, node_id, name) {
    _assertClass(gui, Gui);
    const ptr0 = passArray32ToWasm0(name, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_animation_delay(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_delay(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_animation_delay(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} name
*/
export function set_animation_iteration_count(gui, node_id, name) {
    _assertClass(gui, Gui);
    const ptr0 = passArrayF32ToWasm0(name, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_animation_iteration_count(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_iteration_count(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_animation_iteration_count(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint8Array} name
*/
export function set_animation_direction(gui, node_id, name) {
    _assertClass(gui, Gui);
    const ptr0 = passArray8ToWasm0(name, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_animation_direction(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_direction(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_animation_direction(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint8Array} name
*/
export function set_animation_fill_mode(gui, node_id, name) {
    _assertClass(gui, Gui);
    const ptr0 = passArray8ToWasm0(name, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_animation_fill_mode(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_fill_mode(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_animation_fill_mode(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Uint8Array} name
*/
export function set_animation_play_state(gui, node_id, name) {
    _assertClass(gui, Gui);
    const ptr0 = passArray8ToWasm0(name, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_animation_play_state(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_play_state(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_animation_play_state(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
* @param {number} scope_hash
*/
export function set_animation_name_str(gui, node_id, value, scope_hash) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_animation_name_str(gui.__wbg_ptr, node_id, ptr0, len0, scope_hash);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_name_str(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_animation_name_str(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} animation
* @param {string} key_frames
* @param {number} scope_hash
*/
export function set_runtime_animation(gui, node_id, animation, key_frames, scope_hash) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(animation, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(key_frames, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    wasm.set_runtime_animation(gui.__wbg_ptr, node_id, ptr0, len0, ptr1, len1, scope_hash);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_runtime_animation(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.force_update_text(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
* @param {number} scope_hash
*/
export function set_animation_str(gui, node_id, value, scope_hash) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_animation_str(gui.__wbg_ptr, node_id, ptr0, len0, scope_hash);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_str(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_animation_str(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Atom} image_hash
*/
export function set_mask_image(gui, node_id, image_hash) {
    _assertClass(gui, Gui);
    _assertClass(image_hash, Atom);
    wasm.set_mask_image(gui.__wbg_ptr, node_id, image_hash.__wbg_ptr);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_mask_image(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_mask_image(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Atom} image_hash
*/
export function set_background_image(gui, node_id, image_hash) {
    _assertClass(gui, Gui);
    _assertClass(image_hash, Atom);
    wasm.set_background_image(gui.__wbg_ptr, node_id, image_hash.__wbg_ptr);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_background_image(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_background_image(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Atom} image_hash
*/
export function set_border_image(gui, node_id, image_hash) {
    _assertClass(gui, Gui);
    _assertClass(image_hash, Atom);
    wasm.set_border_image(gui.__wbg_ptr, node_id, image_hash.__wbg_ptr);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_border_image(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_border_image(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} s
*/
export function set_text_shadow(gui, node_id, s) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(s, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_text_shadow(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_shadow(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_text_shadow(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
*/
export function set_text_outer_glow(gui, node_id, value) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_text_outer_glow(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_outer_glow(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_text_outer_glow(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Atom} name
*/
export function set_font_family(gui, node_id, name) {
    _assertClass(gui, Gui);
    _assertClass(name, Atom);
    wasm.set_font_family(gui.__wbg_ptr, node_id, name.__wbg_ptr);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_font_family(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_font_family(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} content
*/
export function set_text_content(gui, node_id, content) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(content, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_text_content(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_text_content(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_text_content(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} value
*/
export function set_animation_timing_function_str(gui, node_id, value) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_animation_timing_function_str(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_animation_timing_function_str(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_animation_timing_function_str(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {string} value
*/
export function set_default_style(gui, value) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_default_style(gui.__wbg_ptr, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {string} css
* @param {number} scope_hash
*/
export function create_class_by_str(gui, css, scope_hash) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(css, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.create_class_by_str(gui.__wbg_ptr, ptr0, len0, scope_hash);
}

/**
* @param {Gui} gui
* @param {number} node
* @param {Uint32Array} class_name
*/
export function set_class(gui, node, class_name) {
    _assertClass(gui, Gui);
    const ptr0 = passArray32ToWasm0(class_name, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_class(gui.__wbg_ptr, node, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} x
* @param {number} y
* @param {number} width
* @param {number} height
* @param {number} root
*/
export function set_view_port(gui, x, y, width, height, root) {
    _assertClass(gui, Gui);
    wasm.set_view_port(gui.__wbg_ptr, x, y, width, height, root);
}

/**
* @param {Gui} gui
* @param {number} node
* @param {number} brush
* @param {boolean | undefined} [by_draw_list]
*/
export function set_brush(gui, node, brush, by_draw_list) {
    _assertClass(gui, Gui);
    wasm.set_brush(gui.__wbg_ptr, node, brush, isLikeNone(by_draw_list) ? 0xFFFFFF : by_draw_list ? 1 : 0);
}

/**
* @param {Gui} gui
* @param {number} node
* @param {boolean} aspect_ratio
* @param {number} start
* @param {number} end
* @param {number} center_x
* @param {number} center_y
* @param {number} cycle
* @param {number} weight
*/
export function set_radial_wave(gui, node, aspect_ratio, start, end, center_x, center_y, cycle, weight) {
    _assertClass(gui, Gui);
    wasm.set_radial_wave(gui.__wbg_ptr, node, aspect_ratio, start, end, center_x, center_y, cycle, weight);
}

/**
* @param {Gui} gui
* @param {number} node
* @param {number} target_ty
*/
export function set_rendertarget_type(gui, node, target_ty) {
    _assertClass(gui, Gui);
    wasm.set_rendertarget_type(gui.__wbg_ptr, node, target_ty);
}

/**
* @param {Gui} gui
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_clear_color(gui, r, g, b, a) {
    _assertClass(gui, Gui);
    wasm.set_clear_color(gui.__wbg_ptr, r, g, b, a);
}

/**
* @param {Gui} gui
* @param {Uint8Array} bin
*/
export function create_class_by_bin(gui, bin) {
    _assertClass(gui, Gui);
    const ptr0 = passArray8ToWasm0(bin, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.create_class_by_bin(gui.__wbg_ptr, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} root
*/
export function set_render_dirty(gui, root) {
    _assertClass(gui, Gui);
    wasm.force_update_text(gui.__wbg_ptr, root);
}

/**
* @param {Gui} _gui
*/
export function bind_render_target(_gui) {
    _assertClass(_gui, Gui);
    wasm.bind_render_target(_gui.__wbg_ptr);
}

/**
* @param {Gui} _gui
* @param {number} _pixel_ratio
*/
export function set_pixel_ratio(_gui, _pixel_ratio) {
    _assertClass(_gui, Gui);
    wasm.set_pixel_ratio(_gui.__wbg_ptr, _pixel_ratio);
}

/**
* @param {Gui} _gui
*/
export function nullify_clear_color(_gui) {
    _assertClass(_gui, Gui);
    wasm.bind_render_target(_gui.__wbg_ptr);
}

/**
* @param {Gui} _gui
* @param {number} _x
* @param {number} _y
* @param {number} _width
* @param {number} _height
*/
export function set_scissor(_gui, _x, _y, _width, _height) {
    _assertClass(_gui, Gui);
    wasm.set_scissor(_gui.__wbg_ptr, _x, _y, _width, _height);
}

/**
* @param {Gui} _gui
* @param {number} _scale_x
* @param {number} _scale_y
* @param {number} _translate_x
* @param {number} _translate_y
* @param {number} _rotate
* @param {number} _width
* @param {number} _height
*/
export function set_project_transfrom(_gui, _scale_x, _scale_y, _translate_x, _translate_y, _rotate, _width, _height) {
    _assertClass(_gui, Gui);
    wasm.set_project_transfrom(_gui.__wbg_ptr, _scale_x, _scale_y, _translate_x, _translate_y, _rotate, _width, _height);
}

/**
* @param {Gui} _gui
* @param {number} _node
*/
export function force_update_text(_gui, _node) {
    _assertClass(_gui, Gui);
    wasm.force_update_text(_gui.__wbg_ptr, _node);
}

/**
* @param {Gui} _gui
* @param {string} _shader_name
* @param {string} _shader_code
*/
export function set_shader(_gui, _shader_name, _shader_code) {
    _assertClass(_gui, Gui);
    const ptr0 = passStringToWasm0(_shader_name, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(_shader_code, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    wasm.set_shader(_gui.__wbg_ptr, ptr0, len0, ptr1, len1);
}

/**
* @param {Gui} _gui
* @returns {number}
*/
export function get_font_sheet(_gui) {
    _assertClass(_gui, Gui);
    const ret = wasm.get_class_sheet(_gui.__wbg_ptr);
    return ret >>> 0;
}

/**
* @param {Gui} _gui
* @returns {number}
*/
export function get_class_sheet(_gui) {
    _assertClass(_gui, Gui);
    const ret = wasm.get_class_sheet(_gui.__wbg_ptr);
    return ret >>> 0;
}

/**
* @param {Gui} _gui
* @param {number} _fbo
* @returns {number}
*/
export function create_render_target(_gui, _fbo) {
    _assertClass(_gui, Gui);
    const ret = wasm.create_render_target(_gui.__wbg_ptr, _fbo);
    return ret >>> 0;
}

/**
* @param {Gui} _gui
* @param {number} _fbo
* @returns {number}
*/
export function destroy_render_target(_gui, _fbo) {
    _assertClass(_gui, Gui);
    const ret = wasm.create_render_target(_gui.__wbg_ptr, _fbo);
    return ret >>> 0;
}

/**
* @param {Gui} _gui
* @returns {Gui}
*/
export function clone_engine(_gui) {
    _assertClass(_gui, Gui);
    const ret = wasm.clone_engine(_gui.__wbg_ptr);
    return Gui.__wrap(ret);
}

/**
* @param {Gui} _gui
* @returns {number}
*/
export function get_text_texture_width(_gui) {
    _assertClass(_gui, Gui);
    const ret = wasm.get_class_sheet(_gui.__wbg_ptr);
    return ret >>> 0;
}

/**
* @param {Gui} _gui
* @returns {number}
*/
export function get_text_texture_height(_gui) {
    _assertClass(_gui, Gui);
    const ret = wasm.get_class_sheet(_gui.__wbg_ptr);
    return ret >>> 0;
}

/**
* @param {Gui} _gui
* @param {number} _node
* @returns {boolean}
*/
export function node_is_exist(_gui, _node) {
    _assertClass(_gui, Gui);
    const ret = wasm.node_is_exist(_gui.__wbg_ptr, _node);
    return ret !== 0;
}

/**
* @param {Gui} _gui
* @param {Engine} _engine
* @param {number} _node
* @returns {boolean}
*/
export function node_is_visibility(_gui, _engine, _node) {
    _assertClass(_gui, Gui);
    _assertClass(_engine, Engine);
    const ret = wasm.node_is_visibility(_gui.__wbg_ptr, _engine.__wbg_ptr, _node);
    return ret !== 0;
}

/**
* @param {Gui} _gui
* @param {number} _parent
* @returns {number | undefined}
*/
export function first_child(_gui, _parent) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(_gui, Gui);
        wasm.first_child(retptr, _gui.__wbg_ptr, _parent);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r2 = getFloat64Memory0()[retptr / 8 + 1];
        return r0 === 0 ? null : r2;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @param {Gui} _gui
* @param {number} _parent
* @returns {number | undefined}
*/
export function last_child(_gui, _parent) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(_gui, Gui);
        wasm.first_child(retptr, _gui.__wbg_ptr, _parent);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r2 = getFloat64Memory0()[retptr / 8 + 1];
        return r0 === 0 ? null : r2;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @param {Gui} _gui
* @param {number} _node
* @returns {number | undefined}
*/
export function next_sibling(_gui, _node) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(_gui, Gui);
        wasm.first_child(retptr, _gui.__wbg_ptr, _node);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r2 = getFloat64Memory0()[retptr / 8 + 1];
        return r0 === 0 ? null : r2;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @param {Gui} _gui
* @param {number} _node
* @returns {number | undefined}
*/
export function previous_sibling(_gui, _node) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(_gui, Gui);
        wasm.first_child(retptr, _gui.__wbg_ptr, _node);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r2 = getFloat64Memory0()[retptr / 8 + 1];
        return r0 === 0 ? null : r2;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @param {Gui} _gui
* @param {number} _node
* @returns {number}
*/
export function get_layer(_gui, _node) {
    _assertClass(_gui, Gui);
    const ret = wasm.get_layer(_gui.__wbg_ptr, _node);
    return ret >>> 0;
}

/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {boolean}
*/
export function get_enable(gui, engine, node) {
    _assertClass(gui, Gui);
    _assertClass(engine, Engine);
    const ret = wasm.get_enable(gui.__wbg_ptr, engine.__wbg_ptr, node);
    return ret !== 0;
}

/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {number}
*/
export function offset_top(gui, engine, node) {
    _assertClass(gui, Gui);
    _assertClass(engine, Engine);
    const ret = wasm.offset_top(gui.__wbg_ptr, engine.__wbg_ptr, node);
    return ret >>> 0;
}

/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {number}
*/
export function offset_left(gui, engine, node) {
    _assertClass(gui, Gui);
    _assertClass(engine, Engine);
    const ret = wasm.offset_left(gui.__wbg_ptr, engine.__wbg_ptr, node);
    return ret >>> 0;
}

/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {number}
*/
export function offset_width(gui, engine, node) {
    _assertClass(gui, Gui);
    _assertClass(engine, Engine);
    const ret = wasm.offset_width(gui.__wbg_ptr, engine.__wbg_ptr, node);
    return ret >>> 0;
}

/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {number}
*/
export function offset_height(gui, engine, node) {
    _assertClass(gui, Gui);
    _assertClass(engine, Engine);
    const ret = wasm.offset_height(gui.__wbg_ptr, engine.__wbg_ptr, node);
    return ret >>> 0;
}

/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {string}
*/
export function get_class_name(gui, engine, node) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(gui, Gui);
        _assertClass(engine, Engine);
        wasm.get_class_name(retptr, gui.__wbg_ptr, engine.__wbg_ptr, node);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {string}
*/
export function offset_document(gui, engine, node) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(gui, Gui);
        _assertClass(engine, Engine);
        wasm.offset_document(retptr, gui.__wbg_ptr, engine.__wbg_ptr, node);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node
* @returns {string}
*/
export function content_box(gui, engine, node) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(gui, Gui);
        _assertClass(engine, Engine);
        wasm.content_box(retptr, gui.__wbg_ptr, engine.__wbg_ptr, node);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {Engine} engine
* @returns {number}
*/
export function get_animation_events_max_len(engine) {
    _assertClass(engine, Engine);
    const ret = wasm.get_animation_events_max_len(engine.__wbg_ptr);
    return ret >>> 0;
}

/**
* @param {Uint32Array} arr
* @param {Engine} engine
* @returns {number}
*/
export function get_animation_events(arr, engine) {
    var ptr0 = passArray32ToWasm0(arr, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    _assertClass(engine, Engine);
    const ret = wasm.get_animation_events(ptr0, len0, addHeapObject(arr), engine.__wbg_ptr);
    return ret >>> 0;
}

/**
* @param {number} value
* @returns {number}
*/
export function get_entity_offset(value) {
    const ret = wasm.get_entity_offset(value);
    return ret >>> 0;
}

/**
* @param {number} value
* @returns {number}
*/
export function get_entity_version(value) {
    const ret = wasm.get_entity_version(value);
    return ret >>> 0;
}

/**
* @param {Engine} engine
* @param {Gui} gui
* @param {number} x
* @param {number} y
* @returns {number | undefined}
*/
export function query(engine, gui, x, y) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(engine, Engine);
        _assertClass(gui, Gui);
        wasm.query(retptr, engine.__wbg_ptr, gui.__wbg_ptr, x, y);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r2 = getFloat64Memory0()[retptr / 8 + 1];
        return r0 === 0 ? null : r2;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} fill_color
*/
export function set_svg_fill_color(gui, node_id, fill_color) {
    _assertClass(gui, Gui);
    const ptr0 = passArrayF32ToWasm0(fill_color, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_svg_fill_color(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_fill_color(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_fill_color(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} fill_color_url
*/
export function set_svg_fill_color_id(gui, node_id, fill_color_url) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(fill_color_url, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_svg_fill_color_id(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_fill_color_id(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_fill_color(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} storke_color
*/
export function set_svg_storke_color(gui, node_id, storke_color) {
    _assertClass(gui, Gui);
    const ptr0 = passArrayF32ToWasm0(storke_color, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_svg_storke_color(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_storke_color(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_fill_color(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} width
*/
export function set_svg_storke_width(gui, node_id, width) {
    _assertClass(gui, Gui);
    wasm.set_svg_storke_width(gui.__wbg_ptr, node_id, width);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_storke_width(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_storke_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} width
*/
export function set_svg_shape_width(gui, node_id, width) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_width(gui.__wbg_ptr, node_id, width);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_width(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} height
*/
export function set_svg_shape_height(gui, node_id, height) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_height(gui.__wbg_ptr, node_id, height);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_height(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} x
*/
export function set_svg_shape_x(gui, node_id, x) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_x(gui.__wbg_ptr, node_id, x);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_x(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_x(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} y
*/
export function set_svg_shape_y(gui, node_id, y) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_y(gui.__wbg_ptr, node_id, y);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_y(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_y(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} width
*/
export function set_svg_width(gui, node_id, width) {
    _assertClass(gui, Gui);
    wasm.set_svg_width(gui.__wbg_ptr, node_id, width);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_width(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_width(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} height
*/
export function set_svg_height(gui, node_id, height) {
    _assertClass(gui, Gui);
    wasm.set_svg_height(gui.__wbg_ptr, node_id, height);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_height(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_height(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} shape
*/
export function set_svg_shape(gui, node_id, shape) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape(gui.__wbg_ptr, node_id, shape);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} center_x
*/
export function set_svg_shape_cx(gui, node_id, center_x) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_cx(gui.__wbg_ptr, node_id, center_x);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_cx(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_cx(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} center_y
*/
export function set_svg_shape_cy(gui, node_id, center_y) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_cy(gui.__wbg_ptr, node_id, center_y);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_cy(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_cy(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} radius
*/
export function set_svg_shape_radius(gui, node_id, radius) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_radius(gui.__wbg_ptr, node_id, radius);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_radius(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_radius(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} radius_x
*/
export function set_svg_shape_radius_x(gui, node_id, radius_x) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_radius_x(gui.__wbg_ptr, node_id, radius_x);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_radius_x(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_radius_x(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} radius_y
*/
export function set_svg_shape_radius_y(gui, node_id, radius_y) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_radius_y(gui.__wbg_ptr, node_id, radius_y);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_radius_y(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_radius_y(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} ax
*/
export function set_svg_shape_ax(gui, node_id, ax) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_ax(gui.__wbg_ptr, node_id, ax);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_ax(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_ax(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} ay
*/
export function set_svg_shape_ay(gui, node_id, ay) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_ay(gui.__wbg_ptr, node_id, ay);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_ay(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_ay(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} bx
*/
export function set_svg_shape_bx(gui, node_id, bx) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_bx(gui.__wbg_ptr, node_id, bx);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_bx(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_bx(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} by
*/
export function set_svg_shape_by(gui, node_id, by) {
    _assertClass(gui, Gui);
    wasm.set_svg_shape_by(gui.__wbg_ptr, node_id, by);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_by(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_by(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} points
*/
export function set_svg_shape_points(gui, node_id, points) {
    _assertClass(gui, Gui);
    const ptr0 = passArrayF32ToWasm0(points, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_svg_shape_points(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_points(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_points(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} verb
* @param {Float32Array} points
*/
export function set_svg_shape_path(gui, node_id, verb, points) {
    _assertClass(gui, Gui);
    const ptr0 = passArrayF32ToWasm0(verb, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passArrayF32ToWasm0(points, wasm.__wbindgen_malloc);
    const len1 = WASM_VECTOR_LEN;
    wasm.set_svg_shape_path(gui.__wbg_ptr, node_id, ptr0, len0, ptr1, len1);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shape_path(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shape_path(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} stroke_dasharray
*/
export function set_svg_stroke_dasharray(gui, node_id, stroke_dasharray) {
    _assertClass(gui, Gui);
    const ptr0 = passArrayF32ToWasm0(stroke_dasharray, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_svg_stroke_dasharray(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_stroke_dasharray(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_stroke_dasharray(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} x
*/
export function set_svg_shadow_offset_dx(gui, node_id, x) {
    _assertClass(gui, Gui);
    wasm.set_svg_shadow_offset_dx(gui.__wbg_ptr, node_id, x);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shadow_offset_dx(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shadow_offset_dx(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} y
*/
export function set_svg_shadow_offset_dy(gui, node_id, y) {
    _assertClass(gui, Gui);
    wasm.set_svg_shadow_offset_dy(gui.__wbg_ptr, node_id, y);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shadow_offset_dy(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shadow_offset_dy(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} level
*/
export function set_svg_blur_level(gui, node_id, level) {
    _assertClass(gui, Gui);
    wasm.set_svg_blur_level(gui.__wbg_ptr, node_id, level);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_blur_level(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_blur_level(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} other_id
*/
export function set_svg_filter(gui, node_id, other_id) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(other_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_svg_filter(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_filter(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_filter(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} other_id
*/
export function set_svg_filter_id(gui, node_id, other_id) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(other_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_svg_filter_id(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_filter_id(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_filter_id(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} color
*/
export function set_svg_gradient_stop(gui, node_id, color) {
    _assertClass(gui, Gui);
    const ptr0 = passArrayF32ToWasm0(color, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_svg_gradient_stop(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_gradient_stop(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_gradient_stop(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {number} offset
*/
export function set_svg_gradient_offset(gui, node_id, offset) {
    _assertClass(gui, Gui);
    wasm.set_svg_gradient_offset(gui.__wbg_ptr, node_id, offset);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_gradient_offset(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_gradient_offset(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {string} other_id
*/
export function set_svg_gradient(gui, node_id, other_id) {
    _assertClass(gui, Gui);
    const ptr0 = passStringToWasm0(other_id, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_svg_gradient(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_gradient(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_gradient(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node_id
* @param {Float32Array} color
*/
export function set_svg_shadow_color(gui, node_id, color) {
    _assertClass(gui, Gui);
    const ptr0 = passArrayF32ToWasm0(color, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_svg_shadow_color(gui.__wbg_ptr, node_id, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function reset_svg_shadow_color(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.reset_svg_shadow_color(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @returns {number}
*/
export function create_node(gui) {
    _assertClass(gui, Gui);
    const ret = wasm.create_node(gui.__wbg_ptr);
    return ret;
}

/**
* @param {Gui} gui
* @returns {number}
*/
export function create_vnode(gui) {
    _assertClass(gui, Gui);
    const ret = wasm.create_vnode(gui.__wbg_ptr);
    return ret;
}

/**
* @param {Gui} gui
* @returns {number}
*/
export function create_text_node(gui) {
    _assertClass(gui, Gui);
    const ret = wasm.create_text_node(gui.__wbg_ptr);
    return ret;
}

/**
* @param {Gui} gui
* @returns {number}
*/
export function create_image_node(gui) {
    _assertClass(gui, Gui);
    const ret = wasm.create_image_node(gui.__wbg_ptr);
    return ret;
}

/**
* @param {Gui} gui
* @returns {number}
*/
export function create_canvas_node(gui) {
    _assertClass(gui, Gui);
    const ret = wasm.create_canvas_node(gui.__wbg_ptr);
    return ret;
}

/**
* @param {Gui} gui
* @param {number} node
*/
export function destroy_node(gui, node) {
    _assertClass(gui, Gui);
    wasm.destroy_node(gui.__wbg_ptr, node);
}

/**
* @param {Gui} gui
* @param {number} node
*/
export function remove_node(gui, node) {
    _assertClass(gui, Gui);
    wasm.remove_node(gui.__wbg_ptr, node);
}

/**
* @param {Gui} gui
* @param {number} node_id
*/
export function insert_as_root(gui, node_id) {
    _assertClass(gui, Gui);
    wasm.insert_as_root(gui.__wbg_ptr, node_id);
}

/**
* @param {Gui} gui
* @param {number} node
* @param {number} parent
*/
export function append_child(gui, node, parent) {
    _assertClass(gui, Gui);
    wasm.append_child(gui.__wbg_ptr, node, parent);
}

/**
* @param {Gui} gui
* @param {number} node
* @param {number} borther
*/
export function insert_before(gui, node, borther) {
    _assertClass(gui, Gui);
    wasm.insert_before(gui.__wbg_ptr, node, borther);
}

/**
* @param {Gui} gui
* @param {Uint8Array} bin
*/
export function create_fragment_by_bin(gui, bin) {
    _assertClass(gui, Gui);
    const ptr0 = passArray8ToWasm0(bin, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.create_fragment_by_bin(gui.__wbg_ptr, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {Engine} engine
*/
export function render_gui(gui, engine) {
    _assertClass(gui, Gui);
    _assertClass(engine, Engine);
    wasm.render_gui(gui.__wbg_ptr, engine.__wbg_ptr);
}

/**
* @param {Gui} gui
* @param {Engine} engine
*/
export function calc(gui, engine) {
    _assertClass(gui, Gui);
    _assertClass(engine, Engine);
    wasm.calc(gui.__wbg_ptr, engine.__wbg_ptr);
}

/**
* @param {Gui} gui
* @param {Engine} engine
*/
export function calc_layout(gui, engine) {
    _assertClass(gui, Gui);
    _assertClass(engine, Engine);
    wasm.calc_layout(gui.__wbg_ptr, engine.__wbg_ptr);
}

/**
* @param {Gui} gui
* @param {Engine} engine
*/
export function calc_geo(gui, engine) {
    _assertClass(gui, Gui);
    _assertClass(engine, Engine);
    wasm.calc_geo(gui.__wbg_ptr, engine.__wbg_ptr);
}

/**
* @param {Engine} engine
* @param {Atom} name
* @param {number} scope_hash
* @returns {string}
*/
export function get_keyframes(engine, name, scope_hash) {
    let deferred1_0;
    let deferred1_1;
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(engine, Engine);
        _assertClass(name, Atom);
        wasm.get_keyframes(retptr, engine.__wbg_ptr, name.__wbg_ptr, scope_hash);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        deferred1_0 = r0;
        deferred1_1 = r1;
        return getStringFromWasm0(r0, r1);
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
        wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
    }
}

/**
* @param {Engine} engine
* @param {boolean} value
*/
export function set_is_run(engine, value) {
    _assertClass(engine, Engine);
    wasm.set_is_run(engine.__wbg_ptr, value);
}

/**
* @param {Engine} engine
* @returns {Uint8Array}
*/
export function get_record(engine) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        _assertClass(engine, Engine);
        wasm.get_record(retptr, engine.__wbg_ptr);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        var v1 = getArrayU8FromWasm0(r0, r1).slice();
        wasm.__wbindgen_free(r0, r1 * 1, 1);
        return v1;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @param {Engine} engine
* @returns {number}
*/
export function get_record_len(engine) {
    _assertClass(engine, Engine);
    const ret = wasm.get_record_len(engine.__wbg_ptr);
    return ret >>> 0;
}

/**
* @param {Engine} engine
* @param {Uint8Array} bin
*/
export function set_next_record(engine, bin) {
    _assertClass(engine, Engine);
    const ptr0 = passArray8ToWasm0(bin, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_next_record(engine.__wbg_ptr, ptr0, len0);
}

/**
* @param {Engine} engine
*/
export function set_next_record_last(engine) {
    _assertClass(engine, Engine);
    wasm.set_next_record_last(engine.__wbg_ptr);
}

/**
* @param {Engine} engine
* @returns {boolean}
*/
export function is_play_end(engine) {
    _assertClass(engine, Engine);
    const ret = wasm.is_play_end(engine.__wbg_ptr);
    return ret !== 0;
}

/**
* @param {Engine} engine
* @param {number} node_id
*/
export function set_debug_entity(engine, node_id) {
    _assertClass(engine, Engine);
    wasm.set_debug_entity(engine.__wbg_ptr, node_id);
}

/**
*
* * -buffer Vec<Vec<u8>>
*
* @param {number} key
* @param {Array<any>} buffer
*/
export function sdf_on_load(key, buffer) {
    wasm.sdf_on_load(key, addHeapObject(buffer));
}

/**
* @param {Gui} gui
* @param {Uint8Array} bin
*/
export function add_sdf_font(gui, bin) {
    _assertClass(gui, Gui);
    const ptr0 = passArray8ToWasm0(bin, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.add_sdf_font(gui.__wbg_ptr, ptr0, len0);
}

/**
* @param {Gui} gui
* @param {Atom} font_name
* @param {Uint8Array} blob
*/
export function add_sdf2_font(gui, font_name, blob) {
    _assertClass(gui, Gui);
    _assertClass(font_name, Atom);
    const ptr0 = passArray8ToWasm0(blob, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.add_sdf2_font(gui.__wbg_ptr, font_name.__wbg_ptr, ptr0, len0);
}

/**
* @param {Engine} engine
* @param {number} node_id
* @param {number} x
* @param {number} y
* @returns {CharPos}
*/
export function query_text(engine, node_id, x, y) {
    _assertClass(engine, Engine);
    const ret = wasm.query_text(engine.__wbg_ptr, node_id, x, y);
    return CharPos.__wrap(ret);
}

/**
* @param {Gui} gui
* @param {Engine} engine
* @param {number} node_id
* @param {number} index
* @returns {CharPos}
*/
export function get_text_pos(gui, engine, node_id, index) {
    _assertClass(gui, Gui);
    _assertClass(engine, Engine);
    const ret = wasm.get_text_pos(gui.__wbg_ptr, engine.__wbg_ptr, node_id, index);
    return CharPos.__wrap(ret);
}

/**
* 是否存在资源
* @param {Engine} engine
* @param {Atom} path
* @returns {boolean}
*/
export function has_res(engine, path) {
    _assertClass(engine, Engine);
    _assertClass(path, Atom);
    const ret = wasm.has_res(engine.__wbg_ptr, path.__wbg_ptr);
    return ret !== 0;
}

/**
* 加载资源
* @param {Gui} gui
* @param {Atom} path
*/
export function load_res(gui, path) {
    _assertClass(gui, Gui);
    _assertClass(path, Atom);
    wasm.load_res(gui.__wbg_ptr, path.__wbg_ptr);
}

/**
* 获取已经加载成功的资源
* @param {Engine} engine
* @returns {number}
*/
export function get_success_res_len(engine) {
    _assertClass(engine, Engine);
    const ret = wasm.get_success_res_len(engine.__wbg_ptr);
    return ret >>> 0;
}

/**
* @param {Engine} engine
* @param {Array<any>} result
* @param {Float64Array} result_keys
*/
export function get_success_res(engine, result, result_keys) {
    _assertClass(engine, Engine);
    var ptr0 = passArrayF64ToWasm0(result_keys, wasm.__wbindgen_malloc);
    var len0 = WASM_VECTOR_LEN;
    wasm.get_success_res(engine.__wbg_ptr, addHeapObject(result), ptr0, len0, addHeapObject(result_keys));
}

/**
* @param {Engine} engine
* @param {CommandsExchangeSpine} cmds
*/
export function spine_exchange_commands(engine, cmds) {
    _assertClass(engine, Engine);
    _assertClass(cmds, CommandsExchangeSpine);
    wasm.spine_exchange_commands(engine.__wbg_ptr, cmds.__wbg_ptr);
}

/**
* @param {Engine} engine
*/
export function init_spine_context(engine) {
    _assertClass(engine, Engine);
    wasm.init_spine_context(engine.__wbg_ptr);
}

/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {string} name
* @param {number | undefined} [width]
* @param {number | undefined} [height]
* @returns {number}
*/
export function spine_renderer_create(app, cmds, name, width, height) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeSpine);
    const ptr0 = passStringToWasm0(name, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.spine_renderer_create(app.__wbg_ptr, cmds.__wbg_ptr, ptr0, len0, !isLikeNone(width), isLikeNone(width) ? 0 : width, !isLikeNone(height), isLikeNone(height) ? 0 : height);
    return ret;
}

/**
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
*/
export function spine_renderer_dispose(cmds, id_renderer) {
    _assertClass(cmds, CommandsExchangeSpine);
    wasm.spine_renderer_dispose(cmds.__wbg_ptr, id_renderer);
}

/**
* @param {CommandsExchangeSpine} cmds
* @param {Atom} key
* @param {boolean} srgb
* @param {boolean} compressed
* @param {boolean} file
* @returns {number}
*/
export function spine_texture_load(cmds, key, srgb, compressed, file) {
    _assertClass(cmds, CommandsExchangeSpine);
    _assertClass(key, Atom);
    const ret = wasm.spine_texture_load(cmds.__wbg_ptr, key.__wbg_ptr, srgb, compressed, file);
    return ret;
}

/**
* @param {Engine} app
* @param {SpineTextureLoadRecord} record
*/
export function spine_texture_loaded_query(app, record) {
    _assertClass(app, Engine);
    _assertClass(record, SpineTextureLoadRecord);
    wasm.spine_texture_loaded_query(app.__wbg_ptr, record.__wbg_ptr);
}

/**
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {TextureDefaultView} texture
*/
export function spine_texture_record(cmds, id_renderer, texture) {
    _assertClass(cmds, CommandsExchangeSpine);
    _assertClass(texture, TextureDefaultView);
    wasm.spine_texture_record(cmds.__wbg_ptr, id_renderer, texture.__wbg_ptr);
}

/**
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {number} key
*/
export function spine_remove_texture(cmds, id_renderer, key) {
    _assertClass(cmds, CommandsExchangeSpine);
    wasm.spine_remove_texture(cmds.__wbg_ptr, id_renderer, key);
}

/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {TextureDefaultView} texture
* @param {number} address_mode_u
* @param {number} address_mode_v
* @param {number} address_mode_w
* @param {number} mag_filter
* @param {number} min_filter
* @param {number} mipmap_filter
*/
export function spine_use_texture(app, cmds, id_renderer, texture, address_mode_u, address_mode_v, address_mode_w, mag_filter, min_filter, mipmap_filter) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeSpine);
    _assertClass(texture, TextureDefaultView);
    wasm.spine_use_texture(app.__wbg_ptr, cmds.__wbg_ptr, id_renderer, texture.__wbg_ptr, address_mode_u, address_mode_v, address_mode_w, mag_filter, min_filter, mipmap_filter);
}

/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {KeySpineShader} shader
*/
export function spine_shader(app, cmds, id_renderer, shader) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeSpine);
    wasm.spine_shader(app.__wbg_ptr, cmds.__wbg_ptr, id_renderer, shader);
}

/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {boolean} val
*/
export function spine_blend(app, cmds, id_renderer, val) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeSpine);
    wasm.spine_blend(app.__wbg_ptr, cmds.__wbg_ptr, id_renderer, val);
}

/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {number} src
* @param {number} dst
*/
export function spine_blend_mode(app, cmds, id_renderer, src, dst) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeSpine);
    wasm.spine_blend_mode(app.__wbg_ptr, cmds.__wbg_ptr, id_renderer, src, dst);
}

/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {Float32Array} val
*/
export function spine_uniform(app, cmds, id_renderer, val) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeSpine);
    const ptr0 = passArrayF32ToWasm0(val, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.spine_uniform(app.__wbg_ptr, cmds.__wbg_ptr, id_renderer, ptr0, len0);
}

/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
* @param {Float32Array} vertices
* @param {Uint16Array} indices
* @param {number} vlen
* @param {number} ilen
*/
export function spine_draw(app, cmds, id_renderer, vertices, indices, vlen, ilen) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeSpine);
    const ptr0 = passArrayF32ToWasm0(vertices, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passArray16ToWasm0(indices, wasm.__wbindgen_malloc);
    const len1 = WASM_VECTOR_LEN;
    wasm.spine_draw(app.__wbg_ptr, cmds.__wbg_ptr, id_renderer, ptr0, len0, ptr1, len1, vlen, ilen);
}

/**
* @param {Engine} app
* @param {CommandsExchangeSpine} cmds
* @param {number} id_renderer
*/
export function spine_reset(app, cmds, id_renderer) {
    _assertClass(app, Engine);
    _assertClass(cmds, CommandsExchangeSpine);
    wasm.spine_reset(app.__wbg_ptr, cmds.__wbg_ptr, id_renderer);
}

/**
*/
export function bon_debug() {
    wasm.bon_debug();
}

/**
* @param {Uint8Array} data
* @returns {Uint8Array}
*/
export function decompress_br(data) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        const ptr0 = passArray8ToWasm0(data, wasm.__wbindgen_malloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.decompress_br(retptr, ptr0, len0);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        var v2 = getArrayU8FromWasm0(r0, r1).slice();
        wasm.__wbindgen_free(r0, r1 * 1, 1);
        return v2;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @returns {Uint8Array}
*/
export function test_uint8array() {
    const ret = wasm.test_uint8array();
    return takeObject(ret);
}

/**
* @returns {Map<any, any>}
*/
export function test_map() {
    const ret = wasm.test_map();
    return takeObject(ret);
}

/**
* @returns {Array<any>}
*/
export function test_arr() {
    const ret = wasm.test_arr();
    return takeObject(ret);
}

/**
* @returns {object}
*/
export function test_obj() {
    const ret = wasm.test_obj();
    return takeObject(ret);
}

/**
* @returns {ConfigMgr}
*/
export function test_mgr() {
    const ret = wasm.test_mgr();
    return ConfigMgr.__wrap(ret);
}

function getArrayI32FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getInt32Memory0().subarray(ptr / 4, ptr / 4 + len);
}
/**
*/
export const TileFlagType = Object.freeze({ All:0,"0":"All",Center:1,"1":"Center",Right:2,"2":"Right",Down:4,"4":"Down", });
/**
* Initializes the global logger setting `max_log_level` to the given value.
*/
export const Level = Object.freeze({
/**
* The "error" level.
*
* Designates very serious errors.
*/
Error:1,"1":"Error",
/**
* The "warn" level.
*
* Designates hazardous situations.
*/
Warn:2,"2":"Warn",
/**
* The "info" level.
*
* Designates useful information.
*/
Info:3,"3":"Info",
/**
* The "debug" level.
*
* Designates lower priority information.
*/
Debug:4,"4":"Debug",
/**
* The "trace" level.
*
* Designates very low priority, often extremely verbose, information.
*/
Trace:5,"5":"Trace", });
/**
*/
export const EAnimationGroupListen = Object.freeze({ Start:0,"0":"Start",End:1,"1":"End",Loop:2,"2":"Loop",Frame:3,"3":"Frame", });
/**
* blocks.regist::<(.*)>\(\);
*/
export const BuiltinNodeMaterialBlock = Object.freeze({ BlockFloat:0,"0":"BlockFloat",BlockViewDirection:1,"1":"BlockViewDirection",BlockColorSpace:2,"2":"BlockColorSpace",BlockColorGray:3,"3":"BlockColorGray",BlockColorHSV:4,"4":"BlockColorHSV",BlockTextureChannel:5,"5":"BlockTextureChannel",BlockUVOffsetSpeed:6,"6":"BlockUVOffsetSpeed",BlockFog:7,"7":"BlockFog",BlockCutoff:8,"8":"BlockCutoff",BlockMainTexture:9,"9":"BlockMainTexture",BlockMainTextureUVOffsetSpeed:10,"10":"BlockMainTextureUVOffsetSpeed",BlockOpacity:11,"11":"BlockOpacity",BlockOpacityTexture:12,"12":"BlockOpacityTexture",BlockOpacityTextureUVOffsetSpeed:13,"13":"BlockOpacityTextureUVOffsetSpeed",BlockOpacity2Texture:14,"14":"BlockOpacity2Texture",BlockOpacity2TextureUVOffsetSpeed:15,"15":"BlockOpacity2TextureUVOffsetSpeed",BlockEmissiveTexture:16,"16":"BlockEmissiveTexture",BlockEmissiveTextureUVOffsetSpeed:17,"17":"BlockEmissiveTextureUVOffsetSpeed",BlockMixTexture:18,"18":"BlockMixTexture",BlockMixTextureUVOffsetSpeed:19,"19":"BlockMixTextureUVOffsetSpeed",BlockMaskTexture:20,"20":"BlockMaskTexture",BlockMaskTextureUVOffsetSpeed:21,"21":"BlockMaskTextureUVOffsetSpeed",BlockFresnel:22,"22":"BlockFresnel",BlockEmissiveFresnel:23,"23":"BlockEmissiveFresnel",BlockOpacityFresnel:24,"24":"BlockOpacityFresnel",BlockPremultiplyResult:25,"25":"BlockPremultiplyResult", });
/**
*/
export const EAnimePropertyID = Object.freeze({ LocalPosition:0,"0":"LocalPosition",LocalRotation:1,"1":"LocalRotation",LocalScaling:2,"2":"LocalScaling",MainTexUScale:3,"3":"MainTexUScale",MainTexVScale:4,"4":"MainTexVScale",MainTexUOffset:5,"5":"MainTexUOffset",MainTexVOffset:6,"6":"MainTexVOffset",Alpha:7,"7":"Alpha",MainColor:8,"8":"MainColor",CameraOrthSize:9,"9":"CameraOrthSize",CameraFov:10,"10":"CameraFov",Enable:11,"11":"Enable",LocalEulerAngles:12,"12":"LocalEulerAngles",Intensity:13,"13":"Intensity",LightDiffuse:14,"14":"LightDiffuse",AlphaCutoff:15,"15":"AlphaCutoff",CellId:16,"16":"CellId",OpacityTexUScale:17,"17":"OpacityTexUScale",OpacityTexVScale:18,"18":"OpacityTexVScale",OpacityTexUOffset:19,"19":"OpacityTexUOffset",OpacityTexVOffset:20,"20":"OpacityTexVOffset",MaskCutoff:21,"21":"MaskCutoff",MaskTexUScale:22,"22":"MaskTexUScale",MaskTexVScale:23,"23":"MaskTexVScale",MaskTexUOffset:24,"24":"MaskTexUOffset",MaskTexVOffset:25,"25":"MaskTexVOffset",MainTexTilloff:50,"50":"MainTexTilloff",MaskTexTilloff:51,"51":"MaskTexTilloff",OpacityTexTilloff:52,"52":"OpacityTexTilloff",BoneOffset:100,"100":"BoneOffset",IndicesRange:101,"101":"IndicesRange", });
/**
*/
export const EAmountMode = Object.freeze({ None:0,"0":"None",BackIn:1,"1":"BackIn",BackOut:2,"2":"BackOut",BackInOut:3,"3":"BackInOut",CircleIn:4,"4":"CircleIn",CircleOut:5,"5":"CircleOut",CircleInOut:6,"6":"CircleInOut",CubicIn:7,"7":"CubicIn",CubicOut:8,"8":"CubicOut",CubicInOut:9,"9":"CubicInOut",SineIn:10,"10":"SineIn",SineOut:11,"11":"SineOut",SineInOut:12,"12":"SineInOut",QuadIn:13,"13":"QuadIn",QuadOut:14,"14":"QuadOut",QuadInOut:15,"15":"QuadInOut",QuartIn:16,"16":"QuartIn",QuartOut:17,"17":"QuartOut",QuartInOut:18,"18":"QuartInOut",QuintIn:19,"19":"QuintIn",QuintOut:20,"20":"QuintOut",QuintInOut:21,"21":"QuintInOut",ExpoIn:22,"22":"ExpoIn",ExpoOut:23,"23":"ExpoOut",ExpoInOut:24,"24":"ExpoInOut",ElasticIn:25,"25":"ElasticIn",ElasticOut:26,"26":"ElasticOut",ElasticInOut:27,"27":"ElasticInOut",BounceIn:28,"28":"BounceIn",BounceOut:29,"29":"BounceOut",BounceInOut:30,"30":"BounceInOut",JumpStart:31,"31":"JumpStart",JumpEnd:32,"32":"JumpEnd",JumpNone:33,"33":"JumpNone",JumpBoth:34,"34":"JumpBoth",CubicBezier:35,"35":"CubicBezier", });
/**
*/
export const ELoopMode = Object.freeze({
/**
* 不循环
*/
Not:0,"0":"Not",
/**
* 正向循环
* * 指定循环次数 - None 无限循环
*/
Positive:1,"1":"Positive",
/**
* 反向循环
* * 指定循环次数 - None 无限循环
*/
Opposite:2,"2":"Opposite",
/**
* 正向反复循环
* * 指定循环次数 - None 无限循环
*/
PositivePly:3,"3":"PositivePly",
/**
* 反向反复循环
* * 指定循环次数 - None 无限循环
*/
OppositePly:4,"4":"OppositePly", });
/**
*/
export const EFillMode = Object.freeze({ None:0,"0":"None",Forwards:1,"1":"Forwards",Backwards:2,"2":"Backwards",Both:3,"3":"Both", });
/**
*/
export const TraceOption = Object.freeze({ None:0,"0":"None",Record:1,"1":"Record",Play:2,"2":"Play", });
/**
*/
export const BlendMode = Object.freeze({ Normal:0,"0":"Normal",AlphaAdd:1,"1":"AlphaAdd",Subtract:2,"2":"Subtract",Multiply:3,"3":"Multiply",OneOne:4,"4":"OneOne", });
/**
*/
export const KeySpineShader = Object.freeze({ Colored:0,"0":"Colored",ColoredTextured:1,"1":"ColoredTextured",TwoColoredTextured:2,"2":"TwoColoredTextured", });
/**
*/
export const Direction = Object.freeze({ Left:0,"0":"Left",Right:1,"1":"Right",Up:2,"2":"Up",Down:3,"3":"Down", });
/**
*/
export const EAnimeCurve = Object.freeze({ FrameValues:0,"0":"FrameValues",FrameValuesStep:1,"1":"FrameValuesStep",EasingCurve:2,"2":"EasingCurve",MinMaxCurve:3,"3":"MinMaxCurve",CubicBezierCurve:4,"4":"CubicBezierCurve",GLTFCubicSpline:5,"5":"GLTFCubicSpline", });

const AStarFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_astar_free(ptr >>> 0));
/**
*/
export class AStar {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(AStar.prototype);
        obj.__wbg_ptr = ptr;
        AStarFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        AStarFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_astar_free(ptr);
    }
    /**
    * @param {number} width
    * @param {number} height
    * @param {number} node_number
    * @returns {AStar}
    */
    static new(width, height, node_number) {
        const ret = wasm.astar_new(width, height, node_number);
        return AStar.__wrap(ret);
    }
    /**
    * @param {TileMap} tile_map
    * @param {number} max_number
    * @param {number} start
    * @param {number} end
    * @param {number} center_flag
    * @param {number} side_flag
    * @returns {number | undefined}
    */
    find_path(tile_map, max_number, start, end, center_flag, side_flag) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            _assertClass(tile_map, TileMap);
            wasm.astar_find_path(retptr, this.__wbg_ptr, tile_map.__wbg_ptr, max_number, start, end, center_flag, side_flag);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return r0 === 0 ? null : r1 >>> 0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} node
    * @param {TileMap} tile_map
    * @param {number} center_flag
    * @param {number} side_flag
    */
    result(node, tile_map, center_flag, side_flag) {
        _assertClass(tile_map, TileMap);
        wasm.astar_result(this.__wbg_ptr, node, tile_map.__wbg_ptr, center_flag, side_flag);
    }
}

const ActionSetScene3DFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_actionsetscene3d_free(ptr >>> 0));
/**
*/
export class ActionSetScene3D {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(ActionSetScene3D.prototype);
        obj.__wbg_ptr = ptr;
        ActionSetScene3DFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ActionSetScene3DFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_actionsetscene3d_free(ptr);
    }
    /**
    * @param {Engine} app
    * @returns {ActionSetScene3D}
    */
    static create(app) {
        _assertClass(app, Engine);
        const ret = wasm.actionsetscene3d_create(app.__wbg_ptr);
        return ActionSetScene3D.__wrap(ret);
    }
}

const AtomFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_atom_free(ptr >>> 0));
/**
*/
export class Atom {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(Atom.prototype);
        obj.__wbg_ptr = ptr;
        AtomFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        AtomFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_atom_free(ptr);
    }
    /**
    * @param {string} value
    * @returns {Atom}
    */
    static from_string(value) {
        const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.atom_from_string(ptr0, len0);
        return Atom.__wrap(ret);
    }
    /**
    * @param {number} value
    * @returns {string | undefined}
    */
    static get_string_by_hash(value) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.atom_get_string_by_hash(retptr, value);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            let v1;
            if (r0 !== 0) {
                v1 = getStringFromWasm0(r0, r1).slice();
                wasm.__wbindgen_free(r0, r1 * 1, 1);
            }
            return v1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @returns {number}
    */
    get_hash() {
        const ret = wasm.atom_get_hash(this.__wbg_ptr);
        return ret;
    }
}

const CharPosFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_charpos_free(ptr >>> 0));
/**
*/
export class CharPos {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(CharPos.prototype);
        obj.__wbg_ptr = ptr;
        CharPosFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        CharPosFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_charpos_free(ptr);
    }
    /**
    * @returns {number}
    */
    index() {
        const ret = wasm.charpos_index(this.__wbg_ptr);
        return ret;
    }
    /**
    * @returns {number}
    */
    x() {
        const ret = wasm.charpos_x(this.__wbg_ptr);
        return ret;
    }
    /**
    * @returns {number}
    */
    y() {
        const ret = wasm.charpos_y(this.__wbg_ptr);
        return ret;
    }
}

const CommandsExchangeD3Finalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_commandsexchanged3_free(ptr >>> 0));
/**
*/
export class CommandsExchangeD3 {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(CommandsExchangeD3.prototype);
        obj.__wbg_ptr = ptr;
        CommandsExchangeD3Finalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        CommandsExchangeD3Finalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_commandsexchanged3_free(ptr);
    }
    /**
    * @returns {CommandsExchangeD3}
    */
    static create() {
        const ret = wasm.commandsexchanged3_create();
        return CommandsExchangeD3.__wrap(ret);
    }
}

const CommandsExchangeSpineFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_commandsexchangespine_free(ptr >>> 0));
/**
*/
export class CommandsExchangeSpine {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(CommandsExchangeSpine.prototype);
        obj.__wbg_ptr = ptr;
        CommandsExchangeSpineFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        CommandsExchangeSpineFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_commandsexchangespine_free(ptr);
    }
    /**
    * @returns {CommandsExchangeSpine}
    */
    static create() {
        const ret = wasm.commandsexchangespine_create();
        return CommandsExchangeSpine.__wrap(ret);
    }
}

const ConfigMgrFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_configmgr_free(ptr >>> 0));
/**
*/
export class ConfigMgr {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(ConfigMgr.prototype);
        obj.__wbg_ptr = ptr;
        ConfigMgrFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ConfigMgrFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_configmgr_free(ptr);
    }
    /**
    * @param {number} cache_size
    * @param {number} timeout
    * @returns {ConfigMgr}
    */
    static init(cache_size, timeout) {
        const ret = wasm.configmgr_init(cache_size, timeout);
        return ConfigMgr.__wrap(ret);
    }
    /**
    * @param {Uint8Array} buffer
    */
    add_buffer(buffer) {
        const ptr0 = passArray8ToWasm0(buffer, wasm.__wbindgen_malloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.configmgr_add_buffer(this.__wbg_ptr, ptr0, len0);
    }
    /**
    * @param {number} tab
    * @param {any} key
    * @returns {any}
    */
    get_config(tab, key) {
        const ret = wasm.configmgr_get_config(this.__wbg_ptr, tab, addHeapObject(key));
        return takeObject(ret);
    }
    /**
    * @param {number} tab
    * @returns {string | undefined}
    */
    get_struct_info(tab) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.configmgr_get_struct_info(retptr, this.__wbg_ptr, tab);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            let v1;
            if (r0 !== 0) {
                v1 = getStringFromWasm0(r0, r1).slice();
                wasm.__wbindgen_free(r0, r1 * 1, 1);
            }
            return v1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} tab
    * @returns {any}
    */
    get_tab(tab) {
        const ret = wasm.configmgr_get_tab(this.__wbg_ptr, tab);
        return takeObject(ret);
    }
    /**
    * @param {number} tab
    * @param {any} key
    * @returns {boolean}
    */
    get_config_buffer(tab, key) {
        const ret = wasm.configmgr_get_config_buffer(this.__wbg_ptr, tab, addHeapObject(key));
        return ret !== 0;
    }
    /**
    * @param {number} tab
    * @returns {TabBuffer | undefined}
    */
    get_tab_buffer(tab) {
        const ret = wasm.configmgr_get_tab_buffer(this.__wbg_ptr, tab);
        return ret === 0 ? null : TabBuffer.__wrap(ret);
    }
    /**
    * @param {number} tab
    * @returns {any}
    */
    get_keys(tab) {
        const ret = wasm.configmgr_get_keys(this.__wbg_ptr, tab);
        return takeObject(ret);
    }
    /**
    * @param {number} tab
    * @returns {any}
    */
    get_infos(tab) {
        const ret = wasm.configmgr_get_infos(this.__wbg_ptr, tab);
        return takeObject(ret);
    }
}

const DataTextureResFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_datatextureres_free(ptr >>> 0));
/**
*/
export class DataTextureRes {

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        DataTextureResFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_datatextureres_free(ptr);
    }
}

const EngineFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_engine_free(ptr >>> 0));
/**
*/
export class Engine {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(Engine.prototype);
        obj.__wbg_ptr = ptr;
        EngineFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        EngineFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_engine_free(ptr);
    }
}

const GLTFResFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_gltfres_free(ptr >>> 0));
/**
*/
export class GLTFRes {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(GLTFRes.prototype);
        obj.__wbg_ptr = ptr;
        GLTFResFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        GLTFResFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_gltfres_free(ptr);
    }
}

const GeometryMetaFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_geometrymeta_free(ptr >>> 0));
/**
*/
export class GeometryMeta {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(GeometryMeta.prototype);
        obj.__wbg_ptr = ptr;
        GeometryMetaFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        GeometryMetaFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_geometrymeta_free(ptr);
    }
    /**
    * @returns {GeometryMeta}
    */
    static create_empty() {
        const ret = wasm.geometrymeta_create_empty();
        return GeometryMeta.__wrap(ret);
    }
    /**
    * @returns {GeometryMeta}
    */
    static create_box() {
        const ret = wasm.geometrymeta_create_box();
        return GeometryMeta.__wrap(ret);
    }
    /**
    * @returns {GeometryMeta}
    */
    static create_quad() {
        const ret = wasm.geometrymeta_create_quad();
        return GeometryMeta.__wrap(ret);
    }
}

const GuiFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_gui_free(ptr >>> 0));
/**
*/
export class Gui {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(Gui.prototype);
        obj.__wbg_ptr = ptr;
        GuiFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        GuiFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_gui_free(ptr);
    }
}

const ImageResFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_imageres_free(ptr >>> 0));
/**
*/
export class ImageRes {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(ImageRes.prototype);
        obj.__wbg_ptr = ptr;
        ImageResFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ImageResFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_imageres_free(ptr);
    }
}

const MaterialUniformDefinesFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_materialuniformdefines_free(ptr >>> 0));
/**
*/
export class MaterialUniformDefines {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(MaterialUniformDefines.prototype);
        obj.__wbg_ptr = ptr;
        MaterialUniformDefinesFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        MaterialUniformDefinesFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_materialuniformdefines_free(ptr);
    }
    /**
    * @returns {MaterialUniformDefines}
    */
    static create() {
        const ret = wasm.materialuniformdefines_create();
        return MaterialUniformDefines.__wrap(ret);
    }
}

const NodeMaterialBlockFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_nodematerialblock_free(ptr >>> 0));
/**
*/
export class NodeMaterialBlock {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(NodeMaterialBlock.prototype);
        obj.__wbg_ptr = ptr;
        NodeMaterialBlockFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        NodeMaterialBlockFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_nodematerialblock_free(ptr);
    }
    /**
    * @param {Atom} key
    * @param {string} vs_define
    * @param {string} vs_surface
    * @param {string} fs_define
    * @param {string} fs_surface
    * @param {number | undefined} [bind_defines]
    * @returns {NodeMaterialBlock}
    */
    static create(key, vs_define, vs_surface, fs_define, fs_surface, bind_defines) {
        _assertClass(key, Atom);
        const ptr0 = passStringToWasm0(vs_define, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ptr1 = passStringToWasm0(vs_surface, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        const ptr2 = passStringToWasm0(fs_define, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len2 = WASM_VECTOR_LEN;
        const ptr3 = passStringToWasm0(fs_surface, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len3 = WASM_VECTOR_LEN;
        const ret = wasm.nodematerialblock_create(key.__wbg_ptr, ptr0, len0, ptr1, len1, ptr2, len2, ptr3, len3, !isLikeNone(bind_defines), isLikeNone(bind_defines) ? 0 : bind_defines);
        return NodeMaterialBlock.__wrap(ret);
    }
}

const NodematerialIncludesFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_nodematerialincludes_free(ptr >>> 0));
/**
*/
export class NodematerialIncludes {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(NodematerialIncludes.prototype);
        obj.__wbg_ptr = ptr;
        NodematerialIncludesFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        NodematerialIncludesFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_nodematerialincludes_free(ptr);
    }
    /**
    * @returns {NodematerialIncludes}
    */
    static create() {
        const ret = wasm.nodematerialincludes_create();
        return NodematerialIncludes.__wrap(ret);
    }
}

const P3DShaderMetaFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_p3dshadermeta_free(ptr >>> 0));
/**
*/
export class P3DShaderMeta {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(P3DShaderMeta.prototype);
        obj.__wbg_ptr = ptr;
        P3DShaderMetaFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        P3DShaderMetaFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_p3dshadermeta_free(ptr);
    }
}

const P3DShaderVaryingsFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_p3dshadervaryings_free(ptr >>> 0));
/**
*/
export class P3DShaderVaryings {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(P3DShaderVaryings.prototype);
        obj.__wbg_ptr = ptr;
        P3DShaderVaryingsFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        P3DShaderVaryingsFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_p3dshadervaryings_free(ptr);
    }
    /**
    * @returns {P3DShaderVaryings}
    */
    static create() {
        const ret = wasm.nodematerialincludes_create();
        return P3DShaderVaryings.__wrap(ret);
    }
}

const PTextureFrameAtlasFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_ptextureframeatlas_free(ptr >>> 0));
/**
*/
export class PTextureFrameAtlas {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(PTextureFrameAtlas.prototype);
        obj.__wbg_ptr = ptr;
        PTextureFrameAtlasFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        PTextureFrameAtlasFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_ptextureframeatlas_free(ptr);
    }
}

const QuadTreeFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_quadtree_free(ptr >>> 0));
/**
*/
export class QuadTree {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(QuadTree.prototype);
        obj.__wbg_ptr = ptr;
        QuadTreeFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        QuadTreeFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_quadtree_free(ptr);
    }
    /**
    * @returns {QuadTree}
    */
    static default() {
        const ret = wasm.quadtree_default();
        return QuadTree.__wrap(ret);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @param {number} min_loose_x
    * @param {number} min_loose_y
    * @param {number} max_loose_x
    * @param {number} max_loose_y
    * @returns {QuadTree}
    */
    static new(min_x, min_y, max_x, max_y, min_loose_x, min_loose_y, max_loose_x, max_loose_y) {
        const ret = wasm.quadtree_new(min_x, min_y, max_x, max_y, min_loose_x, min_loose_y, max_loose_x, max_loose_y);
        return QuadTree.__wrap(ret);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @returns {number}
    */
    add(min_x, min_y, max_x, max_y) {
        const ret = wasm.quadtree_add(this.__wbg_ptr, min_x, min_y, max_x, max_y);
        return ret;
    }
    /**
    * @param {number} id
    */
    remove(id) {
        wasm.quadtree_remove(this.__wbg_ptr, id);
    }
    /**
    * @param {number} id
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    */
    update(id, min_x, min_y, max_x, max_y) {
        wasm.quadtree_update(this.__wbg_ptr, id, min_x, min_y, max_x, max_y);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @returns {Float64Array}
    */
    query(min_x, min_y, max_x, max_y) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.quadtree_query(retptr, this.__wbg_ptr, min_x, min_y, max_x, max_y);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            var v1 = getArrayF64FromWasm0(r0, r1).slice();
            wasm.__wbindgen_free(r0, r1 * 8, 8);
            return v1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @param {Float64Array} result
    * @param {number} max_len
    * @returns {number}
    */
    query_max(min_x, min_y, max_x, max_y, result, max_len) {
        var ptr0 = passArrayF64ToWasm0(result, wasm.__wbindgen_malloc);
        var len0 = WASM_VECTOR_LEN;
        const ret = wasm.quadtree_query_max(this.__wbg_ptr, min_x, min_y, max_x, max_y, ptr0, len0, addHeapObject(result), max_len);
        return ret;
    }
}

const RVOSimulatorFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_rvosimulator_free(ptr >>> 0));
/**
*/
export class RVOSimulator {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(RVOSimulator.prototype);
        obj.__wbg_ptr = ptr;
        RVOSimulatorFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        RVOSimulatorFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_rvosimulator_free(ptr);
    }
    /**
    * @param {number} time_step
    * @param {number} neighbor_dist
    * @param {number} max_neighbors
    * @param {number} time_horizon
    * @param {number} time_horizon_obst
    * @param {number} radius
    * @param {number} max_speed
    * @param {number} velocity_x
    * @param {number} velocity_y
    * @param {number} rng_seed
    * @returns {RVOSimulator}
    */
    static new(time_step, neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y, rng_seed) {
        const ret = wasm.rvosimulator_new(time_step, neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y, rng_seed);
        return RVOSimulator.__wrap(ret);
    }
    /**
    * @returns {RVOSimulator}
    */
    static default() {
        const ret = wasm.rvosimulator_default();
        return RVOSimulator.__wrap(ret);
    }
    /**
    * @param {number} position_x
    * @param {number} position_y
    * @param {number} speed
    * @returns {number}
    */
    add_agent(position_x, position_y, speed) {
        const ret = wasm.rvosimulator_add_agent(this.__wbg_ptr, position_x, position_y, speed);
        return ret;
    }
    /**
    * @param {number} position_x
    * @param {number} position_y
    * @param {number} neighbor_dist
    * @param {number} max_neighbors
    * @param {number} time_horizon
    * @param {number} time_horizon_obst
    * @param {number} radius
    * @param {number} max_speed
    * @param {number} velocity_x
    * @param {number} velocity_y
    * @returns {number}
    */
    add_agent2(position_x, position_y, neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y) {
        const ret = wasm.rvosimulator_add_agent2(this.__wbg_ptr, position_x, position_y, neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y);
        return ret;
    }
    /**
    * @param {number} id
    * @returns {boolean}
    */
    remove_agent(id) {
        const ret = wasm.rvosimulator_remove_agent(this.__wbg_ptr, id);
        return ret !== 0;
    }
    /**
    *
    *     * @brief 为模拟添加新障碍。
    *     * @param[in] vertices 逆时针顺序排列的多边形障碍物的顶点列表。
    *     * @return 障碍物第一个顶点的编号，当顶点数小于2时为返回usize::MAX。
    *     * @note 要添加“负面”障碍，例如环境周围的边界多边形，顶点应按顺时针顺序列出。
    *
    * @param {Float32Array} vertices
    * @returns {number}
    */
    add_obstacle(vertices) {
        const ptr0 = passArrayF32ToWasm0(vertices, wasm.__wbindgen_malloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rvosimulator_add_obstacle(this.__wbg_ptr, ptr0, len0);
        return ret;
    }
    /**
    * @param {number} id
    * @returns {boolean}
    */
    remove_obstacle(id) {
        const ret = wasm.rvosimulator_remove_obstacle(this.__wbg_ptr, id);
        return ret !== 0;
    }
    /**
    * @returns {boolean}
    */
    do_step() {
        const ret = wasm.rvosimulator_do_step(this.__wbg_ptr);
        return ret !== 0;
    }
    /**
    *
    *    * @brief     为添加的任何新代理设置默认属性。
    *    * @param[in] neighborDist    新代理在导航中考虑的默认最大中心点到中心点到其他代理的最大距离。
    *                                 这个数字越大，模拟的运行时间就越长。
    *                                 如果数字太低，模拟将不安全。
    *                                 必须是非负数。
    *    * @param[in] maxNeighbors    新代理在导航中考虑的默认最大其他代理数。
    *                                 这个数字越大，模拟的运行时间越长。
    *                                 如果数字太低，模拟将不安全。
    *    * @param[in] timeHorizon     模拟计算的新代理速度相对于其他代理安全的默认最小时间量。
    *                                 这个数字越大，代理就会越快响应其他代理的存在，但代理在选择速度方面的自由度就越小。
    *                                 必须是正数。
    *    * @param[in] timeHorizonObst 通过模拟计算的新代理的速度相对于障碍物是安全的默认最小时间量。
    *                                 这个数字越大，代理越快响应障碍的存在，但代理的自由度越低 选择它的速度。
    *                                 必须是正数。
    *    * @param[in] radius          新代理的默认半径。 必须是非负数。
    *    * @param[in] maxSpeed        新代理的默认最大速度。 必须是非负数。
    *
    * @param {number} neighbor_dist
    * @param {number} max_neighbors
    * @param {number} time_horizon
    * @param {number} time_horizon_obst
    * @param {number} radius
    * @param {number} max_speed
    * @param {number} velocity_x
    * @param {number} velocity_y
    */
    set_agent_defaults(neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y) {
        wasm.rvosimulator_set_agent_defaults(this.__wbg_ptr, neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y);
    }
    /**
    * @param {number} agent_no
    * @param {number} neighbor_no
    * @returns {number | undefined}
    */
    get_agent_agent_neighbor(agent_no, neighbor_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_agent_neighbor(retptr, this.__wbg_ptr, agent_no, neighbor_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r2 = getFloat64Memory0()[retptr / 8 + 1];
            return r0 === 0 ? null : r2;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_max_neighbors(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_max_neighbors(retptr, this.__wbg_ptr, agent_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return r0 === 0 ? null : r1 >>> 0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_max_speed(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_max_speed(retptr, this.__wbg_ptr, agent_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getFloat32Memory0()[retptr / 4 + 1];
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_neighbor_dist(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_neighbor_dist(retptr, this.__wbg_ptr, agent_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getFloat32Memory0()[retptr / 4 + 1];
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_num_agent_neighbors(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_num_agent_neighbors(retptr, this.__wbg_ptr, agent_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return r0 === 0 ? null : r1 >>> 0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_num_obstacle_neighbors(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_num_obstacle_neighbors(retptr, this.__wbg_ptr, agent_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return r0 === 0 ? null : r1 >>> 0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_num_orcalines(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_num_orcalines(retptr, this.__wbg_ptr, agent_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            return r0 === 0 ? null : r1 >>> 0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @param {number} neighbor_no
    * @returns {number | undefined}
    */
    get_agent_obstacle_neighbor(agent_no, neighbor_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_obstacle_neighbor(retptr, this.__wbg_ptr, agent_no, neighbor_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r2 = getFloat64Memory0()[retptr / 8 + 1];
            return r0 === 0 ? null : r2;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {any}
    */
    get_agent_position(agent_no) {
        const ret = wasm.rvosimulator_get_agent_position(this.__wbg_ptr, agent_no);
        return takeObject(ret);
    }
    /**
    * @param {number} agent_no
    * @returns {any}
    */
    get_agent_pref_velocity(agent_no) {
        const ret = wasm.rvosimulator_get_agent_pref_velocity(this.__wbg_ptr, agent_no);
        return takeObject(ret);
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_radius(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_radius(retptr, this.__wbg_ptr, agent_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getFloat32Memory0()[retptr / 4 + 1];
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_time_horizon(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_time_horizon(retptr, this.__wbg_ptr, agent_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getFloat32Memory0()[retptr / 4 + 1];
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_time_horizon_obst(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_time_horizon(retptr, this.__wbg_ptr, agent_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getFloat32Memory0()[retptr / 4 + 1];
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {any}
    */
    get_agent_velocity(agent_no) {
        const ret = wasm.rvosimulator_get_agent_velocity(this.__wbg_ptr, agent_no);
        return takeObject(ret);
    }
    /**
    * @returns {number}
    */
    get_global_time() {
        const ret = wasm.rvosimulator_get_global_time(this.__wbg_ptr);
        return ret;
    }
    /**
    * @returns {number}
    */
    get_num_agents() {
        const ret = wasm.rvosimulator_get_num_agents(this.__wbg_ptr);
        return ret >>> 0;
    }
    /**
    * @returns {number}
    */
    get_num_obstacle_vertices() {
        const ret = wasm.rvosimulator_get_num_obstacle_vertices(this.__wbg_ptr);
        return ret >>> 0;
    }
    /**
    * @param {number} vertex_no
    * @returns {any}
    */
    get_obstacle_vertex(vertex_no) {
        const ret = wasm.rvosimulator_get_obstacle_vertex(this.__wbg_ptr, vertex_no);
        return takeObject(ret);
    }
    /**
    * @param {number} vertex_no
    * @returns {number | undefined}
    */
    get_next_obstacle_vertex_no(vertex_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_next_obstacle_vertex_no(retptr, this.__wbg_ptr, vertex_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r2 = getFloat64Memory0()[retptr / 8 + 1];
            return r0 === 0 ? null : r2;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} vertex_no
    * @returns {number | undefined}
    */
    get_prev_obstacle_vertex_no(vertex_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_prev_obstacle_vertex_no(retptr, this.__wbg_ptr, vertex_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r2 = getFloat64Memory0()[retptr / 8 + 1];
            return r0 === 0 ? null : r2;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @returns {number}
    */
    get_time_step() {
        const ret = wasm.rvosimulator_get_time_step(this.__wbg_ptr);
        return ret;
    }
    /**
    * @param {number} agent_no
    * @param {number} max_neighbors
    * @returns {boolean}
    */
    set_agent_max_neighbors(agent_no, max_neighbors) {
        const ret = wasm.rvosimulator_set_agent_max_neighbors(this.__wbg_ptr, agent_no, max_neighbors);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} max_speed
    * @returns {boolean}
    */
    set_agent_max_speed(agent_no, max_speed) {
        const ret = wasm.rvosimulator_set_agent_max_speed(this.__wbg_ptr, agent_no, max_speed);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} neighbor_dist
    * @returns {boolean}
    */
    set_agent_neighbor_dist(agent_no, neighbor_dist) {
        const ret = wasm.rvosimulator_set_agent_neighbor_dist(this.__wbg_ptr, agent_no, neighbor_dist);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} position_x
    * @param {number} position_y
    * @returns {boolean}
    */
    set_agent_position(agent_no, position_x, position_y) {
        const ret = wasm.rvosimulator_set_agent_position(this.__wbg_ptr, agent_no, position_x, position_y);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} pref_velocity_x
    * @param {number} pref_velocity_y
    * @returns {boolean}
    */
    set_agent_pref_velocity(agent_no, pref_velocity_x, pref_velocity_y) {
        const ret = wasm.rvosimulator_set_agent_pref_velocity(this.__wbg_ptr, agent_no, pref_velocity_x, pref_velocity_y);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} radius
    * @returns {boolean}
    */
    set_agent_radius(agent_no, radius) {
        const ret = wasm.rvosimulator_set_agent_radius(this.__wbg_ptr, agent_no, radius);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} time_horizon
    * @returns {boolean}
    */
    set_agent_time_horizon(agent_no, time_horizon) {
        const ret = wasm.rvosimulator_set_agent_time_horizon(this.__wbg_ptr, agent_no, time_horizon);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} time_horizon_obst
    * @returns {boolean}
    */
    set_agent_time_horizon_obst(agent_no, time_horizon_obst) {
        const ret = wasm.rvosimulator_set_agent_time_horizon_obst(this.__wbg_ptr, agent_no, time_horizon_obst);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} velocity_x
    * @param {number} velocity_y
    * @returns {boolean}
    */
    set_agent_velocity(agent_no, velocity_x, velocity_y) {
        const ret = wasm.rvosimulator_set_agent_velocity(this.__wbg_ptr, agent_no, velocity_x, velocity_y);
        return ret !== 0;
    }
    /**
    * @param {number} time_step
    */
    set_time_step(time_step) {
        wasm.rvosimulator_set_time_step(this.__wbg_ptr, time_step);
    }
    /**
    *
    *     * @brief     为代理设置目标点。
    *     * @param[in] agent_no   代理id
    *     * @param[in] goal       目标点
    *     * @return 设置成功返回true，失败返回false。
    *
    * @param {number} agent_no
    * @param {number | undefined} [goal_x]
    * @param {number | undefined} [goal_y]
    * @returns {boolean}
    */
    set_agent_goal(agent_no, goal_x, goal_y) {
        const ret = wasm.rvosimulator_set_agent_goal(this.__wbg_ptr, agent_no, !isLikeNone(goal_x), isLikeNone(goal_x) ? 0 : goal_x, !isLikeNone(goal_y), isLikeNone(goal_y) ? 0 : goal_y);
        return ret !== 0;
    }
    /**
    *
    *     * @brief     为代理设置自定义速度。
    *     * @param[in] agent_no   代理id
    *     * @param[in] speed      速度，应该小于代理的最大速度，否则使用最大速度。
    *     * @return 设置成功返回true，失败返回false。
    *
    * @param {number} agent_no
    * @param {number} speed
    * @returns {boolean}
    */
    set_agent_custom_speed(agent_no, speed) {
        const ret = wasm.rvosimulator_set_agent_custom_speed(this.__wbg_ptr, agent_no, speed);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @returns {any}
    */
    get_agent_goal(agent_no) {
        const ret = wasm.rvosimulator_get_agent_goal(this.__wbg_ptr, agent_no);
        return takeObject(ret);
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_custom_speed(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_custom_speed(retptr, this.__wbg_ptr, agent_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getFloat32Memory0()[retptr / 4 + 1];
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} seed
    */
    set_rng_seed(seed) {
        wasm.rvosimulator_set_rng_seed(this.__wbg_ptr, seed);
    }
    /**
    * @param {number} agent_no
    * @param {number} line_no
    * @returns {any}
    */
    get_agent_orcaline(agent_no, line_no) {
        const ret = wasm.rvosimulator_get_agent_orcaline(this.__wbg_ptr, agent_no, line_no);
        return takeObject(ret);
    }
    /**
    * 设置代理的质量; 1.0为默认值, 必须大于0
    * @param {number} agent_no
    * @param {number} quality
    * @returns {boolean}
    */
    set_agent_quality(agent_no, quality) {
        const ret = wasm.rvosimulator_set_agent_quality(this.__wbg_ptr, agent_no, quality);
        return ret !== 0;
    }
    /**
    * 获取代理的质量
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_quality(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_quality(retptr, this.__wbg_ptr, agent_no);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r2 = getFloat64Memory0()[retptr / 8 + 1];
            return r0 === 0 ? null : r2;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
}

const ResAllocatorFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_resallocator_free(ptr >>> 0));
/**
* 资源管理器
*/
export class ResAllocator {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(ResAllocator.prototype);
        obj.__wbg_ptr = ptr;
        ResAllocatorFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ResAllocatorFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_resallocator_free(ptr);
    }
    /**
    * 创建资源管理器的实例
    * @param {number} total_capacity
    * @returns {ResAllocator}
    */
    static new(total_capacity) {
        const ret = wasm.resallocator_new(total_capacity);
        return ResAllocator.__wrap(ret);
    }
    /**
    * 整理方法， 将无人使用的资源放入到LruCache， 清理过时的资源
    * 就是LruMgr有总内存上限， 按权重分给其下的LRU。 如果有LRU有空闲， 则会减少其max_size, 按权重提高那些满的LRU的max_size
    */
    collect() {
        wasm.resallocator_collect(this.__wbg_ptr);
    }
    /**
    * 创建一个资源， 如果资源已经存在，则会修改资源的配置
    * @param {number} ty
    * @param {number} min_capacity
    * @param {number} weight
    * @param {number} time_out
    * @returns {ResMgr}
    */
    register_to_resmgr(ty, min_capacity, weight, time_out) {
        const ret = wasm.resallocator_register_to_resmgr(this.__wbg_ptr, ty, min_capacity, weight, time_out);
        return ResMgr.__wrap(ret);
    }
    /**
    * @returns {number}
    */
    size() {
        const ret = wasm.resallocator_size(this.__wbg_ptr);
        return ret;
    }
    /**
    * @returns {string}
    */
    account_details() {
        let deferred1_0;
        let deferred1_1;
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.resallocator_account_details(retptr, this.__wbg_ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            deferred1_0 = r0;
            deferred1_1 = r1;
            return getStringFromWasm0(r0, r1);
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
            wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
        }
    }
}

const ResHandleFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_reshandle_free(ptr >>> 0));
/**
*/
export class ResHandle {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(ResHandle.prototype);
        obj.__wbg_ptr = ptr;
        ResHandleFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ResHandleFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_reshandle_free(ptr);
    }
}

const ResMgrFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_resmgr_free(ptr >>> 0));
/**
* 资源管理器
*/
export class ResMgr {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(ResMgr.prototype);
        obj.__wbg_ptr = ptr;
        ResMgrFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ResMgrFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_resmgr_free(ptr);
    }
    /**
    * 创建一个资源， 如果资源已经存在，旧的资源将被覆盖
    * 如果创建的资源类型未注册，将崩溃
    * @param {number} key
    * @param {number} cost
    * @returns {ResRef}
    */
    create_res(key, cost) {
        const ret = wasm.resmgr_create_res(this.__wbg_ptr, key, cost);
        return ResRef.__wrap(ret);
    }
    /**
    * 获取资源
    * @param {number} key
    * @returns {ResRef | undefined}
    */
    get_res(key) {
        const ret = wasm.resmgr_get_res(this.__wbg_ptr, key);
        return ret === 0 ? null : ResRef.__wrap(ret);
    }
}

const ResRefFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_resref_free(ptr >>> 0));
/**
* 资源包装
*/
export class ResRef {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(ResRef.prototype);
        obj.__wbg_ptr = ptr;
        ResRefFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ResRefFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_resref_free(ptr);
    }
}

const ResTextureFrameAtlasFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_restextureframeatlas_free(ptr >>> 0));
/**
*/
export class ResTextureFrameAtlas {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(ResTextureFrameAtlas.prototype);
        obj.__wbg_ptr = ptr;
        ResTextureFrameAtlasFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ResTextureFrameAtlasFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_restextureframeatlas_free(ptr);
    }
}

const SpineTextureLoadRecordFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_spinetextureloadrecord_free(ptr >>> 0));
/**
*/
export class SpineTextureLoadRecord {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(SpineTextureLoadRecord.prototype);
        obj.__wbg_ptr = ptr;
        SpineTextureLoadRecordFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        SpineTextureLoadRecordFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_spinetextureloadrecord_free(ptr);
    }
    /**
    * @returns {SpineTextureLoadRecord}
    */
    static new() {
        const ret = wasm.spinetextureloadrecord_new();
        return SpineTextureLoadRecord.__wrap(ret);
    }
    /**
    * @param {Atom} key
    * @returns {TextureDefaultView | undefined}
    */
    success(key) {
        _assertClass(key, Atom);
        const ret = wasm.spinetextureloadrecord_success(this.__wbg_ptr, key.__wbg_ptr);
        return ret === 0 ? null : TextureDefaultView.__wrap(ret);
    }
    /**
    * @param {Atom} key
    * @returns {string | undefined}
    */
    fail(key) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            _assertClass(key, Atom);
            wasm.spinetextureloadrecord_fail(retptr, this.__wbg_ptr, key.__wbg_ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            let v1;
            if (r0 !== 0) {
                v1 = getStringFromWasm0(r0, r1).slice();
                wasm.__wbindgen_free(r0, r1 * 1, 1);
            }
            return v1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    */
    clear() {
        wasm.spinetextureloadrecord_clear(this.__wbg_ptr);
    }
}

const TabBufferFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_tabbuffer_free(ptr >>> 0));
/**
*/
export class TabBuffer {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(TabBuffer.prototype);
        obj.__wbg_ptr = ptr;
        TabBufferFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        TabBufferFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_tabbuffer_free(ptr);
    }
    /**
    * @returns {boolean}
    */
    next() {
        const ret = wasm.tabbuffer_next(this.__wbg_ptr);
        return ret !== 0;
    }
    /**
    * @returns {boolean}
    */
    next_tab() {
        const ret = wasm.tabbuffer_next_tab(this.__wbg_ptr);
        return ret !== 0;
    }
}

const TextureDefaultViewFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_texturedefaultview_free(ptr >>> 0));
/**
*/
export class TextureDefaultView {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(TextureDefaultView.prototype);
        obj.__wbg_ptr = ptr;
        TextureDefaultViewFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        TextureDefaultViewFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_texturedefaultview_free(ptr);
    }
}

const TileMapFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_tilemap_free(ptr >>> 0));
/**
*/
export class TileMap {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(TileMap.prototype);
        obj.__wbg_ptr = ptr;
        TileMapFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        TileMapFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_tilemap_free(ptr);
    }
    /**
    * @param {number} width
    * @param {number} height
    * @returns {TileMap}
    */
    static new(width, height) {
        const ret = wasm.tilemap_new(width, height);
        return TileMap.__wrap(ret);
    }
    /**
    * @param {number} index
    * @param {TileFlagType} flag_type
    * @param {number} value
    * @returns {number}
    */
    set_node_flag(index, flag_type, value) {
        const ret = wasm.tilemap_set_node_flag(this.__wbg_ptr, index, flag_type, value);
        return ret;
    }
    /**
    * @param {number} index
    * @param {TileFlagType} flag_type
    * @returns {number}
    */
    get_node_flag(index, flag_type) {
        const ret = wasm.tilemap_get_node_flag(this.__wbg_ptr, index, flag_type);
        return ret;
    }
    /**
    * @param {number} x1
    * @param {number} y1
    * @param {number} x2
    * @param {number} y2
    * @param {number} value
    */
    set_range_flag(x1, y1, x2, y2, value) {
        wasm.tilemap_set_range_flag(this.__wbg_ptr, x1, y1, x2, y2, value);
    }
    /**
    * @param {number} index
    * @param {number} count
    * @param {number} spacing
    * @param {Direction} d
    * @param {number} flag
    * @returns {any}
    */
    find_round(index, count, spacing, d, flag) {
        const ret = wasm.tilemap_find_round(this.__wbg_ptr, index, count, spacing, d, flag);
        return takeObject(ret);
    }
    /**
    * @param {number} index
    * @param {number} count
    * @param {number} spacing
    * @param {Direction} d
    * @param {number} flag
    * @param {number} target_x
    * @param {number} target_y
    * @returns {any}
    */
    find_round_and_sort_by_dist(index, count, spacing, d, flag, target_x, target_y) {
        const ret = wasm.tilemap_find_round_and_sort_by_dist(this.__wbg_ptr, index, count, spacing, d, flag, target_x, target_y);
        return takeObject(ret);
    }
    /**
    * @param {number} start_x
    * @param {number} start_y
    * @param {number} end_x
    * @param {number} end_y
    * @param {number} center_flag
    * @param {number} side_flag
    * @returns {any}
    */
    test_line(start_x, start_y, end_x, end_y, center_flag, side_flag) {
        const ret = wasm.tilemap_test_line(this.__wbg_ptr, start_x, start_y, end_x, end_y, center_flag, side_flag);
        return takeObject(ret);
    }
}

const TileMapTreeFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_tilemaptree_free(ptr >>> 0));
/**
*/
export class TileMapTree {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(TileMapTree.prototype);
        obj.__wbg_ptr = ptr;
        TileMapTreeFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        TileMapTreeFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_tilemaptree_free(ptr);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @param {number} width
    * @param {number} height
    * @returns {TileMapTree}
    */
    static new(min_x, min_y, max_x, max_y, width, height) {
        const ret = wasm.tilemaptree_new(min_x, min_y, max_x, max_y, width, height);
        return TileMapTree.__wrap(ret);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @returns {number}
    */
    add(min_x, min_y, max_x, max_y) {
        const ret = wasm.tilemaptree_add(this.__wbg_ptr, min_x, min_y, max_x, max_y);
        return ret;
    }
    /**
    * @param {number} id
    */
    remove(id) {
        wasm.tilemaptree_remove(this.__wbg_ptr, id);
    }
    /**
    * @param {number} id
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    */
    update(id, min_x, min_y, max_x, max_y) {
        wasm.tilemaptree_update(this.__wbg_ptr, id, min_x, min_y, max_x, max_y);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @returns {Uint32Array}
    */
    query(min_x, min_y, max_x, max_y) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.tilemaptree_query(retptr, this.__wbg_ptr, min_x, min_y, max_x, max_y);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            var v1 = getArrayU32FromWasm0(r0, r1).slice();
            wasm.__wbindgen_free(r0, r1 * 4, 4);
            return v1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
}

const VBMetaFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_vbmeta_free(ptr >>> 0));
/**
*/
export class VBMeta {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(VBMeta.prototype);
        obj.__wbg_ptr = ptr;
        VBMetaFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        VBMetaFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_vbmeta_free(ptr);
    }
    /**
    * @param {string} name
    * @param {number | undefined} [start]
    * @param {number | undefined} [end]
    * @returns {VBMeta}
    */
    static create(name, start, end) {
        const ptr0 = passStringToWasm0(name, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.vbmeta_create(ptr0, len0, !isLikeNone(start), isLikeNone(start) ? 0 : start, !isLikeNone(end), isLikeNone(end) ? 0 : end);
        return VBMeta.__wrap(ret);
    }
}

const VInstanceAttributesFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_vinstanceattributes_free(ptr >>> 0));
/**
*/
export class VInstanceAttributes {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(VInstanceAttributes.prototype);
        obj.__wbg_ptr = ptr;
        VInstanceAttributesFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        VInstanceAttributesFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_vinstanceattributes_free(ptr);
    }
    /**
    * @param {boolean} instane_matrix
    * @returns {VInstanceAttributes}
    */
    static create(instane_matrix) {
        const ret = wasm.vinstanceattributes_create(instane_matrix);
        return VInstanceAttributes.__wrap(ret);
    }
}

const VertexBufferResFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_vertexbufferres_free(ptr >>> 0));
/**
*/
export class VertexBufferRes {

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        VertexBufferResFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_vertexbufferres_free(ptr);
    }
}

async function __wbg_load(module, imports) {
    if (typeof Response === 'function' && module instanceof Response) {
        if (typeof WebAssembly.instantiateStreaming === 'function') {
            try {
                return await WebAssembly.instantiateStreaming(module, imports);

            } catch (e) {
                if (module.headers.get('Content-Type') != 'application/wasm') {
                    console.warn("`WebAssembly.instantiateStreaming` failed because your server does not serve wasm with `application/wasm` MIME type. Falling back to `WebAssembly.instantiate` which is slower. Original error:\n", e);

                } else {
                    throw e;
                }
            }
        }

        const bytes = await module.arrayBuffer();
        return await WebAssembly.instantiate(bytes, imports);

    } else {
        const instance = await WebAssembly.instantiate(module, imports);

        if (instance instanceof WebAssembly.Instance) {
            return { instance, module };

        } else {
            return instance;
        }
    }
}

function __wbg_get_imports() {
    const imports = {};
    imports.wbg = {};
    imports.wbg.__wbindgen_number_new = function(arg0) {
        const ret = arg0;
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_number_get = function(arg0, arg1) {
        const obj = getObject(arg1);
        const ret = typeof(obj) === 'number' ? obj : undefined;
        getFloat64Memory0()[arg0 / 8 + 1] = isLikeNone(ret) ? 0 : ret;
        getInt32Memory0()[arg0 / 4 + 0] = !isLikeNone(ret);
    };
    imports.wbg.__wbindgen_object_drop_ref = function(arg0) {
        takeObject(arg0);
    };
    imports.wbg.__wbindgen_debug_string = function(arg0, arg1) {
        const ret = debugString(getObject(arg1));
        const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        getInt32Memory0()[arg0 / 4 + 1] = len1;
        getInt32Memory0()[arg0 / 4 + 0] = ptr1;
    };
    imports.wbg.__wbindgen_throw = function(arg0, arg1) {
		let str = getStringFromWasm0(arg0, arg1);
		window._$pi?._wasmThrow?.(str);
        throw new Error(str);
    };
    imports.wbg.__wbindgen_memory = function() {
        const ret = wasm.memory;
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_string_new = function(arg0, arg1) {
        const ret = getStringFromWasm0(arg0, arg1);
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_string_get = function(arg0, arg1) {
        const obj = getObject(arg1);
        const ret = typeof(obj) === 'string' ? obj : undefined;
        var ptr1 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len1 = WASM_VECTOR_LEN;
        getInt32Memory0()[arg0 / 4 + 1] = len1;
        getInt32Memory0()[arg0 / 4 + 0] = ptr1;
    };
    imports.wbg.__wbg_get_bd8e338fbd5f5cc8 = function(arg0, arg1) {
        const ret = getObject(arg0)[arg1 >>> 0];
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_length_cd7af8117672b8b8 = function(arg0) {
        const ret = getObject(arg0).length;
        return ret;
    };
    imports.wbg.__wbg_new_16b304a2cfa7ff4a = function() {
        const ret = new Array();
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_is_function = function(arg0) {
        const ret = typeof(getObject(arg0)) === 'function';
        return ret;
    };
    imports.wbg.__wbg_newnoargs_e258087cd0daa0ea = function(arg0, arg1) {
        const ret = new Function(getStringFromWasm0(arg0, arg1));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_new_d9bc3a0147634640 = function() {
        const ret = new Map();
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_is_object = function(arg0) {
        const val = getObject(arg0);
        const ret = typeof(val) === 'object' && val !== null;
        return ret;
    };
    imports.wbg.__wbg_get_e3c254076557e348 = function() { return handleError(function (arg0, arg1) {
        const ret = Reflect.get(getObject(arg0), getObject(arg1));
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_call_27c0f87801dedf93 = function() { return handleError(function (arg0, arg1) {
        const ret = getObject(arg0).call(getObject(arg1));
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_new_72fb9a18b5ae2624 = function() {
        const ret = new Object();
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_new_32f8dd294d1394fd = function(arg0) {
        const ret = new Set(getObject(arg0));
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_is_string = function(arg0) {
        const ret = typeof(getObject(arg0)) === 'string';
        return ret;
    };
    imports.wbg.__wbindgen_object_clone_ref = function(arg0) {
        const ret = getObject(arg0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_set_d4638f722068f043 = function(arg0, arg1, arg2) {
        getObject(arg0)[arg1 >>> 0] = takeObject(arg2);
    };
    imports.wbg.__wbg_push_a5b05aedc7234f9f = function(arg0, arg1) {
        const ret = getObject(arg0).push(getObject(arg1));
        return ret;
    };
    imports.wbg.__wbg_call_b3ca7c6051f9bec1 = function() { return handleError(function (arg0, arg1, arg2) {
        const ret = getObject(arg0).call(getObject(arg1), getObject(arg2));
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_set_8417257aaedc936b = function(arg0, arg1, arg2) {
        const ret = getObject(arg0).set(getObject(arg1), getObject(arg2));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_is_010fdc0f4ab96916 = function(arg0, arg1) {
        const ret = Object.is(getObject(arg0), getObject(arg1));
        return ret;
    };
    imports.wbg.__wbg_add_9124415f4aba6d98 = function(arg0, arg1) {
        const ret = getObject(arg0).add(getObject(arg1));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_buffer_12d079cc21e14bdb = function(arg0) {
        const ret = getObject(arg0).buffer;
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_then_a73caa9a87991566 = function(arg0, arg1, arg2) {
        const ret = getObject(arg0).then(getObject(arg1), getObject(arg2));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_self_ce0dbfc45cf2f5be = function() { return handleError(function () {
        const ret = self.self;
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_window_c6fb939a7f436783 = function() { return handleError(function () {
        const ret = window.window;
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_globalThis_d1e6af4856ba331b = function() { return handleError(function () {
        const ret = globalThis.globalThis;
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_global_207b558942527489 = function() { return handleError(function () {
        const ret = global.global;
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbindgen_is_undefined = function(arg0) {
        const ret = getObject(arg0) === undefined;
        return ret;
    };
    imports.wbg.__wbg_newwithbyteoffsetandlength_41559f654c4e743c = function(arg0, arg1, arg2) {
        const ret = new Int8Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_newwithbyteoffsetandlength_4bea9f904a7e0aef = function(arg0, arg1, arg2) {
        const ret = new Int16Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_newwithbyteoffsetandlength_425360430a1c8206 = function(arg0, arg1, arg2) {
        const ret = new Int32Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_newwithbyteoffsetandlength_aa4a17c33a06e5cb = function(arg0, arg1, arg2) {
        const ret = new Uint8Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_new_63b92bc8671ed464 = function(arg0) {
        const ret = new Uint8Array(getObject(arg0));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_set_a47bac70306a19a7 = function(arg0, arg1, arg2) {
        getObject(arg0).set(getObject(arg1), arg2 >>> 0);
    };
    imports.wbg.__wbg_length_c20a40f15020d68a = function(arg0) {
        const ret = getObject(arg0).length;
        return ret;
    };
    imports.wbg.__wbg_newwithbyteoffsetandlength_9fd64654bc0b0817 = function(arg0, arg1, arg2) {
        const ret = new Uint16Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_new_d300acbe953d12e8 = function(arg0) {
        const ret = new Uint16Array(getObject(arg0));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_set_d8983c5c08eb8338 = function(arg0, arg1, arg2) {
        getObject(arg0).set(getObject(arg1), arg2 >>> 0);
    };
    imports.wbg.__wbg_length_7cf3a99cadacb5b8 = function(arg0) {
        const ret = getObject(arg0).length;
        return ret;
    };
    imports.wbg.__wbg_newwithbyteoffsetandlength_3125852e5a7fbcff = function(arg0, arg1, arg2) {
        const ret = new Uint32Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_newwithbyteoffsetandlength_4a659d079a1650e0 = function(arg0, arg1, arg2) {
        const ret = new Float32Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_new_9efabd6b6d2ce46d = function(arg0) {
        const ret = new Float32Array(getObject(arg0));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_set_bd975934d1b1fddb = function(arg0, arg1, arg2) {
        getObject(arg0).set(getObject(arg1), arg2 >>> 0);
    };
    imports.wbg.__wbg_length_d25bbcbc3367f684 = function(arg0) {
        const ret = getObject(arg0).length;
        return ret;
    };
    imports.wbg.__wbg_newwithlength_e9b4878cebadb3d3 = function(arg0) {
        const ret = new Uint8Array(arg0 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_subarray_a1f73cd4b5b42fe1 = function(arg0, arg1, arg2) {
        const ret = getObject(arg0).subarray(arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_byteLength_58f7b4fab1919d44 = function(arg0) {
        const ret = getObject(arg0).byteLength;
        return ret;
    };
    imports.wbg.__wbg_getindex_289b14432d9c89b9 = function(arg0, arg1) {
        const ret = getObject(arg0)[arg1 >>> 0];
        return ret;
    };
    imports.wbg.__wbg_setindex_89aa1edc4895386e = function(arg0, arg1, arg2) {
        getObject(arg0)[arg1 >>> 0] = arg2;
    };
    imports.wbg.__wbg_instanceof_Window_99dc9805eaa2614b = function(arg0) {
        let result;
        try {
            result = true;
        } catch (_) {
            result = false;
        }
        const ret = result;
        return ret;
    };
    imports.wbg.__wbg_drawArraysInstancedANGLE_4ba856b2c59d84b8 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).drawArraysInstancedANGLE(arg1 >>> 0, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_drawElementsInstancedANGLE_fdf5cd2eb03dd141 = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        getObject(arg0).drawElementsInstancedANGLE(arg1 >>> 0, arg2, arg3 >>> 0, arg4, arg5);
    };
    imports.wbg.__wbg_vertexAttribDivisorANGLE_51dd5c906f4912a2 = function(arg0, arg1, arg2) {
        getObject(arg0).vertexAttribDivisorANGLE(arg1 >>> 0, arg2 >>> 0);
    };
    imports.wbg.__wbg_instanceof_CanvasRenderingContext2d_17760092d89f8894 = function(arg0) {
        let result;
        try {
            result = true;
        } catch (_) {
            result = false;
        }
        const ret = result;
        return ret;
    };
    imports.wbg.__wbg_canvas_07fefd7a49309c28 = function(arg0) {
        const ret = getObject(arg0).canvas;
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_getImageData_23ae615d32adfe2f = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4) {
        const ret = getObject(arg0).getImageData(arg1, arg2, arg3, arg4);
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_fullscreenElement_8ebe202aecd8ae3c = function(arg0) {
        const ret = getObject(arg0).fullscreenElement;
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createElement_1a136faad4101f43 = function() { return handleError(function (arg0, arg1, arg2) {
        const ret = getObject(arg0).createElement(getStringFromWasm0(arg1, arg2));
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_querySelectorAll_33a699392b92fa52 = function() { return handleError(function (arg0, arg1, arg2) {
        const ret = getObject(arg0).querySelectorAll(getStringFromWasm0(arg1, arg2));
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_requestFullscreen_86cc33835b4db656 = function() { return handleError(function (arg0) {
        getObject(arg0).requestFullscreen();
    }, arguments) };
    imports.wbg.__wbg_setAttribute_0918ea45d5a1c663 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).setAttribute(getStringFromWasm0(arg1, arg2), getStringFromWasm0(arg3, arg4));
    }, arguments) };
    imports.wbg.__wbg_cancelBubble_191799b8e0ab3254 = function(arg0) {
        const ret = getObject(arg0).cancelBubble;
        return ret;
    };
    imports.wbg.__wbg_preventDefault_d2c7416966cb0632 = function(arg0) {
        getObject(arg0).preventDefault();
    };
    imports.wbg.__wbg_stopPropagation_786ab850031995e5 = function(arg0) {
        getObject(arg0).stopPropagation();
    };
    imports.wbg.__wbg_addEventListener_2f891d22985fd3c8 = function() { return handleError(function (arg0, arg1, arg2, arg3) {
        getObject(arg0).addEventListener(getStringFromWasm0(arg1, arg2), getObject(arg3));
    }, arguments) };
    imports.wbg.__wbg_removeEventListener_07715e6f464823fc = function() { return handleError(function (arg0, arg1, arg2, arg3) {
        getObject(arg0).removeEventListener(getStringFromWasm0(arg1, arg2), getObject(arg3));
    }, arguments) };
    imports.wbg.__wbg_instanceof_HtmlCanvasElement_a6076360513b6876 = function(arg0) {
        let result;
        try {
            result = true;
        } catch (_) {
            result = false;
        }
        const ret = result;
        return ret;
    };
    imports.wbg.__wbg_width_9d9d26b087c6ad54 = function(arg0) {
        const ret = getObject(arg0).width;
        return ret;
    };
    imports.wbg.__wbg_height_770da314320603d8 = function(arg0) {
        const ret = getObject(arg0).height;
        return ret;
    };
    imports.wbg.__wbg_getContext_39cdfeffd658feb7 = function() { return handleError(function (arg0, arg1, arg2) {
        const ret = getObject(arg0).getContext(getStringFromWasm0(arg1, arg2));
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_width_32b454baf9a07e6c = function(arg0) {
        const ret = getObject(arg0).width;
        return ret;
    };
    imports.wbg.__wbg_height_7d920b5b76731ded = function(arg0) {
        const ret = getObject(arg0).height;
        return ret;
    };
    imports.wbg.__wbg_width_d55eb8e2dab91e33 = function(arg0) {
        const ret = getObject(arg0).width;
        return ret;
    };
    imports.wbg.__wbg_height_dbe5bb465a03a4f0 = function(arg0) {
        const ret = getObject(arg0).height;
        return ret;
    };
    imports.wbg.__wbg_data_a1416834d6367ac7 = function(arg0, arg1) {
        const ret = getObject(arg1).data;
        const ptr1 = passArray8ToWasm0(ret, wasm.__wbindgen_malloc);
        const len1 = WASM_VECTOR_LEN;
        getInt32Memory0()[arg0 / 4 + 1] = len1;
        getInt32Memory0()[arg0 / 4 + 0] = ptr1;
    };
    imports.wbg.__wbg_key_9a2550983fbad1d0 = function(arg0, arg1) {
        const ret = getObject(arg1).key;
        const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        getInt32Memory0()[arg0 / 4 + 1] = len1;
        getInt32Memory0()[arg0 / 4 + 0] = ptr1;
    };
    imports.wbg.__wbg_removeListener_b8fc928c2300e3c6 = function() { return handleError(function (arg0, arg1) {
        getObject(arg0).removeListener(getObject(arg1));
    }, arguments) };
    imports.wbg.__wbg_userAgent_4106f80b9924b065 = function() { return handleError(function (arg0, arg1) {
        const ret = getObject(arg1).userAgent;
        const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        getInt32Memory0()[arg0 / 4 + 1] = len1;
        getInt32Memory0()[arg0 / 4 + 0] = ptr1;
    }, arguments) };
    imports.wbg.__wbg_get_de3ed10a49ff9959 = function(arg0, arg1) {
        const ret = getObject(arg0)[arg1 >>> 0];
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_bindVertexArrayOES_e95cf32f50e47240 = function(arg0, arg1) {
        getObject(arg0).bindVertexArrayOES(getObject(arg1));
    };
    imports.wbg.__wbg_createVertexArrayOES_96ccfea00081dcf3 = function(arg0) {
        const ret = getObject(arg0).createVertexArrayOES();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_deleteVertexArrayOES_657b2572282b9dff = function(arg0, arg1) {
        getObject(arg0).deleteVertexArrayOES(getObject(arg1));
    };
    imports.wbg.__wbg_now_65ff8ec2b863300c = function(arg0) {
        const ret = getObject(arg0).now();
        return ret;
    };
    imports.wbg.__wbg_bindBufferBase_16d029d5da985b4b = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).bindBufferBase(arg1 >>> 0, arg2 >>> 0, getObject(arg3));
    };
    imports.wbg.__wbg_bindBufferRange_bfdd227c2d5515af = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        getObject(arg0).bindBufferRange(arg1 >>> 0, arg2 >>> 0, getObject(arg3), arg4, arg5);
    };
    imports.wbg.__wbg_bindSampler_12a1965a2db071ed = function(arg0, arg1, arg2) {
        getObject(arg0).bindSampler(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_bindVertexArray_2a70aed123353597 = function(arg0, arg1) {
        getObject(arg0).bindVertexArray(getObject(arg1));
    };
    imports.wbg.__wbg_bufferData_6c5edae24f952d4d = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).bufferData(arg1 >>> 0, arg2, arg3 >>> 0);
    };
    imports.wbg.__wbg_bufferSubData_3b75566851019327 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).bufferSubData(arg1 >>> 0, arg2, getObject(arg3));
    };
    imports.wbg.__wbg_compressedTexSubImage2D_1194f18adf8859b9 = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) {
        getObject(arg0).compressedTexSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8, arg9);
    };
    imports.wbg.__wbg_compressedTexSubImage2D_41270fc03b157293 = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8) {
        getObject(arg0).compressedTexSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, getObject(arg8));
    };
    imports.wbg.__wbg_compressedTexSubImage3D_34cd53cffc6add9c = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11) {
        getObject(arg0).compressedTexSubImage3D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 >>> 0, arg10, arg11);
    };
    imports.wbg.__wbg_compressedTexSubImage3D_f0da020d6e3e3791 = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10) {
        getObject(arg0).compressedTexSubImage3D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 >>> 0, getObject(arg10));
    };
    imports.wbg.__wbg_createSampler_e2bcf2bc717a1cad = function(arg0) {
        const ret = getObject(arg0).createSampler();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createVertexArray_761ba22fc5da3ad7 = function(arg0) {
        const ret = getObject(arg0).createVertexArray();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_deleteSampler_f760c2bdc7a3d881 = function(arg0, arg1) {
        getObject(arg0).deleteSampler(getObject(arg1));
    };
    imports.wbg.__wbg_deleteVertexArray_26631f33de66bdfd = function(arg0, arg1) {
        getObject(arg0).deleteVertexArray(getObject(arg1));
    };
    imports.wbg.__wbg_drawArraysInstanced_b0963fae97f2f14e = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).drawArraysInstanced(arg1 >>> 0, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_drawElementsInstanced_19c02c2c6c7ebdd5 = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        getObject(arg0).drawElementsInstanced(arg1 >>> 0, arg2, arg3 >>> 0, arg4, arg5);
    };
    imports.wbg.__wbg_getUniformBlockIndex_b9628e75250e866c = function(arg0, arg1, arg2, arg3) {
        const ret = getObject(arg0).getUniformBlockIndex(getObject(arg1), getStringFromWasm0(arg2, arg3));
        return ret;
    };
    imports.wbg.__wbg_renderbufferStorageMultisample_c5f884a4faf6330a = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        getObject(arg0).renderbufferStorageMultisample(arg1 >>> 0, arg2, arg3 >>> 0, arg4, arg5);
    };
    imports.wbg.__wbg_samplerParameterf_a15f79d315dcfc5d = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).samplerParameterf(getObject(arg1), arg2 >>> 0, arg3);
    };
    imports.wbg.__wbg_samplerParameteri_6f5c08b9c98433e9 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).samplerParameteri(getObject(arg1), arg2 >>> 0, arg3);
    };
    imports.wbg.__wbg_texStorage2D_b46c4dcaa6dc9638 = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        getObject(arg0).texStorage2D(arg1 >>> 0, arg2, arg3 >>> 0, arg4, arg5);
    };
    imports.wbg.__wbg_texStorage3D_521eded8d8da33a6 = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6) {
        getObject(arg0).texStorage3D(arg1 >>> 0, arg2, arg3 >>> 0, arg4, arg5, arg6);
    };
    imports.wbg.__wbg_texSubImage2D_33018bcf2de70890 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) {
        getObject(arg0).texSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8 >>> 0, getObject(arg9));
    }, arguments) };
    imports.wbg.__wbg_texSubImage2D_b97aa5ddc0162314 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) {
        getObject(arg0).texSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8 >>> 0, arg9);
    }, arguments) };
    imports.wbg.__wbg_texSubImage2D_cbc346dc5a210f5d = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) {
        getObject(arg0).texSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8 >>> 0, getObject(arg9));
    }, arguments) };
    imports.wbg.__wbg_texSubImage2D_8a9badf4e9c5ef83 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) {
        getObject(arg0).texSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8 >>> 0, getObject(arg9));
    }, arguments) };
    imports.wbg.__wbg_texSubImage2D_ad0af504139d876c = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) {
        getObject(arg0).texSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8 >>> 0, getObject(arg9));
    }, arguments) };
    imports.wbg.__wbg_texSubImage2D_4d372d780fc0e4a7 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) {
        getObject(arg0).texSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8 >>> 0, getObject(arg9));
    }, arguments) };
    imports.wbg.__wbg_texSubImage3D_5884c8e282839ff9 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11) {
        getObject(arg0).texSubImage3D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 >>> 0, arg10 >>> 0, arg11);
    }, arguments) };
    imports.wbg.__wbg_texSubImage3D_d98b6d6d4c3f3d01 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11) {
        getObject(arg0).texSubImage3D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 >>> 0, arg10 >>> 0, getObject(arg11));
    }, arguments) };
    imports.wbg.__wbg_texSubImage3D_a8f081c484f78039 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11) {
        getObject(arg0).texSubImage3D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 >>> 0, arg10 >>> 0, getObject(arg11));
    }, arguments) };
    imports.wbg.__wbg_texSubImage3D_e36d3c30ac0d0749 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11) {
        getObject(arg0).texSubImage3D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 >>> 0, arg10 >>> 0, getObject(arg11));
    }, arguments) };
    imports.wbg.__wbg_texSubImage3D_2742ec6099cae3fc = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11) {
        getObject(arg0).texSubImage3D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 >>> 0, arg10 >>> 0, getObject(arg11));
    }, arguments) };
    imports.wbg.__wbg_uniformBlockBinding_bcbb7fbc2fe88b8d = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).uniformBlockBinding(getObject(arg1), arg2 >>> 0, arg3 >>> 0);
    };
    imports.wbg.__wbg_vertexAttribDivisor_aad38a21841ace46 = function(arg0, arg1, arg2) {
        getObject(arg0).vertexAttribDivisor(arg1 >>> 0, arg2 >>> 0);
    };
    imports.wbg.__wbg_vertexAttribIPointer_24c9254053dd8ab4 = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        getObject(arg0).vertexAttribIPointer(arg1 >>> 0, arg2, arg3 >>> 0, arg4, arg5);
    };
    imports.wbg.__wbg_activeTexture_02d56293bce2f613 = function(arg0, arg1) {
        getObject(arg0).activeTexture(arg1 >>> 0);
    };
    imports.wbg.__wbg_attachShader_70c3f88b777a0a54 = function(arg0, arg1, arg2) {
        getObject(arg0).attachShader(getObject(arg1), getObject(arg2));
    };
    imports.wbg.__wbg_bindBuffer_ac939bcab5249160 = function(arg0, arg1, arg2) {
        getObject(arg0).bindBuffer(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_bindFramebuffer_0b8b88d70f0b876e = function(arg0, arg1, arg2) {
        getObject(arg0).bindFramebuffer(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_bindRenderbuffer_f06f73fc0b43967e = function(arg0, arg1, arg2) {
        getObject(arg0).bindRenderbuffer(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_bindTexture_e28115f3ea3da6d2 = function(arg0, arg1, arg2) {
        getObject(arg0).bindTexture(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_blendEquationSeparate_457e81472270e23c = function(arg0, arg1, arg2) {
        getObject(arg0).blendEquationSeparate(arg1 >>> 0, arg2 >>> 0);
    };
    imports.wbg.__wbg_blendFuncSeparate_b6a96b8e26e75171 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).blendFuncSeparate(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, arg4 >>> 0);
    };
    imports.wbg.__wbg_checkFramebufferStatus_e090c0c4dade21fe = function(arg0, arg1) {
        const ret = getObject(arg0).checkFramebufferStatus(arg1 >>> 0);
        return ret;
    };
    imports.wbg.__wbg_clear_40335e7899ec7759 = function(arg0, arg1) {
        getObject(arg0).clear(arg1 >>> 0);
    };
    imports.wbg.__wbg_clearColor_b48ee3ca810de959 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).clearColor(arg1, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_clearDepth_3777869cc4be970c = function(arg0, arg1) {
        getObject(arg0).clearDepth(arg1);
    };
    imports.wbg.__wbg_clearStencil_49cd65640cc9d1d9 = function(arg0, arg1) {
        getObject(arg0).clearStencil(arg1);
    };
    imports.wbg.__wbg_colorMask_743f2bbb6e3fb4e5 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).colorMask(arg1 !== 0, arg2 !== 0, arg3 !== 0, arg4 !== 0);
    };
    imports.wbg.__wbg_compileShader_bdfb3d5a3ad59498 = function(arg0, arg1) {
        getObject(arg0).compileShader(getObject(arg1));
    };
    imports.wbg.__wbg_createBuffer_a95c59cc2c1750e7 = function(arg0) {
        const ret = getObject(arg0).createBuffer();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createFramebuffer_52e5d7327d5afba3 = function(arg0) {
        const ret = getObject(arg0).createFramebuffer();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createProgram_0a7670ed33f06d97 = function(arg0) {
        const ret = getObject(arg0).createProgram();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createRenderbuffer_881be806709189a9 = function(arg0) {
        const ret = getObject(arg0).createRenderbuffer();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createShader_119ffcdb1667f405 = function(arg0, arg1) {
        const ret = getObject(arg0).createShader(arg1 >>> 0);
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createTexture_4f0c3c77df4bde11 = function(arg0) {
        const ret = getObject(arg0).createTexture();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_cullFace_68b06ff8967b93f3 = function(arg0, arg1) {
        getObject(arg0).cullFace(arg1 >>> 0);
    };
    imports.wbg.__wbg_deleteBuffer_b8aaa61f9bb13617 = function(arg0, arg1) {
        getObject(arg0).deleteBuffer(getObject(arg1));
    };
    imports.wbg.__wbg_deleteFramebuffer_d6907809466bdbdb = function(arg0, arg1) {
        getObject(arg0).deleteFramebuffer(getObject(arg1));
    };
    imports.wbg.__wbg_deleteProgram_d90e44574acb8018 = function(arg0, arg1) {
        getObject(arg0).deleteProgram(getObject(arg1));
    };
    imports.wbg.__wbg_deleteRenderbuffer_1c4b186beb91d4a5 = function(arg0, arg1) {
        getObject(arg0).deleteRenderbuffer(getObject(arg1));
    };
    imports.wbg.__wbg_deleteShader_5ec1e25476df2da0 = function(arg0, arg1) {
        getObject(arg0).deleteShader(getObject(arg1));
    };
    imports.wbg.__wbg_deleteTexture_554c30847d340929 = function(arg0, arg1) {
        getObject(arg0).deleteTexture(getObject(arg1));
    };
    imports.wbg.__wbg_depthFunc_e49f522acf6c6c2d = function(arg0, arg1) {
        getObject(arg0).depthFunc(arg1 >>> 0);
    };
    imports.wbg.__wbg_depthMask_052a5e3afe45b590 = function(arg0, arg1) {
        getObject(arg0).depthMask(arg1 !== 0);
    };
    imports.wbg.__wbg_depthRange_8309e031492fd023 = function(arg0, arg1, arg2) {
        getObject(arg0).depthRange(arg1, arg2);
    };
    imports.wbg.__wbg_disable_f68719f70ddfb5b8 = function(arg0, arg1) {
        getObject(arg0).disable(arg1 >>> 0);
    };
    imports.wbg.__wbg_drawElements_a3781a76e2ccb054 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).drawElements(arg1 >>> 0, arg2, arg3 >>> 0, arg4);
    };
    imports.wbg.__wbg_enable_6dab9d5278ba15e2 = function(arg0, arg1) {
        getObject(arg0).enable(arg1 >>> 0);
    };
    imports.wbg.__wbg_enableVertexAttribArray_c2bfb733e87824c8 = function(arg0, arg1) {
        getObject(arg0).enableVertexAttribArray(arg1 >>> 0);
    };
    imports.wbg.__wbg_flush_91fdb0cadb168db7 = function(arg0) {
        getObject(arg0).flush();
    };
    imports.wbg.__wbg_framebufferRenderbuffer_564b54a213de82b7 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).framebufferRenderbuffer(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, getObject(arg4));
    };
    imports.wbg.__wbg_framebufferTexture2D_e7783c0015d1135a = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        getObject(arg0).framebufferTexture2D(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, getObject(arg4), arg5);
    };
    imports.wbg.__wbg_frontFace_271693c85383f2e8 = function(arg0, arg1) {
        getObject(arg0).frontFace(arg1 >>> 0);
    };
    imports.wbg.__wbg_getError_b3d74583648031ab = function(arg0) {
        const ret = getObject(arg0).getError();
        return ret;
    };
    imports.wbg.__wbg_getExtension_25430e0ed157fcf8 = function() { return handleError(function (arg0, arg1, arg2) {
        const ret = getObject(arg0).getExtension(getStringFromWasm0(arg1, arg2));
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_getParameter_b282105ca8420119 = function() { return handleError(function (arg0, arg1) {
        const ret = getObject(arg0).getParameter(arg1 >>> 0);
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_getProgramInfoLog_110f43b4125782e9 = function(arg0, arg1, arg2) {
        const ret = getObject(arg1).getProgramInfoLog(getObject(arg2));
        var ptr1 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len1 = WASM_VECTOR_LEN;
        getInt32Memory0()[arg0 / 4 + 1] = len1;
        getInt32Memory0()[arg0 / 4 + 0] = ptr1;
    };
    imports.wbg.__wbg_getProgramParameter_22b3f1c8d913cd2c = function(arg0, arg1, arg2) {
        const ret = getObject(arg0).getProgramParameter(getObject(arg1), arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_getShaderInfoLog_562b1447e7c24866 = function(arg0, arg1, arg2) {
        const ret = getObject(arg1).getShaderInfoLog(getObject(arg2));
        var ptr1 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len1 = WASM_VECTOR_LEN;
        getInt32Memory0()[arg0 / 4 + 1] = len1;
        getInt32Memory0()[arg0 / 4 + 0] = ptr1;
    };
    imports.wbg.__wbg_getShaderParameter_58d3b34afa9db13b = function(arg0, arg1, arg2) {
        const ret = getObject(arg0).getShaderParameter(getObject(arg1), arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_getSupportedExtensions_1a007030d26efba5 = function(arg0) {
        const ret = getObject(arg0).getSupportedExtensions();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_getUniformLocation_7b435a76db4f3128 = function(arg0, arg1, arg2, arg3) {
        const ret = getObject(arg0).getUniformLocation(getObject(arg1), getStringFromWasm0(arg2, arg3));
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_linkProgram_e170ffe0b8242136 = function(arg0, arg1) {
        getObject(arg0).linkProgram(getObject(arg1));
    };
    imports.wbg.__wbg_pixelStorei_6be3fc7114b690b8 = function(arg0, arg1, arg2) {
        getObject(arg0).pixelStorei(arg1 >>> 0, arg2);
    };
    imports.wbg.__wbg_polygonOffset_0f2730043ba169b2 = function(arg0, arg1, arg2) {
        getObject(arg0).polygonOffset(arg1, arg2);
    };
    imports.wbg.__wbg_renderbufferStorage_5a63960c0bb41916 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).renderbufferStorage(arg1 >>> 0, arg2 >>> 0, arg3, arg4);
    };
    imports.wbg.__wbg_scissor_27cb154cc9864444 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).scissor(arg1, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_shaderSource_e12efd3a2bf3413d = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).shaderSource(getObject(arg1), getStringFromWasm0(arg2, arg3));
    };
    imports.wbg.__wbg_stencilFuncSeparate_e6b4c784aa470ba1 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).stencilFuncSeparate(arg1 >>> 0, arg2 >>> 0, arg3, arg4 >>> 0);
    };
    imports.wbg.__wbg_stencilMaskSeparate_6a90a6801f96c33e = function(arg0, arg1, arg2) {
        getObject(arg0).stencilMaskSeparate(arg1 >>> 0, arg2 >>> 0);
    };
    imports.wbg.__wbg_stencilOpSeparate_f98bb31212170061 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).stencilOpSeparate(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, arg4 >>> 0);
    };
    imports.wbg.__wbg_texParameteri_f5c0d085b77931dd = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).texParameteri(arg1 >>> 0, arg2 >>> 0, arg3);
    };
    imports.wbg.__wbg_uniform1i_1fd90743f7b78faa = function(arg0, arg1, arg2) {
        getObject(arg0).uniform1i(getObject(arg1), arg2);
    };
    imports.wbg.__wbg_useProgram_53de6b084c4780ce = function(arg0, arg1) {
        getObject(arg0).useProgram(getObject(arg1));
    };
    imports.wbg.__wbg_vertexAttribPointer_3133080603a92d4c = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6) {
        getObject(arg0).vertexAttribPointer(arg1 >>> 0, arg2, arg3 >>> 0, arg4 !== 0, arg5, arg6);
    };
    imports.wbg.__wbg_viewport_afd5166081d009b2 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).viewport(arg1, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_bufferData_9566a2faddca5792 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).bufferData(arg1 >>> 0, arg2, arg3 >>> 0);
    };
    imports.wbg.__wbg_bufferSubData_7d216abec8307331 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).bufferSubData(arg1 >>> 0, arg2, getObject(arg3));
    };
    imports.wbg.__wbg_compressedTexSubImage2D_5666e0146e152b7d = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8) {
        getObject(arg0).compressedTexSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, getObject(arg8));
    };
    imports.wbg.__wbg_texSubImage2D_d23a3ec1fa60bdaf = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) {
        getObject(arg0).texSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8 >>> 0, getObject(arg9));
    }, arguments) };
    imports.wbg.__wbg_activeTexture_3748123e1becf07d = function(arg0, arg1) {
        getObject(arg0).activeTexture(arg1 >>> 0);
    };
    imports.wbg.__wbg_attachShader_cfbbdefc08a0422f = function(arg0, arg1, arg2) {
        getObject(arg0).attachShader(getObject(arg1), getObject(arg2));
    };
    imports.wbg.__wbg_bindBuffer_3f166cc2f502fc09 = function(arg0, arg1, arg2) {
        getObject(arg0).bindBuffer(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_bindFramebuffer_28e8c0c3f76447af = function(arg0, arg1, arg2) {
        getObject(arg0).bindFramebuffer(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_bindRenderbuffer_2fe89083883b96e7 = function(arg0, arg1, arg2) {
        getObject(arg0).bindRenderbuffer(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_bindTexture_be92cdd3f162b4f9 = function(arg0, arg1, arg2) {
        getObject(arg0).bindTexture(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_blendEquationSeparate_33f23a57d77e8079 = function(arg0, arg1, arg2) {
        getObject(arg0).blendEquationSeparate(arg1 >>> 0, arg2 >>> 0);
    };
    imports.wbg.__wbg_blendFuncSeparate_52fdb0f1fbf57928 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).blendFuncSeparate(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, arg4 >>> 0);
    };
    imports.wbg.__wbg_checkFramebufferStatus_5526aa8c77ac91a8 = function(arg0, arg1) {
        const ret = getObject(arg0).checkFramebufferStatus(arg1 >>> 0);
        return ret;
    };
    imports.wbg.__wbg_clear_af4278a00382d3ce = function(arg0, arg1) {
        getObject(arg0).clear(arg1 >>> 0);
    };
    imports.wbg.__wbg_clearColor_9a45e2200c61a8f2 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).clearColor(arg1, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_clearDepth_a40e7b975ebc5c14 = function(arg0, arg1) {
        getObject(arg0).clearDepth(arg1);
    };
    imports.wbg.__wbg_clearStencil_62277af75c0a3558 = function(arg0, arg1) {
        getObject(arg0).clearStencil(arg1);
    };
    imports.wbg.__wbg_colorMask_57603facaeb6e2e3 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).colorMask(arg1 !== 0, arg2 !== 0, arg3 !== 0, arg4 !== 0);
    };
    imports.wbg.__wbg_compileShader_be824cfad43331b8 = function(arg0, arg1) {
        getObject(arg0).compileShader(getObject(arg1));
    };
    imports.wbg.__wbg_createBuffer_90bf79c414ad4956 = function(arg0) {
        const ret = getObject(arg0).createBuffer();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createFramebuffer_f8c26154f8992bfa = function(arg0) {
        const ret = getObject(arg0).createFramebuffer();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createProgram_983b87cad6d06768 = function(arg0) {
        const ret = getObject(arg0).createProgram();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createRenderbuffer_e2d77844fbdcc842 = function(arg0) {
        const ret = getObject(arg0).createRenderbuffer();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createShader_896229165c5a11d4 = function(arg0, arg1) {
        const ret = getObject(arg0).createShader(arg1 >>> 0);
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createTexture_b77eefdce0bb2c55 = function(arg0) {
        const ret = getObject(arg0).createTexture();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_cullFace_a65f5d17b1ff5686 = function(arg0, arg1) {
        getObject(arg0).cullFace(arg1 >>> 0);
    };
    imports.wbg.__wbg_deleteBuffer_d70596808095dac2 = function(arg0, arg1) {
        getObject(arg0).deleteBuffer(getObject(arg1));
    };
    imports.wbg.__wbg_deleteFramebuffer_23c9c7c8176aa9b8 = function(arg0, arg1) {
        getObject(arg0).deleteFramebuffer(getObject(arg1));
    };
    imports.wbg.__wbg_deleteProgram_8447c337271aa934 = function(arg0, arg1) {
        getObject(arg0).deleteProgram(getObject(arg1));
    };
    imports.wbg.__wbg_deleteRenderbuffer_7bb3c4c79eac08ff = function(arg0, arg1) {
        getObject(arg0).deleteRenderbuffer(getObject(arg1));
    };
    imports.wbg.__wbg_deleteShader_322b059ad560664a = function(arg0, arg1) {
        getObject(arg0).deleteShader(getObject(arg1));
    };
    imports.wbg.__wbg_deleteTexture_bbda7cb554bc12b9 = function(arg0, arg1) {
        getObject(arg0).deleteTexture(getObject(arg1));
    };
    imports.wbg.__wbg_depthFunc_b78eec6735fd7a0a = function(arg0, arg1) {
        getObject(arg0).depthFunc(arg1 >>> 0);
    };
    imports.wbg.__wbg_depthMask_d2c08d83ea550563 = function(arg0, arg1) {
        getObject(arg0).depthMask(arg1 !== 0);
    };
    imports.wbg.__wbg_depthRange_c4d7339e2f6b2e4a = function(arg0, arg1, arg2) {
        getObject(arg0).depthRange(arg1, arg2);
    };
    imports.wbg.__wbg_disable_57e8624c865bd654 = function(arg0, arg1) {
        getObject(arg0).disable(arg1 >>> 0);
    };
    imports.wbg.__wbg_drawElements_5cade7fb4236c93b = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).drawElements(arg1 >>> 0, arg2, arg3 >>> 0, arg4);
    };
    imports.wbg.__wbg_enable_54d01bacc240df3e = function(arg0, arg1) {
        getObject(arg0).enable(arg1 >>> 0);
    };
    imports.wbg.__wbg_enableVertexAttribArray_c971ef03599058ec = function(arg0, arg1) {
        getObject(arg0).enableVertexAttribArray(arg1 >>> 0);
    };
    imports.wbg.__wbg_flush_34aa7db64a149d98 = function(arg0) {
        getObject(arg0).flush();
    };
    imports.wbg.__wbg_framebufferRenderbuffer_27bc520ea685b484 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).framebufferRenderbuffer(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, getObject(arg4));
    };
    imports.wbg.__wbg_framebufferTexture2D_c61bc6c888f33a52 = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        getObject(arg0).framebufferTexture2D(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, getObject(arg4), arg5);
    };
    imports.wbg.__wbg_frontFace_e13136966c974dd8 = function(arg0, arg1) {
        getObject(arg0).frontFace(arg1 >>> 0);
    };
    imports.wbg.__wbg_getError_0a6390188216606e = function(arg0) {
        const ret = getObject(arg0).getError();
        return ret;
    };
    imports.wbg.__wbg_getParameter_798cbb8ff20c7af0 = function() { return handleError(function (arg0, arg1) {
        const ret = getObject(arg0).getParameter(arg1 >>> 0);
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_getProgramInfoLog_3ff10ea818ab6ce4 = function(arg0, arg1, arg2) {
        const ret = getObject(arg1).getProgramInfoLog(getObject(arg2));
        var ptr1 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len1 = WASM_VECTOR_LEN;
        getInt32Memory0()[arg0 / 4 + 1] = len1;
        getInt32Memory0()[arg0 / 4 + 0] = ptr1;
    };
    imports.wbg.__wbg_getProgramParameter_35800b92324ff726 = function(arg0, arg1, arg2) {
        const ret = getObject(arg0).getProgramParameter(getObject(arg1), arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_getShaderInfoLog_3e435d2b50e0ecf0 = function(arg0, arg1, arg2) {
        const ret = getObject(arg1).getShaderInfoLog(getObject(arg2));
        var ptr1 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len1 = WASM_VECTOR_LEN;
        getInt32Memory0()[arg0 / 4 + 1] = len1;
        getInt32Memory0()[arg0 / 4 + 0] = ptr1;
    };
    imports.wbg.__wbg_getShaderParameter_a9315ba73ab18731 = function(arg0, arg1, arg2) {
        const ret = getObject(arg0).getShaderParameter(getObject(arg1), arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_getUniformLocation_f161344f25983444 = function(arg0, arg1, arg2, arg3) {
        const ret = getObject(arg0).getUniformLocation(getObject(arg1), getStringFromWasm0(arg2, arg3));
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_linkProgram_caeab1eb0c0246be = function(arg0, arg1) {
        getObject(arg0).linkProgram(getObject(arg1));
    };
    imports.wbg.__wbg_pixelStorei_ac98844c2d6d1937 = function(arg0, arg1, arg2) {
        getObject(arg0).pixelStorei(arg1 >>> 0, arg2);
    };
    imports.wbg.__wbg_polygonOffset_442517f9de53e3de = function(arg0, arg1, arg2) {
        getObject(arg0).polygonOffset(arg1, arg2);
    };
    imports.wbg.__wbg_renderbufferStorage_982fcb5577f764ca = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).renderbufferStorage(arg1 >>> 0, arg2 >>> 0, arg3, arg4);
    };
    imports.wbg.__wbg_scissor_7206bcd2a5540aa3 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).scissor(arg1, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_shaderSource_04af20ecb1962b3b = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).shaderSource(getObject(arg1), getStringFromWasm0(arg2, arg3));
    };
    imports.wbg.__wbg_stencilFuncSeparate_89563ca030dab790 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).stencilFuncSeparate(arg1 >>> 0, arg2 >>> 0, arg3, arg4 >>> 0);
    };
    imports.wbg.__wbg_stencilMaskSeparate_1303b1855315b85a = function(arg0, arg1, arg2) {
        getObject(arg0).stencilMaskSeparate(arg1 >>> 0, arg2 >>> 0);
    };
    imports.wbg.__wbg_stencilOpSeparate_fef362ec0f1539d1 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).stencilOpSeparate(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, arg4 >>> 0);
    };
    imports.wbg.__wbg_texParameteri_dd08984388e62491 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).texParameteri(arg1 >>> 0, arg2 >>> 0, arg3);
    };
    imports.wbg.__wbg_uniform1i_5a5f1f9d5828e6c6 = function(arg0, arg1, arg2) {
        getObject(arg0).uniform1i(getObject(arg1), arg2);
    };
    imports.wbg.__wbg_useProgram_229c8fa8394b4c26 = function(arg0, arg1) {
        getObject(arg0).useProgram(getObject(arg1));
    };
    imports.wbg.__wbg_vertexAttribPointer_e9c4ff85658b9ad2 = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6) {
        getObject(arg0).vertexAttribPointer(arg1 >>> 0, arg2, arg3 >>> 0, arg4 !== 0, arg5, arg6);
    };
    imports.wbg.__wbg_viewport_0ca27d1d6ac8424c = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).viewport(arg1, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_document_5257b70811e953c0 = function(arg0) {
        const ret = getObject(arg0).document;
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_navigator_910cca0226b70083 = function(arg0) {
        const ret = getObject(arg0).navigator;
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_devicePixelRatio_93bac98af723c7ba = function(arg0) {
        const ret = getObject(arg0).devicePixelRatio;
        return ret;
    };
    imports.wbg.__wbg_performance_698febdfb8f1f470 = function(arg0) {
        const ret = getObject(arg0).performance;
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_get_7f8cd08c0360178c = function(arg0, arg1, arg2) {
        const ret = getObject(arg0)[getStringFromWasm0(arg1, arg2)];
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_cancelAnimationFrame_2635bb6bdb94eb3f = function() { return handleError(function (arg0, arg1) {
        getObject(arg0).cancelAnimationFrame(arg1);
    }, arguments) };
    imports.wbg.__wbg_requestAnimationFrame_1820a8e6b645ec5a = function() { return handleError(function (arg0, arg1) {
        const ret = getObject(arg0).requestAnimationFrame(getObject(arg1));
        return ret;
    }, arguments) };
    imports.wbg.__wbg_clearTimeout_cf250b4eed087f7b = function(arg0, arg1) {
        getObject(arg0).clearTimeout(arg1);
    };
    imports.wbg.__wbg_setTimeout_bd20251bb242e262 = function() { return handleError(function (arg0, arg1, arg2) {
        const ret = getObject(arg0).setTimeout(getObject(arg1), arg2);
        return ret;
    }, arguments) };
    imports.wbg.__wbg_debug_81bf1b6b83cc1a06 = function(arg0) {
        console.debug(getObject(arg0));
    };
    imports.wbg.__wbg_error_1f4e3e298a7c97f6 = function(arg0) {
        console.error(getObject(arg0));
    };
    imports.wbg.__wbg_error_0f3a2d4325dee96a = function(arg0, arg1) {
        console.error(getObject(arg0), getObject(arg1));
    };
    imports.wbg.__wbg_info_24b7c0f9d7eb6623 = function(arg0) {
        console.info(getObject(arg0));
    };
    imports.wbg.__wbg_log_9dfb3879776dd797 = function(arg0) {
        console.log(getObject(arg0));
    };
    imports.wbg.__wbg_warn_0e0204547af47087 = function(arg0) {
        console.warn(getObject(arg0));
    };
    imports.wbg.__wbg_getRandomValues_260cc23a41afad9a = function() { return handleError(function (arg0, arg1) {
        getObject(arg0).getRandomValues(getObject(arg1));
    }, arguments) };
    imports.wbg.__wbg_randomFillSync_290977693942bf03 = function() { return handleError(function (arg0, arg1) {
        getObject(arg0).randomFillSync(takeObject(arg1));
    }, arguments) };
    imports.wbg.__wbg_crypto_566d7465cdbb6b7a = function(arg0) {
        const ret = getObject(arg0).crypto;
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_process_dc09a8c7d59982f6 = function(arg0) {
        const ret = getObject(arg0).process;
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_versions_d98c6400c6ca2bd8 = function(arg0) {
        const ret = getObject(arg0).versions;
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_node_caaf83d002149bd5 = function(arg0) {
        const ret = getObject(arg0).node;
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_msCrypto_0b84745e9245cdf6 = function(arg0) {
        const ret = getObject(arg0).msCrypto;
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_require_94a9da52636aacbf = function() { return handleError(function () {
        const ret = module.require;
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbindgen_boolean_get = function(arg0) {
        const v = getObject(arg0);
        const ret = typeof(v) === 'boolean' ? (v ? 1 : 0) : 2;
        return ret;
    };
    imports.wbg.__wbg_free_f9304352f445c78f = function(arg0) {
        const ret = free(takeObject(arg0));
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_cb_drop = function(arg0) {
        const obj = takeObject(arg0).original;
        if (obj.cnt-- == 1) {
            obj.a = 0;
            return true;
        }
        const ret = false;
        return ret;
    };
    imports.wbg.__wbg_computeLayout_8f4799c117d91047 = function(arg0, arg1, arg2, arg3) {
        const ret = computeLayout(takeObject(arg0), arg1 >>> 0, arg2 >>> 0, arg3 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_computeSdfTexOfWasm_ebc2c7895afc431c = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6) {
        var v0 = getArrayU8FromWasm0(arg1, arg2).slice();
        wasm.__wbindgen_free(arg1, arg2 * 1, 1);
        const ret = computeSdfTexOfWasm(takeObject(arg0), v0, arg3 >>> 0, arg4 >>> 0, arg5 !== 0, arg6 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_createFace_9d806161e5490e6b = function(arg0, arg1) {
        const ret = createFace(getArrayU8FromWasm0(arg0, arg1));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_horizontalAdvance_79f79dbb73d134c7 = function(arg0, arg1, arg2) {
        let deferred0_0;
        let deferred0_1;
        try {
            deferred0_0 = arg1;
            deferred0_1 = arg2;
            const ret = horizontalAdvance(takeObject(arg0), getStringFromWasm0(arg1, arg2));
            return ret;
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
        }
    };
    imports.wbg.__wbg_ascender_8a98ddad12f2ebfc = function(arg0) {
        const ret = ascender(takeObject(arg0));
        return ret;
    };
    imports.wbg.__wbg_descender_b6933d20901fbb35 = function(arg0) {
        const ret = descender(takeObject(arg0));
        return ret;
    };
    imports.wbg.__wbg_maxBox_64cf6823a07a9102 = function(arg0) {
        const ret = maxBox(takeObject(arg0));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_toOutline_12bae4713f01eecf = function(arg0, arg1, arg2) {
        let deferred0_0;
        let deferred0_1;
        try {
            deferred0_0 = arg1;
            deferred0_1 = arg2;
            const ret = toOutline(takeObject(arg0), getStringFromWasm0(arg1, arg2));
            return addHeapObject(ret);
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
        }
    };
    imports.wbg.__wbg_glyphIndex_fa9c60eb283874af = function(arg0, arg1, arg2) {
        let deferred0_0;
        let deferred0_1;
        try {
            deferred0_0 = arg1;
            deferred0_1 = arg2;
            const ret = glyphIndex(takeObject(arg0), getStringFromWasm0(arg1, arg2));
            return ret;
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
        }
    };
    imports.wbg.__wbg_debugSize_232768636b6067c5 = function(arg0) {
        const ret = debugSize(takeObject(arg0));
        return ret;
    };
    imports.wbg.__wbg_computeSvgLayout_cbe147138c5d7413 = function(arg0, arg1, arg2, arg3, arg4) {
        const ret = computeSvgLayout(getArrayF32FromWasm0(arg0, arg1), arg2 >>> 0, arg3 >>> 0, arg4 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_computeSvgSdfTexOfWasm_cc1629b9337c18b8 = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6) {
        var v0 = getArrayU8FromWasm0(arg0, arg1).slice();
        wasm.__wbindgen_free(arg0, arg1 * 1, 1);
        const ret = computeSvgSdfTexOfWasm(v0, arg2 >>> 0, arg3 >>> 0, arg4 !== 0, arg5 >>> 0, arg6);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_computeSvgSdfTexOfWasmSync_fee5a2fd684e9333 = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6) {
        var v0 = getArrayU8FromWasm0(arg0, arg1).slice();
        wasm.__wbindgen_free(arg0, arg1 * 1, 1);
        const ret = computeSvgSdfTexOfWasmSync(v0, arg2 >>> 0, arg3 >>> 0, arg4 !== 0, arg5 >>> 0, arg6);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_computeSdfCellOfWasm_b5ebc66c52798edd = function(arg0, arg1, arg2) {
        var v0 = getArrayU8FromWasm0(arg0, arg1).slice();
        wasm.__wbindgen_free(arg0, arg1 * 1, 1);
        const ret = computeSdfCellOfWasm(v0, arg2);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_computePositionsAndUv_c785f9fd6ad721c1 = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6) {
        var v0 = getArrayU8FromWasm0(arg0, arg1).slice();
        wasm.__wbindgen_free(arg0, arg1 * 1, 1);
        const ret = computePositionsAndUv(v0, getArrayF32FromWasm0(arg2, arg3), getArrayF32FromWasm0(arg4, arg5), arg6);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_getSvgInfo_78cee716148b4fe8 = function(arg0) {
        const ret = getSvgInfo(takeObject(arg0));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_createCircle_7f56fae6fa6cb77b = function(arg0, arg1, arg2) {
        const ret = createCircle(arg0, arg1, arg2);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_createSegment_9bf69abef83a6117 = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        let v0;
        if (arg4 !== 0) {
            v0 = getArrayF32FromWasm0(arg4, arg5).slice();
            wasm.__wbindgen_free(arg4, arg5 * 4, 4);
        }
        const ret = createSegment(arg0, arg1, arg2, arg3, v0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_createPolygon_2ff5b659c208a850 = function(arg0, arg1) {
        var v0 = getArrayF32FromWasm0(arg0, arg1).slice();
        wasm.__wbindgen_free(arg0, arg1 * 4, 4);
        const ret = createPolygon(v0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_createPolyline_625382e2511c040a = function(arg0, arg1) {
        var v0 = getArrayF32FromWasm0(arg0, arg1).slice();
        wasm.__wbindgen_free(arg0, arg1 * 4, 4);
        const ret = createPolyline(v0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_initLocalStore_11a2f4aef6b4ed7e = function() {
        const ret = initLocalStore();
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_loadFontSdf_e988d617073e011e = function() {
        const ret = loadFontSdf();
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_is_null = function(arg0) {
        const ret = getObject(arg0) === null;
        return ret;
    };
    imports.wbg.__wbg_get_e61df70a2b570fd0 = function() { return handleError(function (arg0, arg1) {
        let deferred0_0;
        let deferred0_1;
        try {
            deferred0_0 = arg0;
            deferred0_1 = arg1;
            const ret = get(getStringFromWasm0(arg0, arg1));
            return addHeapObject(ret);
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
        }
    }, arguments) };
    imports.wbg.__wbg_computeNearArcs_fe8df91ba5e9f5b0 = function(arg0, arg1) {
        const ret = computeNearArcs(takeObject(arg0), arg1);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_write_cd06e3966db26c4a = function(arg0, arg1, arg2, arg3) {
        let deferred0_0;
        let deferred0_1;
        try {
            deferred0_0 = arg0;
            deferred0_1 = arg1;
            var v1 = getArrayU8FromWasm0(arg2, arg3).slice();
            wasm.__wbindgen_free(arg2, arg3 * 1, 1);
            const ret = write(getStringFromWasm0(arg0, arg1), v1);
            return addHeapObject(ret);
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
        }
    };
    imports.wbg.__wbg_setAtom_c744aad73bedd152 = function(arg0, arg1, arg2) {
        let deferred0_0;
        let deferred0_1;
        try {
            deferred0_0 = arg1;
            deferred0_1 = arg2;
            setAtom(arg0, getStringFromWasm0(arg1, arg2));
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
        }
    };
    imports.wbg.__wbg_createRect_42b96f95dca36470 = function(arg0, arg1, arg2, arg3) {
        const ret = createRect(arg0, arg1, arg2, arg3);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_createEllipse_0206a1ef6ed6c6cf = function(arg0, arg1, arg2, arg3) {
        const ret = createEllipse(arg0, arg1, arg2, arg3);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_createPath_fc18ab75960507f5 = function(arg0, arg1, arg2, arg3) {
        var v0 = getArrayU8FromWasm0(arg0, arg1).slice();
        wasm.__wbindgen_free(arg0, arg1 * 1, 1);
        var v1 = getArrayF32FromWasm0(arg2, arg3).slice();
        wasm.__wbindgen_free(arg2, arg3 * 4, 4);
        const ret = createPath(v0, v1);
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_copy_to_typed_array = function(arg0, arg1, arg2) {
        new Uint8Array(getObject(arg2).buffer, getObject(arg2).byteOffset, getObject(arg2).byteLength).set(getArrayU8FromWasm0(arg0, arg1));
    };
    imports.wbg.__wbg_loadKtx_d9ab2f1303b7feac = function() { return handleError(function (arg0) {
        const ret = loadKtx(arg0);
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_loadImage_1a015ecd408d9de5 = function() { return handleError(function (arg0) {
        const ret = loadImage(arg0);
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_loadFile_0b0da51c6bf34f33 = function() { return handleError(function (arg0) {
        const ret = loadFile(arg0);
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_loadImageAsCanvas_0fb71b6151417cc2 = function() { return handleError(function (arg0) {
        const ret = loadImageAsCanvas(arg0);
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_mark_40e050a77cc39fea = function(arg0, arg1) {
        performance.mark(getStringFromWasm0(arg0, arg1));
    };
    imports.wbg.__wbg_log_c9486ca5d8e2cbe8 = function(arg0, arg1) {
        let deferred0_0;
        let deferred0_1;
        try {
            deferred0_0 = arg0;
            deferred0_1 = arg1;
            console.log(getStringFromWasm0(arg0, arg1));
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
        }
    };
    imports.wbg.__wbg_log_aba5996d9bde071f = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7) {
        let deferred0_0;
        let deferred0_1;
        try {
            deferred0_0 = arg0;
            deferred0_1 = arg1;
            console.log(getStringFromWasm0(arg0, arg1), getStringFromWasm0(arg2, arg3), getStringFromWasm0(arg4, arg5), getStringFromWasm0(arg6, arg7));
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
        }
    };
    imports.wbg.__wbg_measure_aa7a73f17813f708 = function() { return handleError(function (arg0, arg1, arg2, arg3) {
        let deferred0_0;
        let deferred0_1;
        let deferred1_0;
        let deferred1_1;
        try {
            deferred0_0 = arg0;
            deferred0_1 = arg1;
            deferred1_0 = arg2;
            deferred1_1 = arg3;
            performance.measure(getStringFromWasm0(arg0, arg1), getStringFromWasm0(arg2, arg3));
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
            wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
        }
    }, arguments) };
    imports.wbg.__wbg_new_abda76e883ba8a5f = function() {
        const ret = new Error();
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_stack_658279fe44541cf6 = function(arg0, arg1) {
        const ret = getObject(arg1).stack;
        const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        getInt32Memory0()[arg0 / 4 + 1] = len1;
        getInt32Memory0()[arg0 / 4 + 0] = ptr1;
    };
    imports.wbg.__wbg_error_f851667af71bcfc6 = function(arg0, arg1) {
        let deferred0_0;
        let deferred0_1;
        try {
            deferred0_0 = arg0;
            deferred0_1 = arg1;
            console.error(getStringFromWasm0(arg0, arg1));
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
        }
    };
    imports.wbg.__wbindgen_bigint_from_u64 = function(arg0) {
        const ret = BigInt.asUintN(64, arg0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_reshandle_new = function(arg0) {
        const ret = ResHandle.__wrap(arg0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_error_new = function(arg0, arg1) {
        const ret = new Error(getStringFromWasm0(arg0, arg1));
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_bigint_from_i64 = function(arg0) {
        const ret = arg0;
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_bigint_from_i128 = function(arg0, arg1) {
        const ret = arg0 << BigInt(64) | BigInt.asUintN(64, arg1);
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_bigint_from_u128 = function(arg0, arg1) {
        const ret = BigInt.asUintN(64, arg0) << BigInt(64) | BigInt.asUintN(64, arg1);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_set_841ac57cff3d672b = function(arg0, arg1, arg2) {
        getObject(arg0)[takeObject(arg1)] = takeObject(arg2);
    };
    imports.wbg.__wbg_bonbuffer_fb7dff181fefd7cb = function(arg0, arg1) {
        bon_buffer(getArrayU8FromWasm0(arg0, arg1));
    };
    imports.wbg.__wbg_roundresult_61928002a27bb0f9 = function(arg0, arg1) {
        round_result(getArrayI32FromWasm0(arg0, arg1));
    };
    imports.wbg.__wbg_pathresult_90e64783aeee82bd = function(arg0, arg1) {
        path_result(getArrayI32FromWasm0(arg0, arg1));
    };
    imports.wbg.__wbindgen_closure_wrapper5100 = function(arg0, arg1, arg2) {
        const ret = makeMutClosure(arg0, arg1, 1141, __wbg_adapter_46);
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_closure_wrapper16249 = function(arg0, arg1, arg2) {
        const ret = makeMutClosure(arg0, arg1, 6107, __wbg_adapter_49);
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_closure_wrapper16251 = function(arg0, arg1, arg2) {
        const ret = makeMutClosure(arg0, arg1, 6107, __wbg_adapter_52);
        return addHeapObject(ret);
    };
    imports['./snippets/pi_hal-c8dfac38fe774d41/js/utils.js'] = __wbg_star0;

    return imports;
}

function __wbg_init_memory(imports, maybe_memory) {

}

function __wbg_finalize_init(instance, module) {
    wasm = instance.exports;
    __wbg_init.__wbindgen_wasm_module = module;
    cachedFloat32Memory0 = null;
    cachedFloat64Memory0 = null;
    cachedInt32Memory0 = null;
    cachedUint16Memory0 = null;
    cachedUint32Memory0 = null;
    cachedUint8Memory0 = null;


    return wasm;
}

function initSync(module) {
    if (wasm !== undefined) return wasm;

    const imports = __wbg_get_imports();

    __wbg_init_memory(imports);

    if (!(module instanceof WebAssembly.Module)) {
        module = new WebAssembly.Module(module);
    }

    const instance = new WebAssembly.Instance(module, imports);

    return __wbg_finalize_init(instance, module);
}

async function __wbg_init(input) {
    if (wasm !== undefined) return wasm;

    if (typeof input === 'undefined') {
        input = new URL('wasm_engine_bg.wasm', "");
    }
    const imports = __wbg_get_imports();

    if (typeof input === 'string' || (typeof Request === 'function' && input instanceof Request) || (typeof URL === 'function' && input instanceof URL)) {
        input = fetch(input);
    }

    __wbg_init_memory(imports);

    const r = await __wbg_load(await input, imports);

    let ret = __wbg_finalize_init(r.instance, r.module);
	
	if(module.postRun) {
		module.postRun();
	}

    return ret;
}

Promise.resolve().then(() => {
	window["__wasm"] = __wbg_init(module.wasmModule);
})
